/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * API Export result.
 *
 */
class ApiExportResult {
  /**
   * Create a ApiExportResult.
   * @property {string} [id] ResourceId of the API which was exported.
   * @property {string} [exportResultFormat] Format in which the Api Details
   * are exported to the Storage Blob with Sas Key valid for 5 minutes.
   * Possible values include: 'Swagger', 'Wsdl', 'Wadl', 'OpenApi'
   * @property {object} [value] The object defining the schema of the exported
   * Api Detail
   * @property {string} [value.link] Link to the Storage Blob containing the
   * result of the export operation. The Blob Uri is only valid for 5 minutes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiExportResult
   *
   * @returns {object} metadata of ApiExportResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiExportResult',
      type: {
        name: 'Composite',
        className: 'ApiExportResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          exportResultFormat: {
            required: false,
            serializedName: 'format',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Composite',
              className: 'ApiExportResultValue'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiExportResult;
