/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Api Version Set Contract details.
 *
 * @extends models['Resource']
 */
class ApiVersionSetContract extends models['Resource'] {
  /**
   * Create a ApiVersionSetContract.
   * @property {string} [description] Description of API Version Set.
   * @property {string} [versionQueryName] Name of query parameter that
   * indicates the API Version if versioningScheme is set to `query`.
   * @property {string} [versionHeaderName] Name of HTTP header parameter that
   * indicates the API Version if versioningScheme is set to `header`.
   * @property {string} displayName Name of API Version Set
   * @property {string} versioningScheme An value that determines where the API
   * Version identifer will be located in a HTTP request. Possible values
   * include: 'Segment', 'Query', 'Header'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApiVersionSetContract
   *
   * @returns {object} metadata of ApiVersionSetContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiVersionSetContract',
      type: {
        name: 'Composite',
        className: 'ApiVersionSetContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          versionQueryName: {
            required: false,
            serializedName: 'properties.versionQueryName',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          versionHeaderName: {
            required: false,
            serializedName: 'properties.versionHeaderName',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: true,
            serializedName: 'properties.displayName',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          versioningScheme: {
            required: true,
            serializedName: 'properties.versioningScheme',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiVersionSetContract;
