/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Certificate configuration which consist of non-trusted intermediates and
 * root certificates.
 *
 */
class CertificateConfiguration {
  /**
   * Create a CertificateConfiguration.
   * @property {string} [encodedCertificate] Base64 Encoded certificate.
   * @property {string} [certificatePassword] Certificate Password.
   * @property {string} storeName The
   * System.Security.Cryptography.x509certificates.StoreName certificate store
   * location. Only Root and CertificateAuthority are valid locations. Possible
   * values include: 'CertificateAuthority', 'Root'
   * @property {object} [certificate] Certificate information.
   * @property {date} [certificate.expiry] Expiration date of the certificate.
   * The date conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
   * specified by the ISO 8601 standard.
   * @property {string} [certificate.thumbprint] Thumbprint of the certificate.
   * @property {string} [certificate.subject] Subject of the certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateConfiguration
   *
   * @returns {object} metadata of CertificateConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateConfiguration',
      type: {
        name: 'Composite',
        className: 'CertificateConfiguration',
        modelProperties: {
          encodedCertificate: {
            required: false,
            serializedName: 'encodedCertificate',
            type: {
              name: 'String'
            }
          },
          certificatePassword: {
            required: false,
            serializedName: 'certificatePassword',
            type: {
              name: 'String'
            }
          },
          storeName: {
            required: true,
            serializedName: 'storeName',
            type: {
              name: 'String'
            }
          },
          certificate: {
            required: false,
            serializedName: 'certificate',
            type: {
              name: 'Composite',
              className: 'CertificateInformation'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateConfiguration;
