/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Content type contract details.
 *
 * @extends models['Resource']
 */
class ContentItemContract extends models['Resource'] {
  /**
   * Create a ContentItemContract.
   * @property {object} [properties] Properties of the content item.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContentItemContract
   *
   * @returns {object} metadata of ContentItemContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentItemContract',
      type: {
        name: 'Composite',
        className: 'ContentItemContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ContentItemContract;
