/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Content type contract details.
 *
 * @extends models['Resource']
 */
class ContentTypeContract extends models['Resource'] {
  /**
   * Create a ContentTypeContract.
   * @property {string} [contentTypeContractId] Content type identifier
   * @property {string} [contentTypeContractName] Content type name. Must be 1
   * to 250 characters long.
   * @property {string} [description] Content type description.
   * @property {object} [schema] Content type schema.
   * @property {string} [version] Content type version.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContentTypeContract
   *
   * @returns {object} metadata of ContentTypeContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentTypeContract',
      type: {
        name: 'Composite',
        className: 'ContentTypeContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          contentTypeContractId: {
            required: false,
            serializedName: 'properties.id',
            type: {
              name: 'String'
            }
          },
          contentTypeContractName: {
            required: false,
            serializedName: 'properties.name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          schema: {
            required: false,
            serializedName: 'properties.schema',
            type: {
              name: 'Object'
            }
          },
          version: {
            required: false,
            serializedName: 'properties.version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContentTypeContract;
