/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ErrorFieldContract = require('./errorFieldContract');
exports.ErrorResponseBody = require('./errorResponseBody');
exports.ErrorResponse = require('./errorResponse');
exports.RegionContract = require('./regionContract');
exports.Resource = require('./resource');
exports.ApiExportResultValue = require('./apiExportResultValue');
exports.ApiExportResult = require('./apiExportResult');
exports.ProductEntityBaseParameters = require('./productEntityBaseParameters');
exports.ProductTagResourceContractProperties = require('./productTagResourceContractProperties');
exports.OperationTagResourceContractProperties = require('./operationTagResourceContractProperties');
exports.SubscriptionKeyParameterNamesContract = require('./subscriptionKeyParameterNamesContract');
exports.OpenIdAuthenticationSettingsContract = require('./openIdAuthenticationSettingsContract');
exports.OAuth2AuthenticationSettingsContract = require('./oAuth2AuthenticationSettingsContract');
exports.AuthenticationSettingsContract = require('./authenticationSettingsContract');
exports.ApiVersionSetContractDetails = require('./apiVersionSetContractDetails');
exports.ApiCreateOrUpdatePropertiesWsdlSelector = require('./apiCreateOrUpdatePropertiesWsdlSelector');
exports.ApiEntityBaseContract = require('./apiEntityBaseContract');
exports.ApiContractProperties = require('./apiContractProperties');
exports.ApiTagResourceContractProperties = require('./apiTagResourceContractProperties');
exports.TagTagResourceContractProperties = require('./tagTagResourceContractProperties');
exports.TagResourceContract = require('./tagResourceContract');
exports.TagContract = require('./tagContract');
exports.TagDescriptionContract = require('./tagDescriptionContract');
exports.TagDescriptionCreateParameters = require('./tagDescriptionCreateParameters');
exports.IssueAttachmentContract = require('./issueAttachmentContract');
exports.IssueCommentContract = require('./issueCommentContract');
exports.IssueContractBaseProperties = require('./issueContractBaseProperties');
exports.IssueUpdateContract = require('./issueUpdateContract');
exports.IssueContract = require('./issueContract');
exports.BodyDiagnosticSettings = require('./bodyDiagnosticSettings');
exports.HttpMessageDiagnostic = require('./httpMessageDiagnostic');
exports.PipelineDiagnosticSettings = require('./pipelineDiagnosticSettings');
exports.SamplingSettings = require('./samplingSettings');
exports.DiagnosticContract = require('./diagnosticContract');
exports.SchemaContract = require('./schemaContract');
exports.PolicyContract = require('./policyContract');
exports.PolicyCollection = require('./policyCollection');
exports.ProductContract = require('./productContract');
exports.ParameterContract = require('./parameterContract');
exports.RepresentationContract = require('./representationContract');
exports.ResponseContract = require('./responseContract');
exports.RequestContract = require('./requestContract');
exports.OperationEntityBaseContract = require('./operationEntityBaseContract');
exports.OperationUpdateContract = require('./operationUpdateContract');
exports.OperationContract = require('./operationContract');
exports.ApiReleaseContract = require('./apiReleaseContract');
exports.ApiRevisionContract = require('./apiRevisionContract');
exports.ApiUpdateContract = require('./apiUpdateContract');
exports.ApiContract = require('./apiContract');
exports.ApiCreateOrUpdateParameter = require('./apiCreateOrUpdateParameter');
exports.ApiVersionSetEntityBase = require('./apiVersionSetEntityBase');
exports.ApiVersionSetUpdateParameters = require('./apiVersionSetUpdateParameters');
exports.ApiVersionSetContract = require('./apiVersionSetContract');
exports.ClientSecretContract = require('./clientSecretContract');
exports.TokenBodyParameterContract = require('./tokenBodyParameterContract');
exports.AuthorizationServerContractBaseProperties = require('./authorizationServerContractBaseProperties');
exports.AuthorizationServerUpdateContract = require('./authorizationServerUpdateContract');
exports.AuthorizationServerContract = require('./authorizationServerContract');
exports.BackendReconnectContract = require('./backendReconnectContract');
exports.BackendTlsProperties = require('./backendTlsProperties');
exports.BackendProxyContract = require('./backendProxyContract');
exports.BackendAuthorizationHeaderCredentials = require('./backendAuthorizationHeaderCredentials');
exports.BackendCredentialsContract = require('./backendCredentialsContract');
exports.X509CertificateName = require('./x509CertificateName');
exports.BackendServiceFabricClusterProperties = require('./backendServiceFabricClusterProperties');
exports.BackendProperties = require('./backendProperties');
exports.BackendBaseParameters = require('./backendBaseParameters');
exports.BackendUpdateParameters = require('./backendUpdateParameters');
exports.BackendContract = require('./backendContract');
exports.CacheUpdateParameters = require('./cacheUpdateParameters');
exports.CacheContract = require('./cacheContract');
exports.CertificateContract = require('./certificateContract');
exports.CertificateCreateOrUpdateParameters = require('./certificateCreateOrUpdateParameters');
exports.ResourceSku = require('./resourceSku');
exports.ResourceSkuCapacity = require('./resourceSkuCapacity');
exports.ResourceSkuResult = require('./resourceSkuResult');
exports.CertificateInformation = require('./certificateInformation');
exports.CertificateConfiguration = require('./certificateConfiguration');
exports.HostnameConfiguration = require('./hostnameConfiguration');
exports.VirtualNetworkConfiguration = require('./virtualNetworkConfiguration');
exports.ApiManagementServiceSkuProperties = require('./apiManagementServiceSkuProperties');
exports.AdditionalLocation = require('./additionalLocation');
exports.ApiManagementServiceBackupRestoreParameters = require('./apiManagementServiceBackupRestoreParameters');
exports.ApiVersionConstraint = require('./apiVersionConstraint');
exports.ApiManagementServiceBaseProperties = require('./apiManagementServiceBaseProperties');
exports.UserIdentityProperties = require('./userIdentityProperties');
exports.ApiManagementServiceIdentity = require('./apiManagementServiceIdentity');
exports.ApimResource = require('./apimResource');
exports.ApiManagementServiceResource = require('./apiManagementServiceResource');
exports.ApiManagementServiceUpdateParameters = require('./apiManagementServiceUpdateParameters');
exports.ApiManagementServiceGetSsoTokenResult = require('./apiManagementServiceGetSsoTokenResult');
exports.ApiManagementServiceCheckNameAvailabilityParameters = require('./apiManagementServiceCheckNameAvailabilityParameters');
exports.ApiManagementServiceNameAvailabilityResult = require('./apiManagementServiceNameAvailabilityResult');
exports.ApiManagementServiceApplyNetworkConfigurationParameters = require('./apiManagementServiceApplyNetworkConfigurationParameters');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.EmailTemplateParametersContractProperties = require('./emailTemplateParametersContractProperties');
exports.EmailTemplateUpdateParameters = require('./emailTemplateUpdateParameters');
exports.EmailTemplateContract = require('./emailTemplateContract');
exports.AssociationContract = require('./associationContract');
exports.GatewayHostnameConfigurationContract = require('./gatewayHostnameConfigurationContract');
exports.GatewayTokenContract = require('./gatewayTokenContract');
exports.GatewayTokenRequestContract = require('./gatewayTokenRequestContract');
exports.GatewayKeyRegenerationRequestContract = require('./gatewayKeyRegenerationRequestContract');
exports.GatewayKeysContract = require('./gatewayKeysContract');
exports.ResourceLocationDataContract = require('./resourceLocationDataContract');
exports.GatewayContract = require('./gatewayContract');
exports.UserIdentityContract = require('./userIdentityContract');
exports.UserEntityBaseParameters = require('./userEntityBaseParameters');
exports.GroupContractProperties = require('./groupContractProperties');
exports.UserContract = require('./userContract');
exports.GroupUpdateParameters = require('./groupUpdateParameters');
exports.GroupContract = require('./groupContract');
exports.GroupCreateParameters = require('./groupCreateParameters');
exports.IdentityProviderBaseParameters = require('./identityProviderBaseParameters');
exports.IdentityProviderUpdateParameters = require('./identityProviderUpdateParameters');
exports.IdentityProviderContract = require('./identityProviderContract');
exports.IdentityProviderCreateContract = require('./identityProviderCreateContract');
exports.LoggerUpdateContract = require('./loggerUpdateContract');
exports.LoggerContract = require('./loggerContract');
exports.PropertyValueContract = require('./propertyValueContract');
exports.NamedValueEntityBaseParameters = require('./namedValueEntityBaseParameters');
exports.NamedValueContract = require('./namedValueContract');
exports.NamedValueUpdateParameters = require('./namedValueUpdateParameters');
exports.NamedValueCreateContract = require('./namedValueCreateContract');
exports.ConnectivityStatusContract = require('./connectivityStatusContract');
exports.NetworkStatusContract = require('./networkStatusContract');
exports.NetworkStatusContractByLocation = require('./networkStatusContractByLocation');
exports.RecipientEmailContract = require('./recipientEmailContract');
exports.RecipientEmailCollection = require('./recipientEmailCollection');
exports.RecipientUserContract = require('./recipientUserContract');
exports.RecipientUserCollection = require('./recipientUserCollection');
exports.RecipientsContractProperties = require('./recipientsContractProperties');
exports.NotificationContract = require('./notificationContract');
exports.OpenidConnectProviderUpdateContract = require('./openidConnectProviderUpdateContract');
exports.OpenidConnectProviderContract = require('./openidConnectProviderContract');
exports.PolicyDescriptionContract = require('./policyDescriptionContract');
exports.PolicyDescriptionCollection = require('./policyDescriptionCollection');
exports.PortalSettingValidationKeyContract = require('./portalSettingValidationKeyContract');
exports.RegistrationDelegationSettingsProperties = require('./registrationDelegationSettingsProperties');
exports.SubscriptionsDelegationSettingsProperties = require('./subscriptionsDelegationSettingsProperties');
exports.PortalDelegationSettings = require('./portalDelegationSettings');
exports.TermsOfServiceProperties = require('./termsOfServiceProperties');
exports.PortalSignupSettings = require('./portalSignupSettings');
exports.PortalSigninSettings = require('./portalSigninSettings');
exports.SubscriptionContract = require('./subscriptionContract');
exports.ProductUpdateParameters = require('./productUpdateParameters');
exports.QuotaCounterValueContractProperties = require('./quotaCounterValueContractProperties');
exports.QuotaCounterValueUpdateContract = require('./quotaCounterValueUpdateContract');
exports.QuotaCounterContract = require('./quotaCounterContract');
exports.QuotaCounterCollection = require('./quotaCounterCollection');
exports.RequestReportRecordContract = require('./requestReportRecordContract');
exports.ReportRecordContract = require('./reportRecordContract');
exports.SubscriptionKeysContract = require('./subscriptionKeysContract');
exports.SubscriptionUpdateParameters = require('./subscriptionUpdateParameters');
exports.SubscriptionCreateParameters = require('./subscriptionCreateParameters');
exports.TagCreateUpdateParameters = require('./tagCreateUpdateParameters');
exports.TenantConfigurationSyncStateContract = require('./tenantConfigurationSyncStateContract');
exports.OperationResultLogItemContract = require('./operationResultLogItemContract');
exports.OperationResultContract = require('./operationResultContract');
exports.DeployConfigurationParameters = require('./deployConfigurationParameters');
exports.SaveConfigurationParameter = require('./saveConfigurationParameter');
exports.AccessInformationContract = require('./accessInformationContract');
exports.AccessInformationUpdateParameters = require('./accessInformationUpdateParameters');
exports.UserTokenResult = require('./userTokenResult');
exports.UserTokenParameters = require('./userTokenParameters');
exports.GenerateSsoUrlResult = require('./generateSsoUrlResult');
exports.UserUpdateParameters = require('./userUpdateParameters');
exports.UserCreateParameters = require('./userCreateParameters');
exports.ApiRevisionInfoContract = require('./apiRevisionInfoContract');
exports.QuotaCounterValueContract = require('./quotaCounterValueContract');
exports.ContentTypeContract = require('./contentTypeContract');
exports.ContentTypeCollection = require('./contentTypeCollection');
exports.ContentItemContract = require('./contentItemContract');
exports.ContentItemCollection = require('./contentItemCollection');
exports.ApiCollection = require('./apiCollection');
exports.TagResourceCollection = require('./tagResourceCollection');
exports.ApiRevisionCollection = require('./apiRevisionCollection');
exports.ApiReleaseCollection = require('./apiReleaseCollection');
exports.OperationCollection = require('./operationCollection');
exports.TagCollection = require('./tagCollection');
exports.ProductCollection = require('./productCollection');
exports.SchemaCollection = require('./schemaCollection');
exports.DiagnosticCollection = require('./diagnosticCollection');
exports.IssueCollection = require('./issueCollection');
exports.IssueCommentCollection = require('./issueCommentCollection');
exports.IssueAttachmentCollection = require('./issueAttachmentCollection');
exports.TagDescriptionCollection = require('./tagDescriptionCollection');
exports.ApiVersionSetCollection = require('./apiVersionSetCollection');
exports.AuthorizationServerCollection = require('./authorizationServerCollection');
exports.BackendCollection = require('./backendCollection');
exports.CacheCollection = require('./cacheCollection');
exports.CertificateCollection = require('./certificateCollection');
exports.OperationListResult = require('./operationListResult');
exports.ResourceSkuResults = require('./resourceSkuResults');
exports.ApiManagementServiceListResult = require('./apiManagementServiceListResult');
exports.EmailTemplateCollection = require('./emailTemplateCollection');
exports.GatewayCollection = require('./gatewayCollection');
exports.GatewayHostnameConfigurationCollection = require('./gatewayHostnameConfigurationCollection');
exports.GroupCollection = require('./groupCollection');
exports.UserCollection = require('./userCollection');
exports.IdentityProviderList = require('./identityProviderList');
exports.LoggerCollection = require('./loggerCollection');
exports.NamedValueCollection = require('./namedValueCollection');
exports.NotificationCollection = require('./notificationCollection');
exports.OpenIdConnectProviderCollection = require('./openIdConnectProviderCollection');
exports.SubscriptionCollection = require('./subscriptionCollection');
exports.RegionListResult = require('./regionListResult');
exports.ReportCollection = require('./reportCollection');
exports.RequestReportCollection = require('./requestReportCollection');
exports.UserIdentityCollection = require('./userIdentityCollection');
