/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Policy description details.
 *
 * @extends models['Resource']
 */
class PolicyDescriptionContract extends models['Resource'] {
  /**
   * Create a PolicyDescriptionContract.
   * @property {string} [description] Policy description.
   * @property {number} [scope] Binary OR value of the Snippet scope.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PolicyDescriptionContract
   *
   * @returns {object} metadata of PolicyDescriptionContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolicyDescriptionContract',
      type: {
        name: 'Composite',
        className: 'PolicyDescriptionContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          scope: {
            required: false,
            readOnly: true,
            serializedName: 'properties.scope',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PolicyDescriptionContract;
