/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Sampling settings for Diagnostic.
 *
 */
class SamplingSettings {
  /**
   * Create a SamplingSettings.
   * @property {string} [samplingType] Sampling type. Possible values include:
   * 'fixed'
   * @property {number} [percentage] Rate of sampling for fixed-rate sampling.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SamplingSettings
   *
   * @returns {object} metadata of SamplingSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SamplingSettings',
      type: {
        name: 'Composite',
        className: 'SamplingSettings',
        modelProperties: {
          samplingType: {
            required: false,
            serializedName: 'samplingType',
            type: {
              name: 'String'
            }
          },
          percentage: {
            required: false,
            serializedName: 'percentage',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SamplingSettings;
