/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A browser timing result
 *
 * @extends models['EventsResultData']
 */
class EventsBrowserTimingResult extends models['EventsResultData'] {
  /**
   * Create a EventsBrowserTimingResult.
   * @member {object} [browserTiming]
   * @member {string} [browserTiming.urlPath] The path of the URL
   * @member {string} [browserTiming.urlHost] The host of the URL
   * @member {string} [browserTiming.name] The name of the page
   * @member {string} [browserTiming.url] The url of the page
   * @member {number} [browserTiming.totalDuration] The total duration of the
   * load
   * @member {string} [browserTiming.performanceBucket] The performance bucket
   * of the load
   * @member {number} [browserTiming.networkDuration] The network duration of
   * the load
   * @member {number} [browserTiming.sendDuration] The send duration of the
   * load
   * @member {number} [browserTiming.receiveDuration] The receive duration of
   * the load
   * @member {number} [browserTiming.processingDuration] The processing
   * duration of the load
   * @member {object} [clientPerformance]
   * @member {string} [clientPerformance.name] The name of the client
   * performance
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventsBrowserTimingResult
   *
   * @returns {object} metadata of EventsBrowserTimingResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'browserTiming',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'EventsResultData',
        className: 'EventsBrowserTimingResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          customDimensions: {
            required: false,
            serializedName: 'customDimensions',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomDimensions'
            }
          },
          customMeasurements: {
            required: false,
            serializedName: 'customMeasurements',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomMeasurements'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'Composite',
              className: 'EventsOperationInfo'
            }
          },
          session: {
            required: false,
            serializedName: 'session',
            type: {
              name: 'Composite',
              className: 'EventsSessionInfo'
            }
          },
          user: {
            required: false,
            serializedName: 'user',
            type: {
              name: 'Composite',
              className: 'EventsUserInfo'
            }
          },
          cloud: {
            required: false,
            serializedName: 'cloud',
            type: {
              name: 'Composite',
              className: 'EventsCloudInfo'
            }
          },
          ai: {
            required: false,
            serializedName: 'ai',
            type: {
              name: 'Composite',
              className: 'EventsAiInfo'
            }
          },
          application: {
            required: false,
            serializedName: 'application',
            type: {
              name: 'Composite',
              className: 'EventsApplicationInfo'
            }
          },
          client: {
            required: false,
            serializedName: 'client',
            type: {
              name: 'Composite',
              className: 'EventsClientInfo'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          browserTiming: {
            required: false,
            serializedName: 'browserTiming',
            type: {
              name: 'Composite',
              className: 'EventsBrowserTimingInfo'
            }
          },
          clientPerformance: {
            required: false,
            serializedName: 'clientPerformance',
            type: {
              name: 'Composite',
              className: 'EventsClientPerformanceInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsBrowserTimingResult;
