/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A dependency result
 *
 * @extends models['EventsResultData']
 */
class EventsDependencyResult extends models['EventsResultData'] {
  /**
   * Create a EventsDependencyResult.
   * @member {object} [dependency]
   * @member {string} [dependency.target] The target of the dependency
   * @member {string} [dependency.data] The data of the dependency
   * @member {string} [dependency.success] Indicates if the dependency was
   * successful
   * @member {number} [dependency.duration] The duration of the dependency
   * @member {string} [dependency.performanceBucket] The performance bucket of
   * the dependency
   * @member {string} [dependency.resultCode] The result code of the dependency
   * @member {string} [dependency.type] The type of the dependency
   * @member {string} [dependency.name] The name of the dependency
   * @member {string} [dependency.id] The ID of the dependency
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventsDependencyResult
   *
   * @returns {object} metadata of EventsDependencyResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'dependency',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'EventsResultData',
        className: 'EventsDependencyResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          customDimensions: {
            required: false,
            serializedName: 'customDimensions',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomDimensions'
            }
          },
          customMeasurements: {
            required: false,
            serializedName: 'customMeasurements',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomMeasurements'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'Composite',
              className: 'EventsOperationInfo'
            }
          },
          session: {
            required: false,
            serializedName: 'session',
            type: {
              name: 'Composite',
              className: 'EventsSessionInfo'
            }
          },
          user: {
            required: false,
            serializedName: 'user',
            type: {
              name: 'Composite',
              className: 'EventsUserInfo'
            }
          },
          cloud: {
            required: false,
            serializedName: 'cloud',
            type: {
              name: 'Composite',
              className: 'EventsCloudInfo'
            }
          },
          ai: {
            required: false,
            serializedName: 'ai',
            type: {
              name: 'Composite',
              className: 'EventsAiInfo'
            }
          },
          application: {
            required: false,
            serializedName: 'application',
            type: {
              name: 'Composite',
              className: 'EventsApplicationInfo'
            }
          },
          client: {
            required: false,
            serializedName: 'client',
            type: {
              name: 'Composite',
              className: 'EventsClientInfo'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          dependency: {
            required: false,
            serializedName: 'dependency',
            type: {
              name: 'Composite',
              className: 'EventsDependencyInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsDependencyResult;
