/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Operation info for an event result
 *
 */
class EventsOperationInfo {
  /**
   * Create a EventsOperationInfo.
   * @member {string} [name] Name of the operation
   * @member {string} [id] ID of the operation
   * @member {string} [parentId] Parent ID of the operation
   * @member {string} [syntheticSource] Synthetic source of the operation
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsOperationInfo
   *
   * @returns {object} metadata of EventsOperationInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsOperationInfo',
      type: {
        name: 'Composite',
        className: 'EventsOperationInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          parentId: {
            required: false,
            serializedName: 'parentId',
            type: {
              name: 'String'
            }
          },
          syntheticSource: {
            required: false,
            serializedName: 'syntheticSource',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsOperationInfo;
