/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties that define an API key of an Application Insights Component.
 *
 */
class ApplicationInsightsComponentAPIKey {
  /**
   * Create a ApplicationInsightsComponentAPIKey.
   * @member {string} [id] The unique ID of the API key inside an Applciation
   * Insights component. It is auto generated when the API key is created.
   * @member {string} [apiKey] The API key value. It will be only return once
   * when the API Key was created.
   * @member {string} [createdDate] The create date of this API key.
   * @member {string} [name] The name of the API key.
   * @member {array} [linkedReadProperties] The read access rights of this API
   * Key.
   * @member {array} [linkedWriteProperties] The write access rights of this
   * API Key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationInsightsComponentAPIKey
   *
   * @returns {object} metadata of ApplicationInsightsComponentAPIKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationInsightsComponentAPIKey',
      type: {
        name: 'Composite',
        className: 'ApplicationInsightsComponentAPIKey',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          apiKey: {
            required: false,
            readOnly: true,
            serializedName: 'apiKey',
            type: {
              name: 'String'
            }
          },
          createdDate: {
            required: false,
            serializedName: 'createdDate',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          linkedReadProperties: {
            required: false,
            serializedName: 'linkedReadProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          linkedWriteProperties: {
            required: false,
            serializedName: 'linkedWriteProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationInsightsComponentAPIKey;
