/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An Application Insights component daily data volume cap status
 *
 */
class ApplicationInsightsComponentQuotaStatus {
  /**
   * Create a ApplicationInsightsComponentQuotaStatus.
   * @member {string} [appId] The Application ID for the Application Insights
   * component.
   * @member {boolean} [shouldBeThrottled] The daily data volume cap is met,
   * and data ingestion will be stopped.
   * @member {string} [expirationTime] Date and time when the daily data volume
   * cap will be reset, and data ingestion will resume.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationInsightsComponentQuotaStatus
   *
   * @returns {object} metadata of ApplicationInsightsComponentQuotaStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationInsightsComponentQuotaStatus',
      type: {
        name: 'Composite',
        className: 'ApplicationInsightsComponentQuotaStatus',
        modelProperties: {
          appId: {
            required: false,
            readOnly: true,
            serializedName: 'AppId',
            type: {
              name: 'String'
            }
          },
          shouldBeThrottled: {
            required: false,
            readOnly: true,
            serializedName: 'ShouldBeThrottled',
            type: {
              name: 'Boolean'
            }
          },
          expirationTime: {
            required: false,
            readOnly: true,
            serializedName: 'ExpirationTime',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationInsightsComponentQuotaStatus;
