/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error associated with trying to get work item configuration or
 * configurations
 *
 */
class WorkItemConfigurationError {
  /**
   * Create a WorkItemConfigurationError.
   * @member {string} [code] Error detail code and explanation
   * @member {string} [message] Error message
   * @member {object} [innererror]
   * @member {string} [innererror.diagnosticcontext] Provides correlation for
   * request
   * @member {date} [innererror.time] Request time
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkItemConfigurationError
   *
   * @returns {object} metadata of WorkItemConfigurationError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkItemConfigurationError',
      type: {
        name: 'Composite',
        className: 'WorkItemConfigurationError',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          innererror: {
            required: false,
            serializedName: 'innererror',
            type: {
              name: 'Composite',
              className: 'InnerError'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkItemConfigurationError;
