/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Role assignment create parameters.
 *
 */
class RoleAssignmentCreateParameters {
  /**
   * Create a RoleAssignmentCreateParameters.
   * @property {string} roleDefinitionId The role definition ID used in the
   * role assignment.
   * @property {string} principalId The principal ID assigned to the role. This
   * maps to the ID inside the Active Directory. It can point to a user,
   * service principal, or security group.
   * @property {string} [principalType] The principal type of the assigned
   * principal ID. Possible values include: 'User', 'Group',
   * 'ServicePrincipal', 'Unknown', 'DirectoryRoleTemplate', 'ForeignGroup',
   * 'Application', 'MSI', 'DirectoryObjectOrGroup', 'Everyone'
   * @property {boolean} [canDelegate] The delgation flag used for creating a
   * role assignment
   */
  constructor() {
  }

  /**
   * Defines the metadata of RoleAssignmentCreateParameters
   *
   * @returns {object} metadata of RoleAssignmentCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RoleAssignmentCreateParameters',
      type: {
        name: 'Composite',
        className: 'RoleAssignmentCreateParameters',
        modelProperties: {
          roleDefinitionId: {
            required: true,
            serializedName: 'properties.roleDefinitionId',
            type: {
              name: 'String'
            }
          },
          principalId: {
            required: true,
            serializedName: 'properties.principalId',
            type: {
              name: 'String'
            }
          },
          principalType: {
            required: false,
            serializedName: 'properties.principalType',
            type: {
              name: 'String'
            }
          },
          canDelegate: {
            required: false,
            serializedName: 'properties.canDelegate',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = RoleAssignmentCreateParameters;
