/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Role definition.
 *
 */
class RoleDefinition {
  /**
   * Create a RoleDefinition.
   * @property {string} [id] The role definition ID.
   * @property {string} [name] The role definition name.
   * @property {string} [type] The role definition type.
   * @property {string} [roleName] The role name.
   * @property {string} [description] The role definition description.
   * @property {string} [roleType] The role type.
   * @property {array} [permissions] Role definition permissions.
   * @property {array} [assignableScopes] Role definition assignable scopes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RoleDefinition
   *
   * @returns {object} metadata of RoleDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RoleDefinition',
      type: {
        name: 'Composite',
        className: 'RoleDefinition',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          roleName: {
            required: false,
            serializedName: 'properties.roleName',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          roleType: {
            required: false,
            serializedName: 'properties.type',
            type: {
              name: 'String'
            }
          },
          permissions: {
            required: false,
            serializedName: 'properties.permissions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PermissionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Permission'
                  }
              }
            }
          },
          assignableScopes: {
            required: false,
            serializedName: 'properties.assignableScopes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RoleDefinition;
