/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure query for the update configuration.
 *
 */
class AzureQueryProperties {
  /**
   * Create a AzureQueryProperties.
   * @member {array} [scope] List of Subscription or Resource Group ARM Ids.
   * @member {array} [locations] List of locations to scope the query to.
   * @member {object} [tagSettings] Tag settings for the VM.
   * @member {object} [tagSettings.tags] Dictionary of tags with its list of
   * values.
   * @member {string} [tagSettings.filterOperator] Filter VMs by Any or All
   * specified tags. Possible values include: 'All', 'Any'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureQueryProperties
   *
   * @returns {object} metadata of AzureQueryProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureQueryProperties',
      type: {
        name: 'Composite',
        className: 'AzureQueryProperties',
        modelProperties: {
          scope: {
            required: false,
            serializedName: 'scope',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          locations: {
            required: false,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          tagSettings: {
            required: false,
            serializedName: 'tagSettings',
            type: {
              name: 'Composite',
              className: 'TagSettingsProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureQueryProperties;
