/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * object returned when requesting a collection of software update
 * configuration
 *
 */
class CollectionItemUpdateConfiguration {
  /**
   * Create a CollectionItemUpdateConfiguration.
   * @member {array} [azureVirtualMachines] List of azure resource Ids for
   * azure virtual machines targeted by the software update configuration.
   * @member {moment.duration} [duration] Maximum time allowed for the software
   * update configuration run. Duration needs to be specified using the format
   * PT[n]H[n]M[n]S as per ISO8601
   */
  constructor() {
  }

  /**
   * Defines the metadata of CollectionItemUpdateConfiguration
   *
   * @returns {object} metadata of CollectionItemUpdateConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'collectionItemUpdateConfiguration',
      type: {
        name: 'Composite',
        className: 'CollectionItemUpdateConfiguration',
        modelProperties: {
          azureVirtualMachines: {
            required: false,
            serializedName: 'azureVirtualMachines',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          duration: {
            required: false,
            serializedName: 'duration',
            type: {
              name: 'TimeSpan'
            }
          }
        }
      }
    };
  }
}

module.exports = CollectionItemUpdateConfiguration;
