/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Software update configuration run tasks model.
 *
 */
class SoftareUpdateConfigurationRunTasks {
  /**
   * Create a SoftareUpdateConfigurationRunTasks.
   * @member {object} [preTask] Pre task properties.
   * @member {string} [preTask.status] The status of the task.
   * @member {string} [preTask.source] The name of the source of the task.
   * @member {string} [preTask.jobId] The job id of the task.
   * @member {object} [postTask] Post task properties.
   * @member {string} [postTask.status] The status of the task.
   * @member {string} [postTask.source] The name of the source of the task.
   * @member {string} [postTask.jobId] The job id of the task.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SoftareUpdateConfigurationRunTasks
   *
   * @returns {object} metadata of SoftareUpdateConfigurationRunTasks
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'softareUpdateConfigurationRunTasks',
      type: {
        name: 'Composite',
        className: 'SoftareUpdateConfigurationRunTasks',
        modelProperties: {
          preTask: {
            required: false,
            serializedName: 'preTask',
            type: {
              name: 'Composite',
              className: 'SoftareUpdateConfigurationRunTaskProperties'
            }
          },
          postTask: {
            required: false,
            serializedName: 'postTask',
            type: {
              name: 'Composite',
              className: 'SoftareUpdateConfigurationRunTaskProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = SoftareUpdateConfigurationRunTasks;
