/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Tag filter information for the VM.
 *
 */
class TagSettingsProperties {
  /**
   * Create a TagSettingsProperties.
   * @member {object} [tags] Dictionary of tags with its list of values.
   * @member {string} [filterOperator] Filter VMs by Any or All specified tags.
   * Possible values include: 'All', 'Any'
   */
  constructor() {
  }

  /**
   * Defines the metadata of TagSettingsProperties
   *
   * @returns {object} metadata of TagSettingsProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TagSettingsProperties',
      type: {
        name: 'Composite',
        className: 'TagSettingsProperties',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ArrayElementType',
                  type: {
                    name: 'Sequence',
                    element: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          },
          filterOperator: {
            required: false,
            serializedName: 'filterOperator',
            type: {
              name: 'Enum',
              allowedValues: [ 'All', 'Any' ]
            }
          }
        }
      }
    };
  }
}

module.exports = TagSettingsProperties;
