/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains the localized display information for this particular operation or
 * action.
 *
 */
class Display {
  /**
   * Create a Display.
   * @member {string} [provider] The localized, friendly version of the
   * resource provider name.
   * @member {string} [resource] The localized, friendly version of the
   * resource type related to this action or operation; the resource type
   * should match the public documentation for the resource provider.
   * @member {string} [operation] The localized, friendly name for the
   * operation. Use the name as it will displayed to the user.
   * @member {string} [description] The localized, friendly description for the
   * operation. The description will be displayed to the user. It should be
   * thorough and concise for used in both tooltips and detailed views.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Display
   *
   * @returns {object} metadata of Display
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Display',
      type: {
        name: 'Composite',
        className: 'Display',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Display;
