/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the supported REST operation.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] The name of the operation being performed on this
   * particular object.
   * @member {object} [display] Contains the localized display information for
   * this particular operation or action.
   * @member {string} [display.provider] The localized, friendly version of the
   * resource provider name.
   * @member {string} [display.resource] The localized, friendly version of the
   * resource type related to this action or operation; the resource type
   * should match the public documentation for the resource provider.
   * @member {string} [display.operation] The localized, friendly name for the
   * operation. Use the name as it will displayed to the user.
   * @member {string} [display.description] The localized, friendly description
   * for the operation. The description will be displayed to the user. It
   * should be thorough and concise for used in both tooltips and detailed
   * views.
   * @member {string} [origin] The intended executor of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'Display'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
