/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary How the Batch service should respond if a Task exits with a
 * particular exit code.
  *
 */
class ExitCodeMapping {
  /**
   * Create a ExitCodeMapping.
   * @property {number} code A process exit code.
   * @property {object} exitOptions How the Batch service should respond if the
   * Task exits with this exit code.
   * @property {string} [exitOptions.jobAction] The default is none for exit
   * code 0 and terminate for all other exit conditions. If the Job's
   * onTaskFailed property is noaction, then specifying this property returns
   * an error and the add Task request fails with an invalid property value
   * error; if you are calling the REST API directly, the HTTP status code is
   * 400 (Bad Request). Possible values include: 'none', 'disable', 'terminate'
   * @property {string} [exitOptions.dependencyAction] Possible values are
   * 'satisfy' (allowing dependent tasks to progress) and 'block' (dependent
   * tasks continue to wait). Batch does not yet support cancellation of
   * dependent tasks. Possible values include: 'satisfy', 'block'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExitCodeMapping
   *
   * @returns {object} metadata of ExitCodeMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExitCodeMapping',
      type: {
        name: 'Composite',
        className: 'ExitCodeMapping',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'Number'
            }
          },
          exitOptions: {
            required: true,
            serializedName: 'exitOptions',
            type: {
              name: 'Composite',
              className: 'ExitOptions'
            }
          }
        }
      }
    };
  }
}

module.exports = ExitCodeMapping;
