/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The network configuration for the Job.
  *
 */
class JobNetworkConfiguration {
  /**
   * Create a JobNetworkConfiguration.
   * @property {string} subnetId The ARM resource identifier of the virtual
   * network subnet which Compute Nodes running Tasks from the Job will join
   * for the duration of the Task. This will only work with a
   * VirtualMachineConfiguration Pool. The virtual network must be in the same
   * region and subscription as the Azure Batch Account. The specified subnet
   * should have enough free IP addresses to accommodate the number of Compute
   * Nodes which will run Tasks from the Job. This can be up to the number of
   * Compute Nodes in the Pool. The 'MicrosoftAzureBatch' service principal
   * must have the 'Classic Virtual Machine Contributor' Role-Based Access
   * Control (RBAC) role for the specified VNet so that Azure Batch service can
   * schedule Tasks on the Nodes. This can be verified by checking if the
   * specified VNet has any associated Network Security Groups (NSG). If
   * communication to the Nodes in the specified subnet is denied by an NSG,
   * then the Batch service will set the state of the Compute Nodes to
   * unusable. This is of the form
   * /subscriptions/{subscription}/resourceGroups/{group}/providers/{provider}/virtualNetworks/{network}/subnets/{subnet}.
   * If the specified VNet has any associated Network Security Groups (NSG),
   * then a few reserved system ports must be enabled for inbound communication
   * from the Azure Batch service. For Pools created with a Virtual Machine
   * configuration, enable ports 29876 and 29877, as well as port 22 for Linux
   * and port 3389 for Windows. Port 443 is also required to be open for
   * outbound connections for communications to Azure Storage. For more details
   * see:
   * https://docs.microsoft.com/en-us/azure/batch/batch-api-basics#virtual-network-vnet-and-firewall-configuration
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobNetworkConfiguration
   *
   * @returns {object} metadata of JobNetworkConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobNetworkConfiguration',
      type: {
        name: 'Composite',
        className: 'JobNetworkConfiguration',
        modelProperties: {
          subnetId: {
            required: true,
            serializedName: 'subnetId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobNetworkConfiguration;
