/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The Task counts for a Job.
  *
 */
class TaskCounts {
  /**
   * Create a TaskCounts.
   * @property {number} active The number of Tasks in the active state.
   * @property {number} running The number of Tasks in the running or preparing
   * state.
   * @property {number} completed The number of Tasks in the completed state.
   * @property {number} succeeded The number of Tasks which succeeded. A Task
   * succeeds if its result (found in the executionInfo property) is 'success'.
   * @property {number} failed The number of Tasks which failed. A Task fails
   * if its result (found in the executionInfo property) is 'failure'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskCounts
   *
   * @returns {object} metadata of TaskCounts
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskCounts',
      type: {
        name: 'Composite',
        className: 'TaskCounts',
        modelProperties: {
          active: {
            required: true,
            serializedName: 'active',
            type: {
              name: 'Number'
            }
          },
          running: {
            required: true,
            serializedName: 'running',
            type: {
              name: 'Number'
            }
          },
          completed: {
            required: true,
            serializedName: 'completed',
            type: {
              name: 'Number'
            }
          },
          succeeded: {
            required: true,
            serializedName: 'succeeded',
            type: {
              name: 'Number'
            }
          },
          failed: {
            required: true,
            serializedName: 'failed',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TaskCounts;
