/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The Azure Batch service log files upload configuration for a
 * Compute Node.
  *
 */
class UploadBatchServiceLogsConfiguration {
  /**
   * Create a UploadBatchServiceLogsConfiguration.
   * @property {string} containerUrl The URL of the container within Azure Blob
   * Storage to which to upload the Batch Service log file(s). The URL must
   * include a Shared Access Signature (SAS) granting write permissions to the
   * container. The SAS duration must allow enough time for the upload to
   * finish. The start time for SAS is optional and recommended to not be
   * specified.
   * @property {date} startTime The start of the time range from which to
   * upload Batch Service log file(s). Any log file containing a log message in
   * the time range will be uploaded. This means that the operation might
   * retrieve more logs than have been requested since the entire log file is
   * always uploaded, but the operation should not retrieve fewer logs than
   * have been requested.
   * @property {date} [endTime] The end of the time range from which to upload
   * Batch Service log file(s). Any log file containing a log message in the
   * time range will be uploaded. This means that the operation might retrieve
   * more logs than have been requested since the entire log file is always
   * uploaded, but the operation should not retrieve fewer logs than have been
   * requested. If omitted, the default is to upload all logs available after
   * the startTime.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UploadBatchServiceLogsConfiguration
   *
   * @returns {object} metadata of UploadBatchServiceLogsConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UploadBatchServiceLogsConfiguration',
      type: {
        name: 'Composite',
        className: 'UploadBatchServiceLogsConfiguration',
        modelProperties: {
          containerUrl: {
            required: true,
            serializedName: 'containerUrl',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = UploadBatchServiceLogsConfiguration;
