/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Caffe job settings.
 *
 */
class CaffeSettings {
  /**
   * Create a CaffeSettings.
   * @member {string} [configFilePath] Config file path. Path of the config
   * file for the job. This property cannot be specified if
   * pythonScriptFilePath is specified.
   * @member {string} [pythonScriptFilePath] Python script file path. Python
   * script to execute. This property cannot be specified if configFilePath is
   * specified.
   * @member {string} [pythonInterpreterPath] Python interpreter path. The path
   * to the Python interpreter. The property can be specified only if the
   * pythonScriptFilePath is specified.
   * @member {string} [commandLineArgs] Command line arguments. Command line
   * arguments that need to be passed to the Caffe job.
   * @member {number} [processCount] Process count. Number of processes to
   * launch for the job execution. The default value for this property is equal
   * to nodeCount property
   */
  constructor() {
  }

  /**
   * Defines the metadata of CaffeSettings
   *
   * @returns {object} metadata of CaffeSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CaffeSettings',
      type: {
        name: 'Composite',
        className: 'CaffeSettings',
        modelProperties: {
          configFilePath: {
            required: false,
            serializedName: 'configFilePath',
            type: {
              name: 'String'
            }
          },
          pythonScriptFilePath: {
            required: false,
            serializedName: 'pythonScriptFilePath',
            type: {
              name: 'String'
            }
          },
          pythonInterpreterPath: {
            required: false,
            serializedName: 'pythonInterpreterPath',
            type: {
              name: 'String'
            }
          },
          commandLineArgs: {
            required: false,
            serializedName: 'commandLineArgs',
            type: {
              name: 'String'
            }
          },
          processCount: {
            required: false,
            serializedName: 'processCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = CaffeSettings;
