/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data disks settings.
 *
 */
class DataDisks {
  /**
   * Create a DataDisks.
   * @member {number} diskSizeInGB Disk size in GB. Disk size in GB for the
   * blank data disks.
   * @member {string} [cachingType] Caching type. Caching type for the disks.
   * Available values are none (default), readonly, readwrite. Caching type can
   * be set only for VM sizes supporting premium storage. Possible values
   * include: 'none', 'readonly', 'readwrite'. Default value: 'none' .
   * @member {number} diskCount Number of data disks. Number of data disks
   * attached to the File Server. If multiple disks attached, they will be
   * configured in RAID level 0.
   * @member {string} storageAccountType Storage account type. Type of storage
   * account to be used on the disk. Possible values are: Standard_LRS or
   * Premium_LRS. Premium storage account type can only be used with VM sizes
   * supporting premium storage. Possible values include: 'Standard_LRS',
   * 'Premium_LRS'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataDisks
   *
   * @returns {object} metadata of DataDisks
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataDisks',
      type: {
        name: 'Composite',
        className: 'DataDisks',
        modelProperties: {
          diskSizeInGB: {
            required: true,
            serializedName: 'diskSizeInGB',
            type: {
              name: 'Number'
            }
          },
          cachingType: {
            required: false,
            serializedName: 'cachingType',
            defaultValue: 'none',
            type: {
              name: 'Enum',
              allowedValues: [ 'none', 'readonly', 'readwrite' ]
            }
          },
          diskCount: {
            required: true,
            serializedName: 'diskCount',
            type: {
              name: 'Number'
            }
          },
          storageAccountType: {
            required: true,
            serializedName: 'storageAccountType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataDisks;
