/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Input directory for the job.
 *
 */
class InputDirectory {
  /**
   * Create a InputDirectory.
   * @member {string} id ID. The ID for the input directory. The job can use
   * AZ_BATCHAI_INPUT_<id> environment variable to find the directory path,
   * where <id> is the value of id attribute.
   * @member {string} path Path. The path to the input directory.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InputDirectory
   *
   * @returns {object} metadata of InputDirectory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InputDirectory',
      type: {
        name: 'Composite',
        className: 'InputDirectory',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          path: {
            required: true,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InputDirectory;
