/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional parameters for listOutputFiles operation.
 *
 */
class JobsListOutputFilesOptions {
  /**
   * Create a JobsListOutputFilesOptions.
   * @member {string} outputdirectoryid Id of the job output directory. This is
   * the OutputDirectory-->id parameter that is given by the user during Create
   * Job.
   * @member {string} [directory] The path to the directory. Default value: '.'
   * .
   * @member {number} [linkexpiryinminutes] The number of minutes after which
   * the download link will expire. Default value: 60 .
   * @member {number} [maxResults] The maximum number of items to return in the
   * response. A maximum of 1000 files can be returned. Default value: 1000 .
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobsListOutputFilesOptions
   *
   * @returns {object} metadata of JobsListOutputFilesOptions
   *
   */
  mapper() {
    return {
      required: false,
      type: {
        name: 'Composite',
        className: 'JobsListOutputFilesOptions',
        modelProperties: {
          outputdirectoryid: {
            required: true,
            type: {
              name: 'String'
            }
          },
          directory: {
            required: false,
            defaultValue: '.',
            type: {
              name: 'String'
            }
          },
          linkexpiryinminutes: {
            required: false,
            defaultValue: 60,
            type: {
              name: 'Number'
            }
          },
          maxResults: {
            required: false,
            defaultValue: 1000,
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = JobsListOutputFilesOptions;
