/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Key Vault Secret reference.
 *
 */
class KeyVaultSecretReference {
  /**
   * Create a KeyVaultSecretReference.
   * @member {object} sourceVault Key Vault resource identifier. Fully
   * qualified resource indentifier of the Key Vault.
   * @member {string} [sourceVault.id] The ID of the resource
   * @member {string} secretUrl Secret URL. The URL referencing a secret in the
   * Key Vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultSecretReference
   *
   * @returns {object} metadata of KeyVaultSecretReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultSecretReference',
      type: {
        name: 'Composite',
        className: 'KeyVaultSecretReference',
        modelProperties: {
          sourceVault: {
            required: true,
            serializedName: 'sourceVault',
            type: {
              name: 'Composite',
              className: 'ResourceId'
            }
          },
          secretUrl: {
            required: true,
            serializedName: 'secretUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultSecretReference;
