/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * File Server mount Information.
 *
 */
class MountSettings {
  /**
   * Create a MountSettings.
   * @member {string} [mountPoint] Mount Point. Path where the data disks are
   * mounted on the File Server.
   * @member {string} [fileServerPublicIP] Public IP. Public IP address of the
   * File Server which can be used to SSH to the node from outside of the
   * subnet.
   * @member {string} [fileServerInternalIP] Internal IP. Internal IP address
   * of the File Server which can be used to access the File Server from within
   * the subnet.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MountSettings
   *
   * @returns {object} metadata of MountSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MountSettings',
      type: {
        name: 'Composite',
        className: 'MountSettings',
        modelProperties: {
          mountPoint: {
            required: false,
            serializedName: 'mountPoint',
            type: {
              name: 'String'
            }
          },
          fileServerPublicIP: {
            required: false,
            serializedName: 'fileServerPublicIP',
            type: {
              name: 'String'
            }
          },
          fileServerInternalIP: {
            required: false,
            serializedName: 'fileServerInternalIP',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MountSettings;
