/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Counts of various compute node states on the cluster.
 *
 */
class NodeStateCounts {
  /**
   * Create a NodeStateCounts.
   * @member {number} [idleNodeCount] Idle node count. Number of compute nodes
   * in idle state.
   * @member {number} [runningNodeCount] Running node count. Number of compute
   * nodes which are running jobs.
   * @member {number} [preparingNodeCount] Preparing node count. Number of
   * compute nodes which are being prepared.
   * @member {number} [unusableNodeCount] Unusable node count. Number of
   * compute nodes which are in unusable state.
   * @member {number} [leavingNodeCount] Leaving node count. Number of compute
   * nodes which are leaving the cluster.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeStateCounts
   *
   * @returns {object} metadata of NodeStateCounts
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeStateCounts',
      type: {
        name: 'Composite',
        className: 'NodeStateCounts',
        modelProperties: {
          idleNodeCount: {
            required: false,
            readOnly: true,
            serializedName: 'idleNodeCount',
            type: {
              name: 'Number'
            }
          },
          runningNodeCount: {
            required: false,
            readOnly: true,
            serializedName: 'runningNodeCount',
            type: {
              name: 'Number'
            }
          },
          preparingNodeCount: {
            required: false,
            readOnly: true,
            serializedName: 'preparingNodeCount',
            type: {
              name: 'Number'
            }
          },
          unusableNodeCount: {
            required: false,
            readOnly: true,
            serializedName: 'unusableNodeCount',
            type: {
              name: 'Number'
            }
          },
          leavingNodeCount: {
            required: false,
            readOnly: true,
            serializedName: 'leavingNodeCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeStateCounts;
