/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Output directory for the job.
 *
 */
class OutputDirectory {
  /**
   * Create a OutputDirectory.
   * @member {string} id ID. The ID of the output directory. The job can use
   * AZ_BATCHAI_OUTPUT_<id> environment variale to find the directory path,
   * where <id> is the value of id attribute.
   * @member {string} pathPrefix Path prefix. The prefix path where the output
   * directory will be created. Note, this is an absolute path to prefix. E.g.
   * $AZ_BATCHAI_MOUNT_ROOT/MyNFS/MyLogs. The full path to the output directory
   * by combining pathPrefix, jobOutputDirectoryPathSegment (reported by get
   * job) and pathSuffix.
   * @member {string} [pathSuffix] Path suffix. The suffix path where the
   * output directory will be created. E.g. models. You can find the full path
   * to the output directory by combining pathPrefix,
   * jobOutputDirectoryPathSegment (reported by get job) and pathSuffix.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OutputDirectory
   *
   * @returns {object} metadata of OutputDirectory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OutputDirectory',
      type: {
        name: 'Composite',
        className: 'OutputDirectory',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          pathPrefix: {
            required: true,
            serializedName: 'pathPrefix',
            type: {
              name: 'String'
            }
          },
          pathSuffix: {
            required: false,
            serializedName: 'pathSuffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OutputDirectory;
