/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Performance counters reporting settings.
 *
 */
class PerformanceCountersSettings {
  /**
   * Create a PerformanceCountersSettings.
   * @member {object} appInsightsReference Azure Application Insights
   * reference. Azure Application Insights information for performance counters
   * reporting. If provided, Batch AI will upload node performance counters to
   * the corresponding Azure Application Insights account.
   * @member {object} [appInsightsReference.component] Azure Application
   * Insights component resource ID.
   * @member {string} [appInsightsReference.component.id] The ID of the
   * resource
   * @member {string} [appInsightsReference.instrumentationKey] Value of the
   * Azure Application Insights instrumentation key.
   * @member {object} [appInsightsReference.instrumentationKeySecretReference]
   * KeyVault Store and Secret which contains Azure Application Insights
   * instrumentation key. One of instrumentationKey or
   * instrumentationKeySecretReference must be specified.
   * @member {object}
   * [appInsightsReference.instrumentationKeySecretReference.sourceVault] Fully
   * qualified resource indentifier of the Key Vault.
   * @member {string}
   * [appInsightsReference.instrumentationKeySecretReference.sourceVault.id]
   * The ID of the resource
   * @member {string}
   * [appInsightsReference.instrumentationKeySecretReference.secretUrl] The URL
   * referencing a secret in the Key Vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerformanceCountersSettings
   *
   * @returns {object} metadata of PerformanceCountersSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerformanceCountersSettings',
      type: {
        name: 'Composite',
        className: 'PerformanceCountersSettings',
        modelProperties: {
          appInsightsReference: {
            required: true,
            serializedName: 'appInsightsReference',
            type: {
              name: 'Composite',
              className: 'AppInsightsReference'
            }
          }
        }
      }
    };
  }
}

module.exports = PerformanceCountersSettings;
