/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The classification details of the text.
 *
 */
class Classification {
  /**
   * Create a Classification.
   * @property {object} [category1] The category1 score details of the text. <a
   * href="https://aka.ms/textClassifyCategories">Click here</a> for more
   * details on category classification.
   * @property {number} [category1.score] The category1 score.
   * @property {object} [category2] The category2 score details of the text. <a
   * href="https://aka.ms/textClassifyCategories">Click here</a> for more
   * details on category classification.
   * @property {number} [category2.score] The category2 score.
   * @property {object} [category3] The category3 score details of the text. <a
   * href="https://aka.ms/textClassifyCategories">Click here</a> for more
   * details on category classification.
   * @property {number} [category3.score] The category3 score.
   * @property {boolean} [reviewRecommended] The review recommended flag.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Classification
   *
   * @returns {object} metadata of Classification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Classification',
      type: {
        name: 'Composite',
        className: 'Classification',
        modelProperties: {
          category1: {
            required: false,
            serializedName: 'Category1',
            type: {
              name: 'Composite',
              className: 'ClassificationCategory1'
            }
          },
          category2: {
            required: false,
            serializedName: 'Category2',
            type: {
              name: 'Composite',
              className: 'ClassificationCategory2'
            }
          },
          category3: {
            required: false,
            serializedName: 'Category3',
            type: {
              name: 'Composite',
              className: 'ClassificationCategory3'
            }
          },
          reviewRecommended: {
            required: false,
            serializedName: 'ReviewRecommended',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Classification;
