/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CreateVideoReviewsBodyItemVideoFramesItem.
 */
class CreateVideoReviewsBodyItemVideoFramesItem {
  /**
   * Create a CreateVideoReviewsBodyItemVideoFramesItem.
   * @property {string} id Id of the frame.
   * @property {number} timestamp Timestamp of the frame.
   * @property {string} frameImage Frame image Url.
   * @property {array} [reviewerResultTags]
   * @property {array} [metadata] Optional metadata details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateVideoReviewsBodyItemVideoFramesItem
   *
   * @returns {object} metadata of CreateVideoReviewsBodyItemVideoFramesItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateVideoReviewsBodyItem_VideoFramesItem',
      type: {
        name: 'Composite',
        className: 'CreateVideoReviewsBodyItemVideoFramesItem',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'Id',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: true,
            serializedName: 'Timestamp',
            type: {
              name: 'Number'
            }
          },
          frameImage: {
            required: true,
            serializedName: 'FrameImage',
            type: {
              name: 'String'
            }
          },
          reviewerResultTags: {
            required: false,
            serializedName: 'ReviewerResultTags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CreateVideoReviewsBodyItemVideoFramesItemReviewerResultTagsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CreateVideoReviewsBodyItemVideoFramesItemReviewerResultTagsItem'
                  }
              }
            }
          },
          metadata: {
            required: false,
            serializedName: 'Metadata',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CreateVideoReviewsBodyItemVideoFramesItemMetadataItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CreateVideoReviewsBodyItemVideoFramesItemMetadataItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CreateVideoReviewsBodyItemVideoFramesItem;
