/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Email Address details.
 *
 */
class Email {
  /**
   * Create a Email.
   * @property {string} [detected] Detected Email Address from the input text
   * content.
   * @property {string} [subType] Subtype of the detected Email Address.
   * @property {string} [text] Email Address in the input text content.
   * @property {number} [index] Index(Location) of the Email address in the
   * input text content.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Email
   *
   * @returns {object} metadata of Email
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Email',
      type: {
        name: 'Composite',
        className: 'Email',
        modelProperties: {
          detected: {
            required: false,
            serializedName: 'Detected',
            type: {
              name: 'String'
            }
          },
          subType: {
            required: false,
            serializedName: 'SubType',
            type: {
              name: 'String'
            }
          },
          text: {
            required: false,
            serializedName: 'Text',
            type: {
              name: 'String'
            }
          },
          index: {
            required: false,
            serializedName: 'Index',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Email;
