/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Image Properties.
 *
 */
class Image {
  /**
   * Create a Image.
   * @property {string} [contentId] Content Id.
   * @property {array} [additionalInfo] Advanced info list.
   * @property {object} [status] Status details.
   * @property {number} [status.code] Status code.
   * @property {string} [status.description] Status description.
   * @property {string} [status.exception] Exception status.
   * @property {string} [trackingId] Tracking Id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Image
   *
   * @returns {object} metadata of Image
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Image',
      type: {
        name: 'Composite',
        className: 'Image',
        modelProperties: {
          contentId: {
            required: false,
            serializedName: 'ContentId',
            type: {
              name: 'String'
            }
          },
          additionalInfo: {
            required: false,
            serializedName: 'AdditionalInfo',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageAdditionalInfoItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageAdditionalInfoItem'
                  }
              }
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'Composite',
              className: 'Status'
            }
          },
          trackingId: {
            required: false,
            serializedName: 'TrackingId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Image;
