/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

const msRest = require('ms-rest');
const ServiceClient = msRest.ServiceClient;

const models = require('./models');
const operations = require('./operations');


/** Class representing a FaceClient. */
class FaceClient extends ServiceClient {
  /**
   * Create a FaceClient.
   * @param {credentials} credentials - Subscription credentials which uniquely identify client subscription.
   * @param {string} endpoint - Supported Cognitive Services endpoints (protocol and hostname, for example: https://westus.api.cognitive.microsoft.com).
   * @param {object} [options] - The parameter options
   * @param {Array} [options.filters] - Filters to be added to the request pipeline
   * @param {object} [options.requestOptions] - Options for the underlying request object
   * {@link https://github.com/request/request#requestoptions-callback Options doc}
   * @param {boolean} [options.noRetryPolicy] - If set to true, turn off default retry policy
   */
  constructor(credentials, endpoint, options) {
    if (credentials === null || credentials === undefined) {
      throw new Error('\'credentials\' cannot be null.');
    }
    if (endpoint === null || endpoint === undefined) {
      throw new Error('\'endpoint\' cannot be null.');
    }

    if (!options) options = {};

    super(credentials, options);

    this.baseUri = '{Endpoint}/face/v1.0';
    this.credentials = credentials;
    this.endpoint = endpoint;

    let packageInfo = this.getPackageJsonInfo(__dirname);
    this.addUserAgentInfo(`${packageInfo.name}/${packageInfo.version}`);
    this.face = new operations.Face(this);
    this.personGroupPerson = new operations.PersonGroupPerson(this);
    this.personGroupOperations = new operations.PersonGroupOperations(this);
    this.faceListOperations = new operations.FaceListOperations(this);
    this.largePersonGroupPerson = new operations.LargePersonGroupPerson(this);
    this.largePersonGroupOperations = new operations.LargePersonGroupOperations(this);
    this.largeFaceListOperations = new operations.LargeFaceListOperations(this);
    this.snapshotOperations = new operations.SnapshotOperations(this);
    this.models = models;
    msRest.addSerializationMixin(this);
  }

}

module.exports = FaceClient;
module.exports['default'] = FaceClient;
module.exports.FaceClient = FaceClient;
module.exports.FaceModels = models;
