/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties describing noise level of the image.
 *
 */
class Noise {
  /**
   * Create a Noise.
   * @property {string} [noiseLevel] An enum value indicating level of noise.
   * Possible values include: 'Low', 'Medium', 'High'
   * @property {number} [value] A number indicating level of noise level
   * ranging from 0 to 1. [0, 0.25) is under exposure. [0.25, 0.75) is good
   * exposure. [0.75, 1] is over exposure. [0, 0.3) is low noise level. [0.3,
   * 0.7) is medium noise level. [0.7, 1] is high noise level.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Noise
   *
   * @returns {object} metadata of Noise
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Noise',
      type: {
        name: 'Composite',
        className: 'Noise',
        modelProperties: {
          noiseLevel: {
            required: false,
            nullable: false,
            serializedName: 'noiseLevel',
            type: {
              name: 'Enum',
              allowedValues: [ 'Low', 'Medium', 'High' ]
            }
          },
          value: {
            required: false,
            nullable: false,
            serializedName: 'value',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Noise;
