/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Training status object.
 *
 */
class TrainingStatus {
  /**
   * Create a TrainingStatus.
   * @property {string} status Training status: notstarted, running, succeeded,
   * failed. If the training process is waiting to perform, the status is
   * notstarted. If the training is ongoing, the status is running. Status
   * succeed means this person group or large person group is ready for Face -
   * Identify, or this large face list is ready for Face - Find Similar. Status
   * failed is often caused by no person or no persisted face exist in the
   * person group or large person group, or no persisted face exist in the
   * large face list. Possible values include: 'nonstarted', 'running',
   * 'succeeded', 'failed'
   * @property {date} created A combined UTC date and time string that
   * describes the created time of the person group, large person group or
   * large face list.
   * @property {date} [lastAction] A combined UTC date and time string that
   * describes the last modify time of the person group, large person group or
   * large face list, could be null value when the group is not successfully
   * trained.
   * @property {date} [lastSuccessfulTraining] A combined UTC date and time
   * string that describes the last successful training time of the person
   * group, large person group or large face list.
   * @property {string} [message] Show failure message when training failed
   * (omitted when training succeed).
   */
  constructor() {
  }

  /**
   * Defines the metadata of TrainingStatus
   *
   * @returns {object} metadata of TrainingStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrainingStatus',
      type: {
        name: 'Composite',
        className: 'TrainingStatus',
        modelProperties: {
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'nonstarted', 'running', 'succeeded', 'failed' ]
            }
          },
          created: {
            required: true,
            serializedName: 'createdDateTime',
            type: {
              name: 'DateTime'
            }
          },
          lastAction: {
            required: false,
            serializedName: 'lastActionDateTime',
            type: {
              name: 'DateTime'
            }
          },
          lastSuccessfulTraining: {
            required: false,
            serializedName: 'lastSuccessfulTrainingDateTime',
            type: {
              name: 'DateTime'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TrainingStatus;
