/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Request body for updating a snapshot, with a combination of user defined
 * apply scope and user specified data.
 *
 */
class UpdateSnapshotRequest {
  /**
   * Create a UpdateSnapshotRequest.
   * @property {array} [applyScope] Array of the target Face subscription ids
   * for the snapshot, specified by the user who created the snapshot when
   * calling Snapshot - Take. For each snapshot, only subscriptions included in
   * the applyScope of Snapshot - Take can apply it.
   * @property {string} [userData] User specified data about the snapshot for
   * any purpose. Length should not exceed 16KB.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateSnapshotRequest
   *
   * @returns {object} metadata of UpdateSnapshotRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateSnapshotRequest',
      type: {
        name: 'Composite',
        className: 'UpdateSnapshotRequest',
        modelProperties: {
          applyScope: {
            required: false,
            serializedName: 'applyScope',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          userData: {
            required: false,
            serializedName: 'userData',
            constraints: {
              MaxLength: 16384
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateSnapshotRequest;
