/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The usage data for a usage request.
 *
 */
class Usage {
  /**
   * Create a Usage.
   * @property {string} [unit] The unit of the metric. Possible values include:
   * 'Count', 'Bytes', 'Seconds', 'Percent', 'CountPerSecond',
   * 'BytesPerSecond', 'Milliseconds'
   * @property {object} [name] The name information for the metric.
   * @property {string} [name.value] The name of the metric.
   * @property {string} [name.localizedValue] The friendly name of the metric.
   * @property {string} [quotaPeriod] The quota period used to summarize the
   * usage values.
   * @property {number} [limit] Maximum value for this metric.
   * @property {number} [currentValue] Current value for this metric.
   * @property {string} [nextResetTime] Next reset time for current quota.
   * @property {string} [status] Cognitive Services account quota usage status.
   * Possible values include: 'Included', 'Blocked', 'InOverage', 'Unknown'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Usage
   *
   * @returns {object} metadata of Usage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Usage',
      type: {
        name: 'Composite',
        className: 'Usage',
        modelProperties: {
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'MetricName'
            }
          },
          quotaPeriod: {
            required: false,
            readOnly: true,
            serializedName: 'quotaPeriod',
            type: {
              name: 'String'
            }
          },
          limit: {
            required: false,
            readOnly: true,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          currentValue: {
            required: false,
            readOnly: true,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          nextResetTime: {
            required: false,
            readOnly: true,
            serializedName: 'nextResetTime',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Usage;
