/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * PATCH Body schema to represent list of Metadata to be updated
 *
 */
class UpdateMetadataDTO {
  /**
   * Create a UpdateMetadataDTO.
   * @property {array} [deleteProperty] List of Metadata associated with answer
   * to be deleted
   * @property {array} [add] List of metadata associated with answer to be
   * added
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateMetadataDTO
   *
   * @returns {object} metadata of UpdateMetadataDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateMetadataDTO',
      type: {
        name: 'Composite',
        className: 'UpdateMetadataDTO',
        modelProperties: {
          deleteProperty: {
            required: false,
            serializedName: 'delete',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetadataDTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetadataDTO'
                  }
              }
            }
          },
          add: {
            required: false,
            serializedName: 'add',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetadataDTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetadataDTO'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateMetadataDTO;
