/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing possible celebrity identification.
 *
 */
class CelebritiesModel {
  /**
   * Create a CelebritiesModel.
   * @property {string} [name] Name of the celebrity.
   * @property {number} [confidence] Confidence level for the celebrity
   * recognition as a value ranging from 0 to 1.
   * @property {object} [faceRectangle] Location of the identified face in the
   * image.
   * @property {number} [faceRectangle.left] X-coordinate of the top left point
   * of the face, in pixels.
   * @property {number} [faceRectangle.top] Y-coordinate of the top left point
   * of the face, in pixels.
   * @property {number} [faceRectangle.width] Width measured from the top-left
   * point of the face, in pixels.
   * @property {number} [faceRectangle.height] Height measured from the
   * top-left point of the face, in pixels.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CelebritiesModel
   *
   * @returns {object} metadata of CelebritiesModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CelebritiesModel',
      type: {
        name: 'Composite',
        className: 'CelebritiesModel',
        modelProperties: {
          name: {
            required: false,
            nullable: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          confidence: {
            required: false,
            nullable: false,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          },
          faceRectangle: {
            required: false,
            serializedName: 'faceRectangle',
            type: {
              name: 'Composite',
              className: 'FaceRectangle'
            }
          }
        }
      }
    };
  }
}

module.exports = CelebritiesModel;
