/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of image analysis using a specific domain model including additional
 * metadata.
 *
 */
class DomainModelResults {
  /**
   * Create a DomainModelResults.
   * @property {object} [result] Model-specific response.
   * @property {string} [requestId] Id of the REST API request.
   * @property {object} [metadata]
   * @property {number} [metadata.width] Image width, in pixels.
   * @property {number} [metadata.height] Image height, in pixels.
   * @property {string} [metadata.format] Image format.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DomainModelResults
   *
   * @returns {object} metadata of DomainModelResults
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DomainModelResults',
      type: {
        name: 'Composite',
        className: 'DomainModelResults',
        modelProperties: {
          result: {
            required: false,
            serializedName: 'result',
            type: {
              name: 'Object'
            }
          },
          requestId: {
            required: false,
            nullable: true,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'ImageMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = DomainModelResults;
