/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing a face identified in the image.
 *
 */
class FaceDescription {
  /**
   * Create a FaceDescription.
   * @property {number} [age] Possible age of the face.
   * @property {string} [gender] Possible gender of the face. Possible values
   * include: 'Male', 'Female'
   * @property {object} [faceRectangle] Rectangle in the image containing the
   * identified face.
   * @property {number} [faceRectangle.left] X-coordinate of the top left point
   * of the face, in pixels.
   * @property {number} [faceRectangle.top] Y-coordinate of the top left point
   * of the face, in pixels.
   * @property {number} [faceRectangle.width] Width measured from the top-left
   * point of the face, in pixels.
   * @property {number} [faceRectangle.height] Height measured from the
   * top-left point of the face, in pixels.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FaceDescription
   *
   * @returns {object} metadata of FaceDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FaceDescription',
      type: {
        name: 'Composite',
        className: 'FaceDescription',
        modelProperties: {
          age: {
            required: false,
            nullable: false,
            serializedName: 'age',
            type: {
              name: 'Number'
            }
          },
          gender: {
            required: false,
            nullable: true,
            serializedName: 'gender',
            type: {
              name: 'Enum',
              allowedValues: [ 'Male', 'Female' ]
            }
          },
          faceRectangle: {
            required: false,
            serializedName: 'faceRectangle',
            type: {
              name: 'Composite',
              className: 'FaceRectangle'
            }
          }
        }
      }
    };
  }
}

module.exports = FaceDescription;
