/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A collection of content tags, along with a list of captions sorted by
 * confidence level, and image metadata.
 *
 */
class ImageDescriptionDetails {
  /**
   * Create a ImageDescriptionDetails.
   * @property {array} [tags] A collection of image tags.
   * @property {array} [captions] A list of captions, sorted by confidence
   * level.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageDescriptionDetails
   *
   * @returns {object} metadata of ImageDescriptionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageDescriptionDetails',
      type: {
        name: 'Composite',
        className: 'ImageDescriptionDetails',
        modelProperties: {
          tags: {
            required: false,
            nullable: true,
            serializedName: 'tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          captions: {
            required: false,
            nullable: true,
            serializedName: 'captions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageCaptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageCaption'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageDescriptionDetails;
