/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The start and end date for a budget.
 *
 */
class BudgetTimePeriod {
  /**
   * Create a BudgetTimePeriod.
   * @member {date} startDate The start date for the budget.
   * @member {date} [endDate] The end date for the budget. If not provided, we
   * default this to 10 years from the start date.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BudgetTimePeriod
   *
   * @returns {object} metadata of BudgetTimePeriod
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BudgetTimePeriod',
      type: {
        name: 'Composite',
        className: 'BudgetTimePeriod',
        modelProperties: {
          startDate: {
            required: true,
            serializedName: 'startDate',
            type: {
              name: 'DateTime'
            }
          },
          endDate: {
            required: false,
            serializedName: 'endDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = BudgetTimePeriod;
