/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The authorization properties for accessing the source code repository.
 *
 */
class AuthInfo {
  /**
   * Create a AuthInfo.
   * @property {string} tokenType The type of Auth token. Possible values
   * include: 'PAT', 'OAuth'
   * @property {string} token The access token used to access the source
   * control provider.
   * @property {string} [refreshToken] The refresh token used to refresh the
   * access token.
   * @property {string} [scope] The scope of the access token.
   * @property {number} [expiresIn] Time in seconds that the token remains
   * valid
   */
  constructor() {
  }

  /**
   * Defines the metadata of AuthInfo
   *
   * @returns {object} metadata of AuthInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AuthInfo',
      type: {
        name: 'Composite',
        className: 'AuthInfo',
        modelProperties: {
          tokenType: {
            required: true,
            serializedName: 'tokenType',
            type: {
              name: 'String'
            }
          },
          token: {
            required: true,
            serializedName: 'token',
            type: {
              name: 'String'
            }
          },
          refreshToken: {
            required: false,
            serializedName: 'refreshToken',
            type: {
              name: 'String'
            }
          },
          scope: {
            required: false,
            serializedName: 'scope',
            type: {
              name: 'String'
            }
          },
          expiresIn: {
            required: false,
            serializedName: 'expiresIn',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AuthInfo;
