/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a volume that is populated with the contents of a git repository
 *
 */
class GitRepoVolume {
  /**
   * Create a GitRepoVolume.
   * @member {string} [directory] Target directory name. Must not contain or
   * start with '..'.  If '.' is supplied, the volume directory will be the git
   * repository.  Otherwise, if specified, the volume will contain the git
   * repository in the subdirectory with the given name.
   * @member {string} repository Repository URL
   * @member {string} [revision] Commit hash for the specified revision.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GitRepoVolume
   *
   * @returns {object} metadata of GitRepoVolume
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GitRepoVolume',
      type: {
        name: 'Composite',
        className: 'GitRepoVolume',
        modelProperties: {
          directory: {
            required: false,
            serializedName: 'directory',
            type: {
              name: 'String'
            }
          },
          repository: {
            required: true,
            serializedName: 'repository',
            type: {
              name: 'String'
            }
          },
          revision: {
            required: false,
            serializedName: 'revision',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GitRepoVolume;
