/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the OpenShift networking configuration
 *
 */
class NetworkProfile {
  /**
   * Create a NetworkProfile.
   * @property {string} [vnetCidr] CIDR for the OpenShift Vnet. Default value:
   * '10.0.0.0/8' .
   * @property {string} [peerVnetId] CIDR of the Vnet to peer.
   * @property {string} [vnetId] ID of the Vnet created for OSA cluster.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkProfile
   *
   * @returns {object} metadata of NetworkProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkProfile',
      type: {
        name: 'Composite',
        className: 'NetworkProfile',
        modelProperties: {
          vnetCidr: {
            required: false,
            serializedName: 'vnetCidr',
            defaultValue: '10.0.0.0/8',
            type: {
              name: 'String'
            }
          },
          peerVnetId: {
            required: false,
            serializedName: 'peerVnetId',
            type: {
              name: 'String'
            }
          },
          vnetId: {
            required: false,
            serializedName: 'vnetId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkProfile;
