/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The partition level usage data for a usage request.
 *
 * @extends models['Usage']
 */
class PartitionUsage extends models['Usage'] {
  /**
   * Create a PartitionUsage.
   * @member {string} [partitionId] The parition id (GUID identifier) of the
   * usages.
   * @member {string} [partitionKeyRangeId] The partition key range id (integer
   * identifier) of the usages.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PartitionUsage
   *
   * @returns {object} metadata of PartitionUsage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionUsage',
      type: {
        name: 'Composite',
        className: 'PartitionUsage',
        modelProperties: {
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'MetricName'
            }
          },
          quotaPeriod: {
            required: false,
            readOnly: true,
            serializedName: 'quotaPeriod',
            type: {
              name: 'String'
            }
          },
          limit: {
            required: false,
            readOnly: true,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          currentValue: {
            required: false,
            readOnly: true,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          partitionId: {
            required: false,
            readOnly: true,
            serializedName: 'partitionId',
            type: {
              name: 'String'
            }
          },
          partitionKeyRangeId: {
            required: false,
            readOnly: true,
            serializedName: 'partitionKeyRangeId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionUsage;
