/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Prediction result.
 *
 */
class Prediction {
  /**
   * Create a Prediction.
   * @property {number} [probability] Probability of the tag.
   * @property {uuid} [tagId] Id of the predicted tag.
   * @property {string} [tagName] Name of the predicted tag.
   * @property {object} [boundingBox] Bounding box of the prediction.
   * @property {number} [boundingBox.left] Coordinate of the left boundary.
   * @property {number} [boundingBox.top] Coordinate of the top boundary.
   * @property {number} [boundingBox.width] Width.
   * @property {number} [boundingBox.height] Height.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Prediction
   *
   * @returns {object} metadata of Prediction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Prediction',
      type: {
        name: 'Composite',
        className: 'Prediction',
        modelProperties: {
          probability: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'probability',
            type: {
              name: 'Number'
            }
          },
          tagId: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'tagId',
            type: {
              name: 'String'
            }
          },
          tagName: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'tagName',
            type: {
              name: 'String'
            }
          },
          boundingBox: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'boundingBox',
            type: {
              name: 'Composite',
              className: 'BoundingBox'
            }
          }
        }
      }
    };
  }
}

module.exports = Prediction;
