/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ExportModel.
 */
class ExportModel {
  /**
   * Create a ExportModel.
   * @property {string} [platform] Platform of the export. Possible values
   * include: 'CoreML', 'TensorFlow', 'DockerFile', 'ONNX', 'VAIDK'
   * @property {string} [status] Status of the export. Possible values include:
   * 'Exporting', 'Failed', 'Done'
   * @property {string} [downloadUri] URI used to download the model.
   * @property {string} [flavor] Flavor of the export. Possible values include:
   * 'Linux', 'Windows', 'ONNX10', 'ONNX12', 'ARM'
   * @property {boolean} [newerVersionAvailable] Indicates an updated version
   * of the export package is available and should be re-exported for the
   * latest changes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExportModel
   *
   * @returns {object} metadata of ExportModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Export',
      type: {
        name: 'Composite',
        className: 'ExportModel',
        modelProperties: {
          platform: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'platform',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          downloadUri: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'downloadUri',
            type: {
              name: 'String'
            }
          },
          flavor: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'flavor',
            type: {
              name: 'String'
            }
          },
          newerVersionAvailable: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'newerVersionAvailable',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ExportModel;
