/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a project.
 *
 */
class Project {
  /**
   * Create a Project.
   * @property {uuid} [id] Gets the project id.
   * @property {string} name Gets or sets the name of the project.
   * @property {string} description Gets or sets the description of the
   * project.
   * @property {object} settings Gets or sets the project settings.
   * @property {uuid} [settings.domainId] Gets or sets the id of the Domain to
   * use with this project.
   * @property {string} [settings.classificationType] Gets or sets the
   * classification type of the project. Possible values include: 'Multiclass',
   * 'Multilabel'
   * @property {array} [settings.targetExportPlatforms] A list of
   * ExportPlatform that the trained model should be able to support.
   * @property {date} [created] Gets the date this project was created.
   * @property {date} [lastModified] Gets the date this project was last
   * modified.
   * @property {string} [thumbnailUri] Gets the thumbnail url representing the
   * image.
   * @property {boolean} [drModeEnabled] Gets if the DR mode is on.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Project
   *
   * @returns {object} metadata of Project
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Project',
      type: {
        name: 'Composite',
        className: 'Project',
        modelProperties: {
          id: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            nullable: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: true,
            nullable: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          settings: {
            required: true,
            nullable: false,
            serializedName: 'settings',
            type: {
              name: 'Composite',
              className: 'ProjectSettings'
            }
          },
          created: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'DateTime'
            }
          },
          lastModified: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'lastModified',
            type: {
              name: 'DateTime'
            }
          },
          thumbnailUri: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'thumbnailUri',
            type: {
              name: 'String'
            }
          },
          drModeEnabled: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'drModeEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Project;
