/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Shipping details.
 *
 */
class PackageShippingDetails {
  /**
   * Create a PackageShippingDetails.
   * @member {string} [carrierName] Name of the carrier.
   * @member {string} [trackingId] Tracking Id of shipment.
   * @member {string} [trackingUrl] Url where shipment can be tracked.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PackageShippingDetails
   *
   * @returns {object} metadata of PackageShippingDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PackageShippingDetails',
      type: {
        name: 'Composite',
        className: 'PackageShippingDetails',
        modelProperties: {
          carrierName: {
            required: false,
            serializedName: 'carrierName',
            type: {
              name: 'String'
            }
          },
          trackingId: {
            required: false,
            serializedName: 'trackingId',
            type: {
              name: 'String'
            }
          },
          trackingUrl: {
            required: false,
            serializedName: 'trackingUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PackageShippingDetails;
