/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Unencrypted secrets for accessing device.
 *
 */
class UnencryptedSecrets {
  /**
   * Create a UnencryptedSecrets.
   * @member {string} jobName Name of the job.
   * @member {string} [deviceType] The Device Type used in the job. Possible
   * values include: 'Pod', 'Disk', 'Cabinet'
   * @member {object} [jobSecrets] Secrets related to this job.
   * @member {string} [jobSecrets.jobSecretsType] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UnencryptedSecrets
   *
   * @returns {object} metadata of UnencryptedSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UnencryptedSecrets',
      type: {
        name: 'Composite',
        className: 'UnencryptedSecrets',
        modelProperties: {
          jobName: {
            required: true,
            serializedName: 'jobName',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: false,
            serializedName: 'deviceType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Pod', 'Disk', 'Cabinet' ]
            }
          },
          jobSecrets: {
            required: false,
            serializedName: 'jobSecrets',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'jobSecretsType',
                clientName: 'jobSecretsType'
              },
              uberParent: 'JobSecrets',
              className: 'JobSecrets'
            }
          }
        }
      }
    };
  }
}

module.exports = UnencryptedSecrets;
