/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The secrets related to a databox heavy.
 *
 */
class DataBoxHeavySecret {
  /**
   * Create a DataBoxHeavySecret.
   * @member {string} [deviceSerialNumber] Serial number of the assigned
   * device.
   * @member {string} [devicePassword] Password for out of the box experience
   * on device.
   * @member {array} [networkConfigurations] Network configuration of the
   * appliance.
   * @member {string} [encodedValidationCertPubKey] The base 64 encoded public
   * key to authenticate with the device
   * @member {array} [accountCredentialDetails] Per account level access
   * credentials.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataBoxHeavySecret
   *
   * @returns {object} metadata of DataBoxHeavySecret
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataBoxHeavySecret',
      type: {
        name: 'Composite',
        className: 'DataBoxHeavySecret',
        modelProperties: {
          deviceSerialNumber: {
            required: false,
            readOnly: true,
            serializedName: 'deviceSerialNumber',
            type: {
              name: 'String'
            }
          },
          devicePassword: {
            required: false,
            readOnly: true,
            serializedName: 'devicePassword',
            type: {
              name: 'String'
            }
          },
          networkConfigurations: {
            required: false,
            readOnly: true,
            serializedName: 'networkConfigurations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplianceNetworkConfigurationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplianceNetworkConfiguration'
                  }
              }
            }
          },
          encodedValidationCertPubKey: {
            required: false,
            readOnly: true,
            serializedName: 'encodedValidationCertPubKey',
            type: {
              name: 'String'
            }
          },
          accountCredentialDetails: {
            required: false,
            readOnly: true,
            serializedName: 'accountCredentialDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AccountCredentialDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'AccountCredentialDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DataBoxHeavySecret;
