/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Data Catalog.
 *
 * @extends models['Resource']
 */
class ADCCatalog extends models['Resource'] {
  /**
   * Create a ADCCatalog.
   * @member {string} [sku] Azure data catalog SKU. Possible values include:
   * 'Free', 'Standard'
   * @member {number} [units] Azure data catalog units.
   * @member {array} [admins] Azure data catalog admin list.
   * @member {array} [users] Azure data catalog user list.
   * @member {boolean} [successfullyProvisioned] Azure data catalog provision
   * status.
   * @member {boolean} [enableAutomaticUnitAdjustment] Automatic unit
   * adjustment enabled or not.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ADCCatalog
   *
   * @returns {object} metadata of ADCCatalog
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ADCCatalog',
      type: {
        name: 'Composite',
        className: 'ADCCatalog',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'properties.sku',
            type: {
              name: 'String'
            }
          },
          units: {
            required: false,
            serializedName: 'properties.units',
            type: {
              name: 'Number'
            }
          },
          admins: {
            required: false,
            serializedName: 'properties.admins',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PrincipalsElementType',
                  type: {
                    name: 'Composite',
                    className: 'Principals'
                  }
              }
            }
          },
          users: {
            required: false,
            serializedName: 'properties.users',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PrincipalsElementType',
                  type: {
                    name: 'Composite',
                    className: 'Principals'
                  }
              }
            }
          },
          successfullyProvisioned: {
            required: false,
            serializedName: 'properties.successfullyProvisioned',
            type: {
              name: 'Boolean'
            }
          },
          enableAutomaticUnitAdjustment: {
            required: false,
            serializedName: 'properties.enableAutomaticUnitAdjustment',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ADCCatalog;
