/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Dynamics sink.
 *
 * @extends models['CopySink']
 */
class DynamicsSink extends models['CopySink'] {
  /**
   * Create a DynamicsSink.
   * @member {object} [ignoreNullValues] The flag indicating whether ignore
   * null values from input dataset (except key fields) during write operation.
   * Default is false. Type: boolean (or Expression with resultType boolean).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DynamicsSink
   *
   * @returns {object} metadata of DynamicsSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DynamicsSink',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'CopySink',
        className: 'DynamicsSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          writeBehavior: {
            required: true,
            isConstant: true,
            serializedName: 'writeBehavior',
            defaultValue: 'Upsert',
            type: {
              name: 'String'
            }
          },
          ignoreNullValues: {
            required: false,
            serializedName: 'ignoreNullValues',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = DynamicsSink;
