/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.SubResource = require('./subResource');
exports.Expression = require('./expression');
exports.SecretBase = require('./secretBase');
exports.SecureString = require('./secureString');
exports.LinkedServiceReference = require('./linkedServiceReference');
exports.AzureKeyVaultSecretReference = require('./azureKeyVaultSecretReference');
exports.FactoryIdentity = require('./factoryIdentity');
exports.FactoryRepoConfiguration = require('./factoryRepoConfiguration');
exports.Factory = require('./factory');
exports.IntegrationRuntime = require('./integrationRuntime');
exports.IntegrationRuntimeResource = require('./integrationRuntimeResource');
exports.IntegrationRuntimeReference = require('./integrationRuntimeReference');
exports.IntegrationRuntimeStatus = require('./integrationRuntimeStatus');
exports.IntegrationRuntimeStatusResponse = require('./integrationRuntimeStatusResponse');
exports.IntegrationRuntimeStatusListResponse = require('./integrationRuntimeStatusListResponse');
exports.UpdateIntegrationRuntimeRequest = require('./updateIntegrationRuntimeRequest');
exports.UpdateIntegrationRuntimeNodeRequest = require('./updateIntegrationRuntimeNodeRequest');
exports.LinkedIntegrationRuntimeRequest = require('./linkedIntegrationRuntimeRequest');
exports.CreateLinkedIntegrationRuntimeRequest = require('./createLinkedIntegrationRuntimeRequest');
exports.ParameterSpecification = require('./parameterSpecification');
exports.LinkedService = require('./linkedService');
exports.LinkedServiceResource = require('./linkedServiceResource');
exports.DatasetFolder = require('./datasetFolder');
exports.Dataset = require('./dataset');
exports.DatasetResource = require('./datasetResource');
exports.ActivityDependency = require('./activityDependency');
exports.UserProperty = require('./userProperty');
exports.Activity = require('./activity');
exports.VariableSpecification = require('./variableSpecification');
exports.PipelineFolder = require('./pipelineFolder');
exports.PipelineResource = require('./pipelineResource');
exports.Trigger = require('./trigger');
exports.TriggerResource = require('./triggerResource');
exports.CreateRunResponse = require('./createRunResponse');
exports.FactoryVSTSConfiguration = require('./factoryVSTSConfiguration');
exports.FactoryGitHubConfiguration = require('./factoryGitHubConfiguration');
exports.FactoryRepoUpdate = require('./factoryRepoUpdate');
exports.GitHubAccessTokenRequest = require('./gitHubAccessTokenRequest');
exports.GitHubAccessTokenResponse = require('./gitHubAccessTokenResponse');
exports.PipelineReference = require('./pipelineReference');
exports.TriggerPipelineReference = require('./triggerPipelineReference');
exports.FactoryUpdateParameters = require('./factoryUpdateParameters');
exports.DatasetReference = require('./datasetReference');
exports.RunQueryFilter = require('./runQueryFilter');
exports.RunQueryOrderBy = require('./runQueryOrderBy');
exports.RunFilterParameters = require('./runFilterParameters');
exports.PipelineRunInvokedBy = require('./pipelineRunInvokedBy');
exports.PipelineRun = require('./pipelineRun');
exports.PipelineRunsQueryResponse = require('./pipelineRunsQueryResponse');
exports.ActivityRun = require('./activityRun');
exports.ActivityRunsQueryResponse = require('./activityRunsQueryResponse');
exports.TriggerRun = require('./triggerRun');
exports.TriggerRunsQueryResponse = require('./triggerRunsQueryResponse');
exports.RerunTumblingWindowTriggerActionParameters = require('./rerunTumblingWindowTriggerActionParameters');
exports.RerunTumblingWindowTrigger = require('./rerunTumblingWindowTrigger');
exports.RerunTriggerResource = require('./rerunTriggerResource');
exports.OperationDisplay = require('./operationDisplay');
exports.OperationLogSpecification = require('./operationLogSpecification');
exports.OperationMetricAvailability = require('./operationMetricAvailability');
exports.OperationMetricDimension = require('./operationMetricDimension');
exports.OperationMetricSpecification = require('./operationMetricSpecification');
exports.OperationServiceSpecification = require('./operationServiceSpecification');
exports.Operation = require('./operation');
exports.DependencyReference = require('./dependencyReference');
exports.SelfDependencyTumblingWindowTriggerReference = require('./selfDependencyTumblingWindowTriggerReference');
exports.TriggerReference = require('./triggerReference');
exports.TriggerDependencyReference = require('./triggerDependencyReference');
exports.TumblingWindowTriggerDependencyReference = require('./tumblingWindowTriggerDependencyReference');
exports.RetryPolicy = require('./retryPolicy');
exports.TumblingWindowTrigger = require('./tumblingWindowTrigger');
exports.MultiplePipelineTrigger = require('./multiplePipelineTrigger');
exports.BlobEventsTrigger = require('./blobEventsTrigger');
exports.BlobTrigger = require('./blobTrigger');
exports.RecurrenceScheduleOccurrence = require('./recurrenceScheduleOccurrence');
exports.RecurrenceSchedule = require('./recurrenceSchedule');
exports.ScheduleTriggerRecurrence = require('./scheduleTriggerRecurrence');
exports.ScheduleTrigger = require('./scheduleTrigger');
exports.ResponsysLinkedService = require('./responsysLinkedService');
exports.AzureDatabricksLinkedService = require('./azureDatabricksLinkedService');
exports.AzureDataLakeAnalyticsLinkedService = require('./azureDataLakeAnalyticsLinkedService');
exports.ScriptAction = require('./scriptAction');
exports.HDInsightOnDemandLinkedService = require('./hDInsightOnDemandLinkedService');
exports.SalesforceMarketingCloudLinkedService = require('./salesforceMarketingCloudLinkedService');
exports.NetezzaLinkedService = require('./netezzaLinkedService');
exports.VerticaLinkedService = require('./verticaLinkedService');
exports.ZohoLinkedService = require('./zohoLinkedService');
exports.XeroLinkedService = require('./xeroLinkedService');
exports.SquareLinkedService = require('./squareLinkedService');
exports.SparkLinkedService = require('./sparkLinkedService');
exports.ShopifyLinkedService = require('./shopifyLinkedService');
exports.ServiceNowLinkedService = require('./serviceNowLinkedService');
exports.QuickBooksLinkedService = require('./quickBooksLinkedService');
exports.PrestoLinkedService = require('./prestoLinkedService');
exports.PhoenixLinkedService = require('./phoenixLinkedService');
exports.PaypalLinkedService = require('./paypalLinkedService');
exports.MarketoLinkedService = require('./marketoLinkedService');
exports.MariaDBLinkedService = require('./mariaDBLinkedService');
exports.MagentoLinkedService = require('./magentoLinkedService');
exports.JiraLinkedService = require('./jiraLinkedService');
exports.ImpalaLinkedService = require('./impalaLinkedService');
exports.HubspotLinkedService = require('./hubspotLinkedService');
exports.HiveLinkedService = require('./hiveLinkedService');
exports.HBaseLinkedService = require('./hBaseLinkedService');
exports.GreenplumLinkedService = require('./greenplumLinkedService');
exports.GoogleBigQueryLinkedService = require('./googleBigQueryLinkedService');
exports.EloquaLinkedService = require('./eloquaLinkedService');
exports.DrillLinkedService = require('./drillLinkedService');
exports.CouchbaseLinkedService = require('./couchbaseLinkedService');
exports.ConcurLinkedService = require('./concurLinkedService');
exports.AzurePostgreSqlLinkedService = require('./azurePostgreSqlLinkedService');
exports.AmazonMWSLinkedService = require('./amazonMWSLinkedService');
exports.SapHanaLinkedService = require('./sapHanaLinkedService');
exports.SapBWLinkedService = require('./sapBWLinkedService');
exports.SftpServerLinkedService = require('./sftpServerLinkedService');
exports.FtpServerLinkedService = require('./ftpServerLinkedService');
exports.HttpLinkedService = require('./httpLinkedService');
exports.AzureSearchLinkedService = require('./azureSearchLinkedService');
exports.CustomDataSourceLinkedService = require('./customDataSourceLinkedService');
exports.AmazonRedshiftLinkedService = require('./amazonRedshiftLinkedService');
exports.AmazonS3LinkedService = require('./amazonS3LinkedService');
exports.SapEccLinkedService = require('./sapEccLinkedService');
exports.SapCloudForCustomerLinkedService = require('./sapCloudForCustomerLinkedService');
exports.SalesforceLinkedService = require('./salesforceLinkedService');
exports.AzureDataLakeStoreLinkedService = require('./azureDataLakeStoreLinkedService');
exports.MongoDbLinkedService = require('./mongoDbLinkedService');
exports.CassandraLinkedService = require('./cassandraLinkedService');
exports.WebLinkedServiceTypeProperties = require('./webLinkedServiceTypeProperties');
exports.WebClientCertificateAuthentication = require('./webClientCertificateAuthentication');
exports.WebBasicAuthentication = require('./webBasicAuthentication');
exports.WebAnonymousAuthentication = require('./webAnonymousAuthentication');
exports.WebLinkedService = require('./webLinkedService');
exports.ODataLinkedService = require('./oDataLinkedService');
exports.HdfsLinkedService = require('./hdfsLinkedService');
exports.OdbcLinkedService = require('./odbcLinkedService');
exports.AzureMLLinkedService = require('./azureMLLinkedService');
exports.TeradataLinkedService = require('./teradataLinkedService');
exports.Db2LinkedService = require('./db2LinkedService');
exports.SybaseLinkedService = require('./sybaseLinkedService');
exports.PostgreSqlLinkedService = require('./postgreSqlLinkedService');
exports.MySqlLinkedService = require('./mySqlLinkedService');
exports.AzureMySqlLinkedService = require('./azureMySqlLinkedService');
exports.OracleLinkedService = require('./oracleLinkedService');
exports.FileServerLinkedService = require('./fileServerLinkedService');
exports.HDInsightLinkedService = require('./hDInsightLinkedService');
exports.DynamicsLinkedService = require('./dynamicsLinkedService');
exports.CosmosDbLinkedService = require('./cosmosDbLinkedService');
exports.AzureKeyVaultLinkedService = require('./azureKeyVaultLinkedService');
exports.AzureBatchLinkedService = require('./azureBatchLinkedService');
exports.AzureSqlDatabaseLinkedService = require('./azureSqlDatabaseLinkedService');
exports.SqlServerLinkedService = require('./sqlServerLinkedService');
exports.AzureSqlDWLinkedService = require('./azureSqlDWLinkedService');
exports.AzureTableStorageLinkedService = require('./azureTableStorageLinkedService');
exports.AzureBlobStorageLinkedService = require('./azureBlobStorageLinkedService');
exports.AzureStorageLinkedService = require('./azureStorageLinkedService');
exports.ResponsysObjectDataset = require('./responsysObjectDataset');
exports.SalesforceMarketingCloudObjectDataset = require('./salesforceMarketingCloudObjectDataset');
exports.VerticaTableDataset = require('./verticaTableDataset');
exports.NetezzaTableDataset = require('./netezzaTableDataset');
exports.ZohoObjectDataset = require('./zohoObjectDataset');
exports.XeroObjectDataset = require('./xeroObjectDataset');
exports.SquareObjectDataset = require('./squareObjectDataset');
exports.SparkObjectDataset = require('./sparkObjectDataset');
exports.ShopifyObjectDataset = require('./shopifyObjectDataset');
exports.ServiceNowObjectDataset = require('./serviceNowObjectDataset');
exports.QuickBooksObjectDataset = require('./quickBooksObjectDataset');
exports.PrestoObjectDataset = require('./prestoObjectDataset');
exports.PhoenixObjectDataset = require('./phoenixObjectDataset');
exports.PaypalObjectDataset = require('./paypalObjectDataset');
exports.MarketoObjectDataset = require('./marketoObjectDataset');
exports.MariaDBTableDataset = require('./mariaDBTableDataset');
exports.MagentoObjectDataset = require('./magentoObjectDataset');
exports.JiraObjectDataset = require('./jiraObjectDataset');
exports.ImpalaObjectDataset = require('./impalaObjectDataset');
exports.HubspotObjectDataset = require('./hubspotObjectDataset');
exports.HiveObjectDataset = require('./hiveObjectDataset');
exports.HBaseObjectDataset = require('./hBaseObjectDataset');
exports.GreenplumTableDataset = require('./greenplumTableDataset');
exports.GoogleBigQueryObjectDataset = require('./googleBigQueryObjectDataset');
exports.EloquaObjectDataset = require('./eloquaObjectDataset');
exports.DrillTableDataset = require('./drillTableDataset');
exports.CouchbaseTableDataset = require('./couchbaseTableDataset');
exports.ConcurObjectDataset = require('./concurObjectDataset');
exports.AzurePostgreSqlTableDataset = require('./azurePostgreSqlTableDataset');
exports.AmazonMWSObjectDataset = require('./amazonMWSObjectDataset');
exports.DatasetCompression = require('./datasetCompression');
exports.DatasetZipDeflateCompression = require('./datasetZipDeflateCompression');
exports.DatasetDeflateCompression = require('./datasetDeflateCompression');
exports.DatasetGZipCompression = require('./datasetGZipCompression');
exports.DatasetBZip2Compression = require('./datasetBZip2Compression');
exports.DatasetStorageFormat = require('./datasetStorageFormat');
exports.ParquetFormat = require('./parquetFormat');
exports.OrcFormat = require('./orcFormat');
exports.AvroFormat = require('./avroFormat');
exports.JsonFormat = require('./jsonFormat');
exports.TextFormat = require('./textFormat');
exports.HttpDataset = require('./httpDataset');
exports.AzureSearchIndexDataset = require('./azureSearchIndexDataset');
exports.WebTableDataset = require('./webTableDataset');
exports.SqlServerTableDataset = require('./sqlServerTableDataset');
exports.SapEccResourceDataset = require('./sapEccResourceDataset');
exports.SapCloudForCustomerResourceDataset = require('./sapCloudForCustomerResourceDataset');
exports.SalesforceObjectDataset = require('./salesforceObjectDataset');
exports.RelationalTableDataset = require('./relationalTableDataset');
exports.AzureMySqlTableDataset = require('./azureMySqlTableDataset');
exports.OracleTableDataset = require('./oracleTableDataset');
exports.ODataResourceDataset = require('./oDataResourceDataset');
exports.MongoDbCollectionDataset = require('./mongoDbCollectionDataset');
exports.FileShareDataset = require('./fileShareDataset');
exports.AzureDataLakeStoreDataset = require('./azureDataLakeStoreDataset');
exports.DynamicsEntityDataset = require('./dynamicsEntityDataset');
exports.DocumentDbCollectionDataset = require('./documentDbCollectionDataset');
exports.CustomDataset = require('./customDataset');
exports.CassandraTableDataset = require('./cassandraTableDataset');
exports.AzureSqlDWTableDataset = require('./azureSqlDWTableDataset');
exports.AzureSqlTableDataset = require('./azureSqlTableDataset');
exports.AzureTableDataset = require('./azureTableDataset');
exports.AzureBlobDataset = require('./azureBlobDataset');
exports.AmazonS3Dataset = require('./amazonS3Dataset');
exports.ActivityPolicy = require('./activityPolicy');
exports.ExecutionActivity = require('./executionActivity');
exports.DatabricksSparkPythonActivity = require('./databricksSparkPythonActivity');
exports.DatabricksSparkJarActivity = require('./databricksSparkJarActivity');
exports.DatabricksNotebookActivity = require('./databricksNotebookActivity');
exports.DataLakeAnalyticsUSQLActivity = require('./dataLakeAnalyticsUSQLActivity');
exports.AzureMLUpdateResourceActivity = require('./azureMLUpdateResourceActivity');
exports.AzureMLWebServiceFile = require('./azureMLWebServiceFile');
exports.AzureMLBatchExecutionActivity = require('./azureMLBatchExecutionActivity');
exports.GetMetadataActivity = require('./getMetadataActivity');
exports.WebActivityAuthentication = require('./webActivityAuthentication');
exports.WebActivity = require('./webActivity');
exports.RedshiftUnloadSettings = require('./redshiftUnloadSettings');
exports.CopySource = require('./copySource');
exports.AmazonRedshiftSource = require('./amazonRedshiftSource');
exports.ResponsysSource = require('./responsysSource');
exports.SalesforceMarketingCloudSource = require('./salesforceMarketingCloudSource');
exports.VerticaSource = require('./verticaSource');
exports.NetezzaSource = require('./netezzaSource');
exports.ZohoSource = require('./zohoSource');
exports.XeroSource = require('./xeroSource');
exports.SquareSource = require('./squareSource');
exports.SparkSource = require('./sparkSource');
exports.ShopifySource = require('./shopifySource');
exports.ServiceNowSource = require('./serviceNowSource');
exports.QuickBooksSource = require('./quickBooksSource');
exports.PrestoSource = require('./prestoSource');
exports.PhoenixSource = require('./phoenixSource');
exports.PaypalSource = require('./paypalSource');
exports.MarketoSource = require('./marketoSource');
exports.MariaDBSource = require('./mariaDBSource');
exports.MagentoSource = require('./magentoSource');
exports.JiraSource = require('./jiraSource');
exports.ImpalaSource = require('./impalaSource');
exports.HubspotSource = require('./hubspotSource');
exports.HiveSource = require('./hiveSource');
exports.HBaseSource = require('./hBaseSource');
exports.GreenplumSource = require('./greenplumSource');
exports.GoogleBigQuerySource = require('./googleBigQuerySource');
exports.EloquaSource = require('./eloquaSource');
exports.DrillSource = require('./drillSource');
exports.CouchbaseSource = require('./couchbaseSource');
exports.ConcurSource = require('./concurSource');
exports.AzurePostgreSqlSource = require('./azurePostgreSqlSource');
exports.AmazonMWSSource = require('./amazonMWSSource');
exports.HttpSource = require('./httpSource');
exports.AzureDataLakeStoreSource = require('./azureDataLakeStoreSource');
exports.MongoDbSource = require('./mongoDbSource');
exports.CassandraSource = require('./cassandraSource');
exports.WebSource = require('./webSource');
exports.OracleSource = require('./oracleSource');
exports.AzureMySqlSource = require('./azureMySqlSource');
exports.DistcpSettings = require('./distcpSettings');
exports.HdfsSource = require('./hdfsSource');
exports.FileSystemSource = require('./fileSystemSource');
exports.SqlDWSource = require('./sqlDWSource');
exports.StoredProcedureParameter = require('./storedProcedureParameter');
exports.SqlSource = require('./sqlSource');
exports.SapEccSource = require('./sapEccSource');
exports.SapCloudForCustomerSource = require('./sapCloudForCustomerSource');
exports.SalesforceSource = require('./salesforceSource');
exports.RelationalSource = require('./relationalSource');
exports.DynamicsSource = require('./dynamicsSource');
exports.DocumentDbCollectionSource = require('./documentDbCollectionSource');
exports.BlobSource = require('./blobSource');
exports.AzureTableSource = require('./azureTableSource');
exports.LookupActivity = require('./lookupActivity');
exports.DeleteActivity = require('./deleteActivity');
exports.SqlServerStoredProcedureActivity = require('./sqlServerStoredProcedureActivity');
exports.CustomActivityReferenceObject = require('./customActivityReferenceObject');
exports.CustomActivity = require('./customActivity');
exports.SSISPropertyOverride = require('./sSISPropertyOverride');
exports.SSISExecutionParameter = require('./sSISExecutionParameter');
exports.SSISPackageLocation = require('./sSISPackageLocation');
exports.ExecuteSSISPackageActivity = require('./executeSSISPackageActivity');
exports.HDInsightSparkActivity = require('./hDInsightSparkActivity');
exports.HDInsightStreamingActivity = require('./hDInsightStreamingActivity');
exports.HDInsightMapReduceActivity = require('./hDInsightMapReduceActivity');
exports.HDInsightPigActivity = require('./hDInsightPigActivity');
exports.HDInsightHiveActivity = require('./hDInsightHiveActivity');
exports.RedirectIncompatibleRowSettings = require('./redirectIncompatibleRowSettings');
exports.StagingSettings = require('./stagingSettings');
exports.CopyTranslator = require('./copyTranslator');
exports.TabularTranslator = require('./tabularTranslator');
exports.CopySink = require('./copySink');
exports.SalesforceSink = require('./salesforceSink');
exports.DynamicsSink = require('./dynamicsSink');
exports.OdbcSink = require('./odbcSink');
exports.AzureSearchIndexSink = require('./azureSearchIndexSink');
exports.AzureDataLakeStoreSink = require('./azureDataLakeStoreSink');
exports.OracleSink = require('./oracleSink');
exports.PolybaseSettings = require('./polybaseSettings');
exports.SqlDWSink = require('./sqlDWSink');
exports.SqlSink = require('./sqlSink');
exports.DocumentDbCollectionSink = require('./documentDbCollectionSink');
exports.FileSystemSink = require('./fileSystemSink');
exports.BlobSink = require('./blobSink');
exports.AzureTableSink = require('./azureTableSink');
exports.AzureQueueSink = require('./azureQueueSink');
exports.SapCloudForCustomerSink = require('./sapCloudForCustomerSink');
exports.CopyActivity = require('./copyActivity');
exports.ControlActivity = require('./controlActivity');
exports.AppendVariableActivity = require('./appendVariableActivity');
exports.SetVariableActivity = require('./setVariableActivity');
exports.FilterActivity = require('./filterActivity');
exports.UntilActivity = require('./untilActivity');
exports.WaitActivity = require('./waitActivity');
exports.ForEachActivity = require('./forEachActivity');
exports.IfConditionActivity = require('./ifConditionActivity');
exports.ExecutePipelineActivity = require('./executePipelineActivity');
exports.LinkedIntegrationRuntime = require('./linkedIntegrationRuntime');
exports.SelfHostedIntegrationRuntimeNode = require('./selfHostedIntegrationRuntimeNode');
exports.SelfHostedIntegrationRuntimeStatus = require('./selfHostedIntegrationRuntimeStatus');
exports.ManagedIntegrationRuntimeOperationResult = require('./managedIntegrationRuntimeOperationResult');
exports.ManagedIntegrationRuntimeError = require('./managedIntegrationRuntimeError');
exports.ManagedIntegrationRuntimeNode = require('./managedIntegrationRuntimeNode');
exports.ManagedIntegrationRuntimeStatus = require('./managedIntegrationRuntimeStatus');
exports.LinkedIntegrationRuntimeType = require('./linkedIntegrationRuntimeType');
exports.LinkedIntegrationRuntimeRbacAuthorization = require('./linkedIntegrationRuntimeRbacAuthorization');
exports.LinkedIntegrationRuntimeKeyAuthorization = require('./linkedIntegrationRuntimeKeyAuthorization');
exports.SelfHostedIntegrationRuntime = require('./selfHostedIntegrationRuntime');
exports.IntegrationRuntimeCustomSetupScriptProperties = require('./integrationRuntimeCustomSetupScriptProperties');
exports.IntegrationRuntimeSsisCatalogInfo = require('./integrationRuntimeSsisCatalogInfo');
exports.IntegrationRuntimeSsisProperties = require('./integrationRuntimeSsisProperties');
exports.IntegrationRuntimeVNetProperties = require('./integrationRuntimeVNetProperties');
exports.IntegrationRuntimeComputeProperties = require('./integrationRuntimeComputeProperties');
exports.ManagedIntegrationRuntime = require('./managedIntegrationRuntime');
exports.IntegrationRuntimeNodeIpAddress = require('./integrationRuntimeNodeIpAddress');
exports.IntegrationRuntimeNodeMonitoringData = require('./integrationRuntimeNodeMonitoringData');
exports.IntegrationRuntimeMonitoringData = require('./integrationRuntimeMonitoringData');
exports.IntegrationRuntimeAuthKeys = require('./integrationRuntimeAuthKeys');
exports.IntegrationRuntimeRegenerateKeyParameters = require('./integrationRuntimeRegenerateKeyParameters');
exports.IntegrationRuntimeConnectionInfo = require('./integrationRuntimeConnectionInfo');
exports.OperationListResponse = require('./operationListResponse');
exports.FactoryListResponse = require('./factoryListResponse');
exports.IntegrationRuntimeListResponse = require('./integrationRuntimeListResponse');
exports.LinkedServiceListResponse = require('./linkedServiceListResponse');
exports.DatasetListResponse = require('./datasetListResponse');
exports.PipelineListResponse = require('./pipelineListResponse');
exports.TriggerListResponse = require('./triggerListResponse');
exports.RerunTriggerListResponse = require('./rerunTriggerListResponse');
exports.discriminators = {
  'SecretBase.SecureString' : exports.SecureString,
  'SecretBase.AzureKeyVaultSecret' : exports.AzureKeyVaultSecretReference,
  'SecretBase' : exports.SecretBase,
  'FactoryRepoConfiguration' : exports.FactoryRepoConfiguration,
  'IntegrationRuntime' : exports.IntegrationRuntime,
  'IntegrationRuntimeStatus' : exports.IntegrationRuntimeStatus,
  'LinkedService' : exports.LinkedService,
  'Dataset' : exports.Dataset,
  'Activity' : exports.Activity,
  'Trigger' : exports.Trigger,
  'FactoryRepoConfiguration.FactoryVSTSConfiguration' : exports.FactoryVSTSConfiguration,
  'FactoryRepoConfiguration.FactoryGitHubConfiguration' : exports.FactoryGitHubConfiguration,
  'Trigger.RerunTumblingWindowTrigger' : exports.RerunTumblingWindowTrigger,
  'DependencyReference.SelfDependencyTumblingWindowTriggerReference' : exports.SelfDependencyTumblingWindowTriggerReference,
  'DependencyReference.TumblingWindowTriggerDependencyReference' : exports.TumblingWindowTriggerDependencyReference,
  'DependencyReference.TriggerDependencyReference' : exports.TriggerDependencyReference,
  'DependencyReference' : exports.DependencyReference,
  'Trigger.TumblingWindowTrigger' : exports.TumblingWindowTrigger,
  'Trigger.BlobEventsTrigger' : exports.BlobEventsTrigger,
  'Trigger.BlobTrigger' : exports.BlobTrigger,
  'Trigger.ScheduleTrigger' : exports.ScheduleTrigger,
  'Trigger.MultiplePipelineTrigger' : exports.MultiplePipelineTrigger,
  'LinkedService.Responsys' : exports.ResponsysLinkedService,
  'LinkedService.AzureDatabricks' : exports.AzureDatabricksLinkedService,
  'LinkedService.AzureDataLakeAnalytics' : exports.AzureDataLakeAnalyticsLinkedService,
  'LinkedService.HDInsightOnDemand' : exports.HDInsightOnDemandLinkedService,
  'LinkedService.SalesforceMarketingCloud' : exports.SalesforceMarketingCloudLinkedService,
  'LinkedService.Netezza' : exports.NetezzaLinkedService,
  'LinkedService.Vertica' : exports.VerticaLinkedService,
  'LinkedService.Zoho' : exports.ZohoLinkedService,
  'LinkedService.Xero' : exports.XeroLinkedService,
  'LinkedService.Square' : exports.SquareLinkedService,
  'LinkedService.Spark' : exports.SparkLinkedService,
  'LinkedService.Shopify' : exports.ShopifyLinkedService,
  'LinkedService.ServiceNow' : exports.ServiceNowLinkedService,
  'LinkedService.QuickBooks' : exports.QuickBooksLinkedService,
  'LinkedService.Presto' : exports.PrestoLinkedService,
  'LinkedService.Phoenix' : exports.PhoenixLinkedService,
  'LinkedService.Paypal' : exports.PaypalLinkedService,
  'LinkedService.Marketo' : exports.MarketoLinkedService,
  'LinkedService.MariaDB' : exports.MariaDBLinkedService,
  'LinkedService.Magento' : exports.MagentoLinkedService,
  'LinkedService.Jira' : exports.JiraLinkedService,
  'LinkedService.Impala' : exports.ImpalaLinkedService,
  'LinkedService.Hubspot' : exports.HubspotLinkedService,
  'LinkedService.Hive' : exports.HiveLinkedService,
  'LinkedService.HBase' : exports.HBaseLinkedService,
  'LinkedService.Greenplum' : exports.GreenplumLinkedService,
  'LinkedService.GoogleBigQuery' : exports.GoogleBigQueryLinkedService,
  'LinkedService.Eloqua' : exports.EloquaLinkedService,
  'LinkedService.Drill' : exports.DrillLinkedService,
  'LinkedService.Couchbase' : exports.CouchbaseLinkedService,
  'LinkedService.Concur' : exports.ConcurLinkedService,
  'LinkedService.AzurePostgreSql' : exports.AzurePostgreSqlLinkedService,
  'LinkedService.AmazonMWS' : exports.AmazonMWSLinkedService,
  'LinkedService.SapHana' : exports.SapHanaLinkedService,
  'LinkedService.SapBW' : exports.SapBWLinkedService,
  'LinkedService.Sftp' : exports.SftpServerLinkedService,
  'LinkedService.FtpServer' : exports.FtpServerLinkedService,
  'LinkedService.HttpServer' : exports.HttpLinkedService,
  'LinkedService.AzureSearch' : exports.AzureSearchLinkedService,
  'LinkedService.CustomDataSource' : exports.CustomDataSourceLinkedService,
  'LinkedService.AmazonRedshift' : exports.AmazonRedshiftLinkedService,
  'LinkedService.AmazonS3' : exports.AmazonS3LinkedService,
  'LinkedService.SapEcc' : exports.SapEccLinkedService,
  'LinkedService.SapCloudForCustomer' : exports.SapCloudForCustomerLinkedService,
  'LinkedService.Salesforce' : exports.SalesforceLinkedService,
  'LinkedService.AzureDataLakeStore' : exports.AzureDataLakeStoreLinkedService,
  'LinkedService.MongoDb' : exports.MongoDbLinkedService,
  'LinkedService.Cassandra' : exports.CassandraLinkedService,
  'WebLinkedServiceTypeProperties.ClientCertificate' : exports.WebClientCertificateAuthentication,
  'WebLinkedServiceTypeProperties.Basic' : exports.WebBasicAuthentication,
  'WebLinkedServiceTypeProperties.Anonymous' : exports.WebAnonymousAuthentication,
  'WebLinkedServiceTypeProperties' : exports.WebLinkedServiceTypeProperties,
  'LinkedService.Web' : exports.WebLinkedService,
  'LinkedService.OData' : exports.ODataLinkedService,
  'LinkedService.Hdfs' : exports.HdfsLinkedService,
  'LinkedService.Odbc' : exports.OdbcLinkedService,
  'LinkedService.AzureML' : exports.AzureMLLinkedService,
  'LinkedService.Teradata' : exports.TeradataLinkedService,
  'LinkedService.Db2' : exports.Db2LinkedService,
  'LinkedService.Sybase' : exports.SybaseLinkedService,
  'LinkedService.PostgreSql' : exports.PostgreSqlLinkedService,
  'LinkedService.MySql' : exports.MySqlLinkedService,
  'LinkedService.AzureMySql' : exports.AzureMySqlLinkedService,
  'LinkedService.Oracle' : exports.OracleLinkedService,
  'LinkedService.FileServer' : exports.FileServerLinkedService,
  'LinkedService.HDInsight' : exports.HDInsightLinkedService,
  'LinkedService.Dynamics' : exports.DynamicsLinkedService,
  'LinkedService.CosmosDb' : exports.CosmosDbLinkedService,
  'LinkedService.AzureKeyVault' : exports.AzureKeyVaultLinkedService,
  'LinkedService.AzureBatch' : exports.AzureBatchLinkedService,
  'LinkedService.AzureSqlDatabase' : exports.AzureSqlDatabaseLinkedService,
  'LinkedService.SqlServer' : exports.SqlServerLinkedService,
  'LinkedService.AzureSqlDW' : exports.AzureSqlDWLinkedService,
  'LinkedService.AzureTableStorage' : exports.AzureTableStorageLinkedService,
  'LinkedService.AzureBlobStorage' : exports.AzureBlobStorageLinkedService,
  'LinkedService.AzureStorage' : exports.AzureStorageLinkedService,
  'Dataset.ResponsysObject' : exports.ResponsysObjectDataset,
  'Dataset.SalesforceMarketingCloudObject' : exports.SalesforceMarketingCloudObjectDataset,
  'Dataset.VerticaTable' : exports.VerticaTableDataset,
  'Dataset.NetezzaTable' : exports.NetezzaTableDataset,
  'Dataset.ZohoObject' : exports.ZohoObjectDataset,
  'Dataset.XeroObject' : exports.XeroObjectDataset,
  'Dataset.SquareObject' : exports.SquareObjectDataset,
  'Dataset.SparkObject' : exports.SparkObjectDataset,
  'Dataset.ShopifyObject' : exports.ShopifyObjectDataset,
  'Dataset.ServiceNowObject' : exports.ServiceNowObjectDataset,
  'Dataset.QuickBooksObject' : exports.QuickBooksObjectDataset,
  'Dataset.PrestoObject' : exports.PrestoObjectDataset,
  'Dataset.PhoenixObject' : exports.PhoenixObjectDataset,
  'Dataset.PaypalObject' : exports.PaypalObjectDataset,
  'Dataset.MarketoObject' : exports.MarketoObjectDataset,
  'Dataset.MariaDBTable' : exports.MariaDBTableDataset,
  'Dataset.MagentoObject' : exports.MagentoObjectDataset,
  'Dataset.JiraObject' : exports.JiraObjectDataset,
  'Dataset.ImpalaObject' : exports.ImpalaObjectDataset,
  'Dataset.HubspotObject' : exports.HubspotObjectDataset,
  'Dataset.HiveObject' : exports.HiveObjectDataset,
  'Dataset.HBaseObject' : exports.HBaseObjectDataset,
  'Dataset.GreenplumTable' : exports.GreenplumTableDataset,
  'Dataset.GoogleBigQueryObject' : exports.GoogleBigQueryObjectDataset,
  'Dataset.EloquaObject' : exports.EloquaObjectDataset,
  'Dataset.DrillTable' : exports.DrillTableDataset,
  'Dataset.CouchbaseTable' : exports.CouchbaseTableDataset,
  'Dataset.ConcurObject' : exports.ConcurObjectDataset,
  'Dataset.AzurePostgreSqlTable' : exports.AzurePostgreSqlTableDataset,
  'Dataset.AmazonMWSObject' : exports.AmazonMWSObjectDataset,
  'DatasetCompression.ZipDeflate' : exports.DatasetZipDeflateCompression,
  'DatasetCompression.Deflate' : exports.DatasetDeflateCompression,
  'DatasetCompression.GZip' : exports.DatasetGZipCompression,
  'DatasetCompression.BZip2' : exports.DatasetBZip2Compression,
  'DatasetCompression' : exports.DatasetCompression,
  'DatasetStorageFormat.ParquetFormat' : exports.ParquetFormat,
  'DatasetStorageFormat.OrcFormat' : exports.OrcFormat,
  'DatasetStorageFormat.AvroFormat' : exports.AvroFormat,
  'DatasetStorageFormat.JsonFormat' : exports.JsonFormat,
  'DatasetStorageFormat.TextFormat' : exports.TextFormat,
  'DatasetStorageFormat' : exports.DatasetStorageFormat,
  'Dataset.HttpFile' : exports.HttpDataset,
  'Dataset.AzureSearchIndex' : exports.AzureSearchIndexDataset,
  'Dataset.WebTable' : exports.WebTableDataset,
  'Dataset.SqlServerTable' : exports.SqlServerTableDataset,
  'Dataset.SapEccResource' : exports.SapEccResourceDataset,
  'Dataset.SapCloudForCustomerResource' : exports.SapCloudForCustomerResourceDataset,
  'Dataset.SalesforceObject' : exports.SalesforceObjectDataset,
  'Dataset.RelationalTable' : exports.RelationalTableDataset,
  'Dataset.AzureMySqlTable' : exports.AzureMySqlTableDataset,
  'Dataset.OracleTable' : exports.OracleTableDataset,
  'Dataset.ODataResource' : exports.ODataResourceDataset,
  'Dataset.MongoDbCollection' : exports.MongoDbCollectionDataset,
  'Dataset.FileShare' : exports.FileShareDataset,
  'Dataset.AzureDataLakeStoreFile' : exports.AzureDataLakeStoreDataset,
  'Dataset.DynamicsEntity' : exports.DynamicsEntityDataset,
  'Dataset.DocumentDbCollection' : exports.DocumentDbCollectionDataset,
  'Dataset.CustomDataset' : exports.CustomDataset,
  'Dataset.CassandraTable' : exports.CassandraTableDataset,
  'Dataset.AzureSqlDWTable' : exports.AzureSqlDWTableDataset,
  'Dataset.AzureSqlTable' : exports.AzureSqlTableDataset,
  'Dataset.AzureTable' : exports.AzureTableDataset,
  'Dataset.AzureBlob' : exports.AzureBlobDataset,
  'Dataset.AmazonS3Object' : exports.AmazonS3Dataset,
  'Activity.DatabricksSparkPython' : exports.DatabricksSparkPythonActivity,
  'Activity.DatabricksSparkJar' : exports.DatabricksSparkJarActivity,
  'Activity.DatabricksNotebook' : exports.DatabricksNotebookActivity,
  'Activity.DataLakeAnalyticsU-SQL' : exports.DataLakeAnalyticsUSQLActivity,
  'Activity.AzureMLUpdateResource' : exports.AzureMLUpdateResourceActivity,
  'Activity.AzureMLBatchExecution' : exports.AzureMLBatchExecutionActivity,
  'Activity.GetMetadata' : exports.GetMetadataActivity,
  'Activity.WebActivity' : exports.WebActivity,
  'CopySource.AmazonRedshiftSource' : exports.AmazonRedshiftSource,
  'CopySource.ResponsysSource' : exports.ResponsysSource,
  'CopySource.SalesforceMarketingCloudSource' : exports.SalesforceMarketingCloudSource,
  'CopySource.VerticaSource' : exports.VerticaSource,
  'CopySource.NetezzaSource' : exports.NetezzaSource,
  'CopySource.ZohoSource' : exports.ZohoSource,
  'CopySource.XeroSource' : exports.XeroSource,
  'CopySource.SquareSource' : exports.SquareSource,
  'CopySource.SparkSource' : exports.SparkSource,
  'CopySource.ShopifySource' : exports.ShopifySource,
  'CopySource.ServiceNowSource' : exports.ServiceNowSource,
  'CopySource.QuickBooksSource' : exports.QuickBooksSource,
  'CopySource.PrestoSource' : exports.PrestoSource,
  'CopySource.PhoenixSource' : exports.PhoenixSource,
  'CopySource.PaypalSource' : exports.PaypalSource,
  'CopySource.MarketoSource' : exports.MarketoSource,
  'CopySource.MariaDBSource' : exports.MariaDBSource,
  'CopySource.MagentoSource' : exports.MagentoSource,
  'CopySource.JiraSource' : exports.JiraSource,
  'CopySource.ImpalaSource' : exports.ImpalaSource,
  'CopySource.HubspotSource' : exports.HubspotSource,
  'CopySource.HiveSource' : exports.HiveSource,
  'CopySource.HBaseSource' : exports.HBaseSource,
  'CopySource.GreenplumSource' : exports.GreenplumSource,
  'CopySource.GoogleBigQuerySource' : exports.GoogleBigQuerySource,
  'CopySource.EloquaSource' : exports.EloquaSource,
  'CopySource.DrillSource' : exports.DrillSource,
  'CopySource.CouchbaseSource' : exports.CouchbaseSource,
  'CopySource.ConcurSource' : exports.ConcurSource,
  'CopySource.AzurePostgreSqlSource' : exports.AzurePostgreSqlSource,
  'CopySource.AmazonMWSSource' : exports.AmazonMWSSource,
  'CopySource.HttpSource' : exports.HttpSource,
  'CopySource.AzureDataLakeStoreSource' : exports.AzureDataLakeStoreSource,
  'CopySource.MongoDbSource' : exports.MongoDbSource,
  'CopySource.CassandraSource' : exports.CassandraSource,
  'CopySource.WebSource' : exports.WebSource,
  'CopySource.OracleSource' : exports.OracleSource,
  'CopySource.AzureMySqlSource' : exports.AzureMySqlSource,
  'CopySource.HdfsSource' : exports.HdfsSource,
  'CopySource.FileSystemSource' : exports.FileSystemSource,
  'CopySource.SqlDWSource' : exports.SqlDWSource,
  'CopySource.SqlSource' : exports.SqlSource,
  'CopySource.SapEccSource' : exports.SapEccSource,
  'CopySource.SapCloudForCustomerSource' : exports.SapCloudForCustomerSource,
  'CopySource.SalesforceSource' : exports.SalesforceSource,
  'CopySource.RelationalSource' : exports.RelationalSource,
  'CopySource.DynamicsSource' : exports.DynamicsSource,
  'CopySource.DocumentDbCollectionSource' : exports.DocumentDbCollectionSource,
  'CopySource.BlobSource' : exports.BlobSource,
  'CopySource.AzureTableSource' : exports.AzureTableSource,
  'CopySource' : exports.CopySource,
  'Activity.Lookup' : exports.LookupActivity,
  'Activity.Delete' : exports.DeleteActivity,
  'Activity.SqlServerStoredProcedure' : exports.SqlServerStoredProcedureActivity,
  'Activity.Custom' : exports.CustomActivity,
  'Activity.ExecuteSSISPackage' : exports.ExecuteSSISPackageActivity,
  'Activity.HDInsightSpark' : exports.HDInsightSparkActivity,
  'Activity.HDInsightStreaming' : exports.HDInsightStreamingActivity,
  'Activity.HDInsightMapReduce' : exports.HDInsightMapReduceActivity,
  'Activity.HDInsightPig' : exports.HDInsightPigActivity,
  'Activity.HDInsightHive' : exports.HDInsightHiveActivity,
  'CopyTranslator.TabularTranslator' : exports.TabularTranslator,
  'CopyTranslator' : exports.CopyTranslator,
  'CopySink.SalesforceSink' : exports.SalesforceSink,
  'CopySink.DynamicsSink' : exports.DynamicsSink,
  'CopySink.OdbcSink' : exports.OdbcSink,
  'CopySink.AzureSearchIndexSink' : exports.AzureSearchIndexSink,
  'CopySink.AzureDataLakeStoreSink' : exports.AzureDataLakeStoreSink,
  'CopySink.OracleSink' : exports.OracleSink,
  'CopySink.SqlDWSink' : exports.SqlDWSink,
  'CopySink.SqlSink' : exports.SqlSink,
  'CopySink.DocumentDbCollectionSink' : exports.DocumentDbCollectionSink,
  'CopySink.FileSystemSink' : exports.FileSystemSink,
  'CopySink.BlobSink' : exports.BlobSink,
  'CopySink.AzureTableSink' : exports.AzureTableSink,
  'CopySink.AzureQueueSink' : exports.AzureQueueSink,
  'CopySink.SapCloudForCustomerSink' : exports.SapCloudForCustomerSink,
  'CopySink' : exports.CopySink,
  'Activity.Copy' : exports.CopyActivity,
  'Activity.Execution' : exports.ExecutionActivity,
  'Activity.AppendVariable' : exports.AppendVariableActivity,
  'Activity.SetVariable' : exports.SetVariableActivity,
  'Activity.Filter' : exports.FilterActivity,
  'Activity.Until' : exports.UntilActivity,
  'Activity.Wait' : exports.WaitActivity,
  'Activity.ForEach' : exports.ForEachActivity,
  'Activity.IfCondition' : exports.IfConditionActivity,
  'Activity.ExecutePipeline' : exports.ExecutePipelineActivity,
  'Activity.Container' : exports.ControlActivity,
  'IntegrationRuntimeStatus.SelfHosted' : exports.SelfHostedIntegrationRuntimeStatus,
  'IntegrationRuntimeStatus.Managed' : exports.ManagedIntegrationRuntimeStatus,
  'LinkedIntegrationRuntimeType.RBAC' : exports.LinkedIntegrationRuntimeRbacAuthorization,
  'LinkedIntegrationRuntimeType.Key' : exports.LinkedIntegrationRuntimeKeyAuthorization,
  'LinkedIntegrationRuntimeType' : exports.LinkedIntegrationRuntimeType,
  'IntegrationRuntime.SelfHosted' : exports.SelfHostedIntegrationRuntime,
  'IntegrationRuntime.Managed' : exports.ManagedIntegrationRuntime
};
