/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Custom setup script properties for a managed dedicated integration runtime.
 *
 */
class IntegrationRuntimeCustomSetupScriptProperties {
  /**
   * Create a IntegrationRuntimeCustomSetupScriptProperties.
   * @member {string} [blobContainerUri] The URI of the Azure blob container
   * that contains the custom setup script.
   * @member {object} [sasToken] The SAS token of the Azure blob container.
   * @member {string} [sasToken.value] Value of secure string.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeCustomSetupScriptProperties
   *
   * @returns {object} metadata of IntegrationRuntimeCustomSetupScriptProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeCustomSetupScriptProperties',
      type: {
        name: 'Composite',
        className: 'IntegrationRuntimeCustomSetupScriptProperties',
        modelProperties: {
          blobContainerUri: {
            required: false,
            serializedName: 'blobContainerUri',
            type: {
              name: 'String'
            }
          },
          sasToken: {
            required: false,
            serializedName: 'sasToken',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'SecretBase',
              className: 'SecureString'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeCustomSetupScriptProperties;
