/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity Rest service source.
 *
 * @extends models['CopySource']
 */
class RestServiceSource extends models['CopySource'] {
  /**
   * Create a RestServiceSource.
   * @member {object} [httpRequestTimeout] The timeout (TimeSpan) to get an
   * HTTP response.  It is the timeout to get a response, not the timeout to
   * read response data.  Default value: 00:01:40. Type: string (or Expression
   * with resultType string), pattern:
   * ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).
   * @member {object} [requestInterval] The time to await before sending next
   * page request.  Default value: 00:00:01. Type: string (or Expression with
   * resultType string), pattern:
   * ((\d+)\.)?(\d\d):(60|([0-5][0-9])):(60|([0-5][0-9])).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RestServiceSource
   *
   * @returns {object} metadata of RestServiceSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestServiceSource',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'CopySource',
        className: 'RestServiceSource',
        modelProperties: {
          sourceRetryCount: {
            required: false,
            serializedName: 'sourceRetryCount',
            type: {
              name: 'Object'
            }
          },
          sourceRetryWait: {
            required: false,
            serializedName: 'sourceRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          httpRequestTimeout: {
            required: false,
            serializedName: 'httpRequestTimeout',
            type: {
              name: 'Object'
            }
          },
          requestInterval: {
            required: false,
            serializedName: 'requestInterval',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = RestServiceSource;
