/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity SAP Cloud for Customer sink.
 *
 * @extends models['CopySink']
 */
class SapCloudForCustomerSink extends models['CopySink'] {
  /**
   * Create a SapCloudForCustomerSink.
   * @member {string} [writeBehavior] The write behavior for the operation.
   * Default is 'Insert'. Possible values include: 'Insert', 'Update'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SapCloudForCustomerSink
   *
   * @returns {object} metadata of SapCloudForCustomerSink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SapCloudForCustomerSink',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'CopySink',
        className: 'SapCloudForCustomerSink',
        modelProperties: {
          writeBatchSize: {
            required: false,
            serializedName: 'writeBatchSize',
            type: {
              name: 'Object'
            }
          },
          writeBatchTimeout: {
            required: false,
            serializedName: 'writeBatchTimeout',
            type: {
              name: 'Object'
            }
          },
          sinkRetryCount: {
            required: false,
            serializedName: 'sinkRetryCount',
            type: {
              name: 'Object'
            }
          },
          sinkRetryWait: {
            required: false,
            serializedName: 'sinkRetryWait',
            type: {
              name: 'Object'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          writeBehavior: {
            required: false,
            serializedName: 'writeBehavior',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SapCloudForCustomerSink;
