/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Data Lake Store account name availability result information.
 *
 */
class NameAvailabilityInformation {
  /**
   * Create a NameAvailabilityInformation.
   * @property {boolean} [nameAvailable] The Boolean value of true or false to
   * indicate whether the Data Lake Store account name is available or not.
   * @property {string} [reason] The reason why the Data Lake Store account
   * name is not available, if nameAvailable is false.
   * @property {string} [message] The message describing why the Data Lake
   * Store account name is not available, if nameAvailable is false.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NameAvailabilityInformation
   *
   * @returns {object} metadata of NameAvailabilityInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NameAvailabilityInformation',
      type: {
        name: 'Composite',
        className: 'NameAvailabilityInformation',
        modelProperties: {
          nameAvailable: {
            required: false,
            readOnly: true,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            readOnly: true,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NameAvailabilityInformation;
