/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a VerificationCodeResponseProperties.
 */
class VerificationCodeResponseProperties {
  /**
   * Create a VerificationCodeResponseProperties.
   * @member {string} [verificationCode] Verification code.
   * @member {string} [subject] Certificate subject.
   * @member {string} [expiry] Code expiry.
   * @member {string} [thumbprint] Certificate thumbprint.
   * @member {boolean} [isVerified] Indicate if the certificate is verified by
   * owner of private key.
   * @member {string} [created] Certificate created time.
   * @member {string} [updated] Certificate updated time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VerificationCodeResponseProperties
   *
   * @returns {object} metadata of VerificationCodeResponseProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VerificationCodeResponse_properties',
      type: {
        name: 'Composite',
        className: 'VerificationCodeResponseProperties',
        modelProperties: {
          verificationCode: {
            required: false,
            serializedName: 'verificationCode',
            type: {
              name: 'String'
            }
          },
          subject: {
            required: false,
            serializedName: 'subject',
            type: {
              name: 'String'
            }
          },
          expiry: {
            required: false,
            serializedName: 'expiry',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            serializedName: 'thumbprint',
            type: {
              name: 'String'
            }
          },
          isVerified: {
            required: false,
            serializedName: 'isVerified',
            type: {
              name: 'Boolean'
            }
          },
          created: {
            required: false,
            serializedName: 'created',
            type: {
              name: 'String'
            }
          },
          updated: {
            required: false,
            serializedName: 'updated',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VerificationCodeResponseProperties;
