/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a KubernetesConnectionDetails.
 * @extends models['OrchestratorSpecificConnectionDetails']
 */
class KubernetesConnectionDetails extends models['OrchestratorSpecificConnectionDetails'] {
  /**
   * Create a KubernetesConnectionDetails.
   * @member {string} [kubeConfig] Gets the kubeconfig for the cluster.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of KubernetesConnectionDetails
   *
   * @returns {object} metadata of KubernetesConnectionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Kubernetes',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'instanceType',
          clientName: 'instanceType'
        },
        uberParent: 'OrchestratorSpecificConnectionDetails',
        className: 'KubernetesConnectionDetails',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          kubeConfig: {
            required: false,
            serializedName: 'kubeConfig',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KubernetesConnectionDetails;
