/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a ContractualRulesAttribution.
 * @extends models['ContractualRulesContractualRule']
 */
class ContractualRulesAttribution extends models['ContractualRulesContractualRule'] {
  /**
   * Create a ContractualRulesAttribution.
   * @property {boolean} [mustBeCloseToContent] A Boolean value that determines
   * whether the contents of the rule must be placed in close proximity to the
   * field that the rule applies to. If true, the contents must be placed in
   * close proximity. If false, or this field does not exist, the contents may
   * be placed at the caller's discretion.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContractualRulesAttribution
   *
   * @returns {object} metadata of ContractualRulesAttribution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContractualRules/Attribution',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ContractualRulesContractualRule',
        className: 'ContractualRulesAttribution',
        modelProperties: {
          targetPropertyName: {
            required: false,
            readOnly: true,
            serializedName: 'targetPropertyName',
            type: {
              name: 'String'
            }
          },
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          mustBeCloseToContent: {
            required: false,
            readOnly: true,
            serializedName: 'mustBeCloseToContent',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ContractualRulesAttribution;
