/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a contractual rule for media attribution.
 *
 * @extends models['ContractualRulesAttribution']
 */
class ContractualRulesMediaAttribution extends models['ContractualRulesAttribution'] {
  /**
   * Create a ContractualRulesMediaAttribution.
   * @property {string} [url] The URL that you use to create of hyperlink of
   * the media content. For example, if the target is an image, you would use
   * the URL to make the image clickable.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContractualRulesMediaAttribution
   *
   * @returns {object} metadata of ContractualRulesMediaAttribution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContractualRules/MediaAttribution',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ContractualRulesContractualRule',
        className: 'ContractualRulesMediaAttribution',
        modelProperties: {
          targetPropertyName: {
            required: false,
            readOnly: true,
            serializedName: 'targetPropertyName',
            type: {
              name: 'String'
            }
          },
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          mustBeCloseToContent: {
            required: false,
            readOnly: true,
            serializedName: 'mustBeCloseToContent',
            type: {
              name: 'Boolean'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContractualRulesMediaAttribution;
