/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A portion of the properties that can be written only by the application
 * back-end, and read by the device.
 *
 */
class DeviceTwinProperties {
  /**
   * Create a DeviceTwinProperties.
   * @member {object} [metadata] Metadata information for the properties JSON
   * document.
   * @member {string} [metadata.lastUpdated] The ISO8601 timestamp of the last
   * time the properties were updated.
   * @member {number} [version] Version of device twin properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceTwinProperties
   *
   * @returns {object} metadata of DeviceTwinProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceTwinProperties',
      type: {
        name: 'Composite',
        className: 'DeviceTwinProperties',
        modelProperties: {
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'DeviceTwinMetadata'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceTwinProperties;
