/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema of the Data property of an EventGridEvent for an
 * Microsoft.Resources.ResourceDeleteCancel event. This is raised when a
 * resource delete operation is canceled.
 *
 */
class ResourceDeleteCancelData {
  /**
   * Create a ResourceDeleteCancelData.
   * @member {string} [tenantId] The tenant ID of the resource.
   * @member {string} [subscriptionId] The subscription ID of the resource.
   * @member {string} [resourceGroup] The resource group of the resource.
   * @member {string} [resourceProvider] The resource provider performing the
   * operation.
   * @member {string} [resourceUri] The URI of the resource in the operation.
   * @member {string} [operationName] The operation that was performed.
   * @member {string} [status] The status of the operation.
   * @member {string} [authorization] The requested authorization for the
   * operation.
   * @member {string} [claims] The properties of the claims.
   * @member {string} [correlationId] An operation ID used for troubleshooting.
   * @member {string} [httpRequest] The details of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceDeleteCancelData
   *
   * @returns {object} metadata of ResourceDeleteCancelData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceDeleteCancelData',
      type: {
        name: 'Composite',
        className: 'ResourceDeleteCancelData',
        modelProperties: {
          tenantId: {
            required: false,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          subscriptionId: {
            required: false,
            serializedName: 'subscriptionId',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: false,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          },
          resourceProvider: {
            required: false,
            serializedName: 'resourceProvider',
            type: {
              name: 'String'
            }
          },
          resourceUri: {
            required: false,
            serializedName: 'resourceUri',
            type: {
              name: 'String'
            }
          },
          operationName: {
            required: false,
            serializedName: 'operationName',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          authorization: {
            required: false,
            serializedName: 'authorization',
            type: {
              name: 'String'
            }
          },
          claims: {
            required: false,
            serializedName: 'claims',
            type: {
              name: 'String'
            }
          },
          correlationId: {
            required: false,
            serializedName: 'correlationId',
            type: {
              name: 'String'
            }
          },
          httpRequest: {
            required: false,
            serializedName: 'httpRequest',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceDeleteCancelData;
