/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents an operation returned by the GetOperations request
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @property {string} [name] Name of the operation
   * @property {object} [display] Display name of the operation
   * @property {string} [display.provider] Name of the provider
   * @property {string} [display.resource] Name of the resource type
   * @property {string} [display.operation] Name of the operation
   * @property {string} [display.description] Description of the operation
   * @property {string} [origin] Origin of the operation
   * @property {object} [properties] Properties of the operation
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationInfo'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
