/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Output of check name availability API.
 *
 */
class CheckNameAvailabilityOutput {
  /**
   * Create a CheckNameAvailabilityOutput.
   * @member {string} [nameAvailability] Indicates whether the name is
   * available. Possible values include: 'Available', 'Unavailable'
   * @member {string} [reason] The reason why the name is not available.
   * @member {string} [message] The detailed error message describing why the
   * name is not available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckNameAvailabilityOutput
   *
   * @returns {object} metadata of CheckNameAvailabilityOutput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckNameAvailabilityOutput',
      type: {
        name: 'Composite',
        className: 'CheckNameAvailabilityOutput',
        modelProperties: {
          nameAvailability: {
            required: false,
            readOnly: true,
            serializedName: 'nameAvailability',
            type: {
              name: 'String'
            }
          },
          reason: {
            required: false,
            readOnly: true,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckNameAvailabilityOutput;
