/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of the request to list HealthProbeSettings. It contains a list of
 * HealthProbeSettings objects and a URL link to get the the next set of
 * results.
 */
class HealthProbeSettingsListResult extends Array {
  /**
   * Create a HealthProbeSettingsListResult.
   * @member {string} [nextLink] URL to get the next set of HealthProbeSettings
   * objects if there are any.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HealthProbeSettingsListResult
   *
   * @returns {object} metadata of HealthProbeSettingsListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HealthProbeSettingsListResult',
      type: {
        name: 'Composite',
        className: 'HealthProbeSettingsListResult',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HealthProbeSettingsModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'HealthProbeSettingsModel'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HealthProbeSettingsListResult;
