/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * L7 health probe settings for a backend pool
 *
 */
class HealthProbeSettingsUpdateParameters {
  /**
   * Create a HealthProbeSettingsUpdateParameters.
   * @member {string} [path] The path to use for the health probe. Default is /
   * @member {string} [protocol] Protocol scheme to use for this probe.
   * Possible values include: 'Http', 'Https'
   * @member {number} [intervalInSeconds] The number of seconds between health
   * probes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HealthProbeSettingsUpdateParameters
   *
   * @returns {object} metadata of HealthProbeSettingsUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HealthProbeSettingsUpdateParameters',
      type: {
        name: 'Composite',
        className: 'HealthProbeSettingsUpdateParameters',
        modelProperties: {
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          protocol: {
            required: false,
            serializedName: 'protocol',
            type: {
              name: 'String'
            }
          },
          intervalInSeconds: {
            required: false,
            serializedName: 'intervalInSeconds',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HealthProbeSettingsUpdateParameters;
