/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the operating system settings for the HANA instance.
 *
 */
class OSProfile {
  /**
   * Create a OSProfile.
   * @property {string} [computerName] Specifies the host OS name of the HANA
   * instance.
   * @property {string} [osType] This property allows you to specify the type
   * of the OS.
   * @property {string} [version] Specifies version of operating system.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OSProfile
   *
   * @returns {object} metadata of OSProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OSProfile',
      type: {
        name: 'Composite',
        className: 'OSProfile',
        modelProperties: {
          computerName: {
            required: false,
            readOnly: true,
            serializedName: 'computerName',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: false,
            readOnly: true,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            readOnly: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OSProfile;
