/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a rating.
 *
 * @extends models['PropertiesItem']
 */
class Rating extends models['PropertiesItem'] {
  /**
   * Create a Rating.
   * @property {number} ratingValue The mean (average) rating. The possible
   * values are 1.0 through 5.0.
   * @property {number} [bestRating] The highest rated review. The possible
   * values are 1.0 through 5.0.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Rating
   *
   * @returns {object} metadata of Rating
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Rating',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'PropertiesItem',
        className: 'Rating',
        modelProperties: {
          text: {
            required: false,
            readOnly: true,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          ratingValue: {
            required: true,
            serializedName: 'ratingValue',
            type: {
              name: 'Number'
            }
          },
          bestRating: {
            required: false,
            readOnly: true,
            serializedName: 'bestRating',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Rating;
