/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The X509 Certificate.
 *
 * @extends models['BaseResource']
 */
class CertificateWithNonceDescription extends models['BaseResource'] {
  /**
   * Create a CertificateWithNonceDescription.
   * @member {object} [properties]
   * @member {string} [properties.subject] The certificate's subject name.
   * @member {date} [properties.expiry] The certificate's expiration date and
   * time.
   * @member {string} [properties.thumbprint] The certificate's thumbprint.
   * @member {boolean} [properties.isVerified] Determines whether certificate
   * has been verified.
   * @member {date} [properties.created] The certificate's create date and
   * time.
   * @member {date} [properties.updated] The certificate's last update date and
   * time.
   * @member {string} [properties.verificationCode] The certificate's
   * verification code that will be used for proof of possession.
   * @member {string} [properties.certificate] The certificate content
   * @member {string} [id] The resource identifier.
   * @member {string} [name] The name of the certificate.
   * @member {string} [etag] The entity tag.
   * @member {string} [type] The resource type.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CertificateWithNonceDescription
   *
   * @returns {object} metadata of CertificateWithNonceDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateWithNonceDescription',
      type: {
        name: 'Composite',
        className: 'CertificateWithNonceDescription',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CertificatePropertiesWithNonce'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateWithNonceDescription;
