/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the Azure Storage Container for file archive.
 *
 */
class StorageContainerProperties {
  /**
   * Create a StorageContainerProperties.
   * @member {string} [connectionString] The connection string of the storage
   * account.
   * @member {string} [subscriptionId] The subscription identifier of the
   * storage account.
   * @member {string} [resourceGroup] The name of the resource group of the
   * storage account.
   * @member {string} [containerName] The name of storage container in the
   * storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageContainerProperties
   *
   * @returns {object} metadata of StorageContainerProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageContainerProperties',
      type: {
        name: 'Composite',
        className: 'StorageContainerProperties',
        modelProperties: {
          connectionString: {
            required: false,
            serializedName: 'connectionString',
            type: {
              name: 'String'
            }
          },
          subscriptionId: {
            required: false,
            serializedName: 'subscriptionId',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: false,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: false,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageContainerProperties;
