/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure capacity definition.
 *
 */
class AzureCapacity {
  /**
   * Create a AzureCapacity.
   * @property {string} scaleType Scale type. Possible values include:
   * 'automatic', 'manual', 'none'
   * @property {number} minimum Minimum allowed capacity.
   * @property {number} maximum Maximum allowed capacity.
   * @property {number} default The default capacity that would be used.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureCapacity
   *
   * @returns {object} metadata of AzureCapacity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureCapacity',
      type: {
        name: 'Composite',
        className: 'AzureCapacity',
        modelProperties: {
          scaleType: {
            required: true,
            serializedName: 'scaleType',
            type: {
              name: 'String'
            }
          },
          minimum: {
            required: true,
            serializedName: 'minimum',
            type: {
              name: 'Number'
            }
          },
          maximum: {
            required: true,
            serializedName: 'maximum',
            type: {
              name: 'Number'
            }
          },
          default: {
            required: true,
            serializedName: 'default',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureCapacity;
