/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Settings related to creating an environment setting
 *
 */
class EnvironmentSettingCreationParameters {
  /**
   * Create a EnvironmentSettingCreationParameters.
   * @property {object} resourceSettingCreationParameters The resource specific
   * settings
   * @property {string} [resourceSettingCreationParameters.location] The
   * location where the virtual machine will live
   * @property {string} [resourceSettingCreationParameters.name] The name of
   * the resource setting
   * @property {string}
   * [resourceSettingCreationParameters.galleryImageResourceId] The resource id
   * of the gallery image used for creating the virtual machine
   * @property {string} [resourceSettingCreationParameters.size] The size of
   * the virtual machine. Possible values include: 'Basic', 'Standard',
   * 'Performance'
   * @property {object}
   * [resourceSettingCreationParameters.referenceVmCreationParameters] Creation
   * parameters for Reference Vm
   * @property {string}
   * [resourceSettingCreationParameters.referenceVmCreationParameters.userName]
   * The username of the virtual machine
   * @property {string}
   * [resourceSettingCreationParameters.referenceVmCreationParameters.password]
   * The password of the virtual machine.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnvironmentSettingCreationParameters
   *
   * @returns {object} metadata of EnvironmentSettingCreationParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentSettingCreationParameters',
      type: {
        name: 'Composite',
        className: 'EnvironmentSettingCreationParameters',
        modelProperties: {
          resourceSettingCreationParameters: {
            required: true,
            serializedName: 'resourceSettingCreationParameters',
            type: {
              name: 'Composite',
              className: 'ResourceSettingCreationParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentSettingCreationParameters;
