/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents an image from the Azure Marketplace
 *
 * @extends models['Resource']
 */
class GalleryImageFragment extends models['Resource'] {
  /**
   * Create a GalleryImageFragment.
   * @property {boolean} [isEnabled] Indicates whether this gallery image is
   * enabled.
   * @property {boolean} [isOverride] Indicates whether this gallery has been
   * overridden for this lab account
   * @property {boolean} [isPlanAuthorized] Indicates if the plan has been
   * authorized for programmatic deployment.
   * @property {string} [provisioningState] The provisioning status of the
   * resource.
   * @property {string} [uniqueIdentifier] The unique immutable identifier of a
   * resource (Guid).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GalleryImageFragment
   *
   * @returns {object} metadata of GalleryImageFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryImageFragment',
      type: {
        name: 'Composite',
        className: 'GalleryImageFragment',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          isEnabled: {
            required: false,
            serializedName: 'properties.isEnabled',
            type: {
              name: 'Boolean'
            }
          },
          isOverride: {
            required: false,
            serializedName: 'properties.isOverride',
            type: {
              name: 'Boolean'
            }
          },
          isPlanAuthorized: {
            required: false,
            serializedName: 'properties.isPlanAuthorized',
            type: {
              name: 'Boolean'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          uniqueIdentifier: {
            required: false,
            serializedName: 'properties.uniqueIdentifier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryImageFragment;
