/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This represents the details about a lab that the User is in, and its state.
 *
 */
class LabDetails {
  /**
   * Create a LabDetails.
   * @property {string} [name] Name of the lab
   * @property {string} [provisioningState] The provisioning state of the lab.
   * @property {string} [id] The Id of the lab.
   * @property {moment.duration} [usageQuota] The maximum duration a user can
   * use a VM in this lab.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LabDetails
   *
   * @returns {object} metadata of LabDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LabDetails',
      type: {
        name: 'Composite',
        className: 'LabDetails',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'provisioningState',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          usageQuota: {
            required: false,
            readOnly: true,
            serializedName: 'usageQuota',
            type: {
              name: 'TimeSpan'
            }
          }
        }
      }
    };
  }
}

module.exports = LabDetails;
