/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents payload for any Environment operations like get, start, stop,
 * connect
 *
 */
class PersonalPreferencesOperationsPayload {
  /**
   * Create a PersonalPreferencesOperationsPayload.
   * @property {string} [labAccountResourceId] Resource Id of the lab account
   * @property {string} [addRemove] Enum indicating if user is adding or
   * removing a favorite lab. Possible values include: 'Add', 'Remove'
   * @property {string} [labResourceId] Resource Id of the lab to add/remove
   * from the favorites list
   */
  constructor() {
  }

  /**
   * Defines the metadata of PersonalPreferencesOperationsPayload
   *
   * @returns {object} metadata of PersonalPreferencesOperationsPayload
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PersonalPreferencesOperationsPayload',
      type: {
        name: 'Composite',
        className: 'PersonalPreferencesOperationsPayload',
        modelProperties: {
          labAccountResourceId: {
            required: false,
            serializedName: 'labAccountResourceId',
            type: {
              name: 'String'
            }
          },
          addRemove: {
            required: false,
            serializedName: 'addRemove',
            type: {
              name: 'String'
            }
          },
          labResourceId: {
            required: false,
            serializedName: 'labResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PersonalPreferencesOperationsPayload;
