/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details about the state of the reference virtual machine.
 *
 */
class VmStateDetails {
  /**
   * Create a VmStateDetails.
   * @property {string} [rdpAuthority] The RdpAuthority property is a server
   * DNS host name or IP address followed by the service port number for RDP
   * (Remote Desktop Protocol).
   * @property {string} [sshAuthority] The SshAuthority property is a server
   * DNS host name or IP address followed by the service port number for SSH.
   * @property {string} [powerState] The power state of the reference virtual
   * machine.
   * @property {string} [lastKnownPowerState] Last known compute power state
   * captured in DTL
   */
  constructor() {
  }

  /**
   * Defines the metadata of VmStateDetails
   *
   * @returns {object} metadata of VmStateDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VmStateDetails',
      type: {
        name: 'Composite',
        className: 'VmStateDetails',
        modelProperties: {
          rdpAuthority: {
            required: false,
            readOnly: true,
            serializedName: 'rdpAuthority',
            type: {
              name: 'String'
            }
          },
          sshAuthority: {
            required: false,
            readOnly: true,
            serializedName: 'sshAuthority',
            type: {
              name: 'String'
            }
          },
          powerState: {
            required: false,
            readOnly: true,
            serializedName: 'powerState',
            type: {
              name: 'String'
            }
          },
          lastKnownPowerState: {
            required: false,
            readOnly: true,
            serializedName: 'lastKnownPowerState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VmStateDetails;
