/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The azure resource error info.
 *
 * @extends models['ErrorInfo']
 */
class AzureResourceErrorInfo extends models['ErrorInfo'] {
  /**
   * Create a AzureResourceErrorInfo.
   * @property {string} message The error message.
   * @property {array} [details] The error details.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureResourceErrorInfo
   *
   * @returns {object} metadata of AzureResourceErrorInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureResourceErrorInfo',
      type: {
        name: 'Composite',
        className: 'AzureResourceErrorInfo',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureResourceErrorInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureResourceErrorInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureResourceErrorInfo;
