/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Edifact schema reference.
 *
 */
class EdifactSchemaReference {
  /**
   * Create a EdifactSchemaReference.
   * @property {string} messageId The message id.
   * @property {string} messageVersion The message version.
   * @property {string} messageRelease The message release version.
   * @property {string} [senderApplicationId] The sender application id.
   * @property {string} [senderApplicationQualifier] The sender application
   * qualifier.
   * @property {string} [associationAssignedCode] The association assigned
   * code.
   * @property {string} schemaName The schema name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EdifactSchemaReference
   *
   * @returns {object} metadata of EdifactSchemaReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EdifactSchemaReference',
      type: {
        name: 'Composite',
        className: 'EdifactSchemaReference',
        modelProperties: {
          messageId: {
            required: true,
            serializedName: 'messageId',
            type: {
              name: 'String'
            }
          },
          messageVersion: {
            required: true,
            serializedName: 'messageVersion',
            type: {
              name: 'String'
            }
          },
          messageRelease: {
            required: true,
            serializedName: 'messageRelease',
            type: {
              name: 'String'
            }
          },
          senderApplicationId: {
            required: false,
            serializedName: 'senderApplicationId',
            type: {
              name: 'String'
            }
          },
          senderApplicationQualifier: {
            required: false,
            serializedName: 'senderApplicationQualifier',
            type: {
              name: 'String'
            }
          },
          associationAssignedCode: {
            required: false,
            serializedName: 'associationAssignedCode',
            type: {
              name: 'String'
            }
          },
          schemaName: {
            required: true,
            serializedName: 'schemaName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EdifactSchemaReference;
