/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The reference to the key vault key.
 *
 */
class KeyVaultKeyReference {
  /**
   * Create a KeyVaultKeyReference.
   * @property {object} keyVault The key vault reference.
   * @property {string} [keyVault.id] The resource id.
   * @property {string} [keyVault.name] The resource name.
   * @property {string} [keyVault.type] The resource type.
   * @property {string} keyName The private key name in key vault.
   * @property {string} [keyVersion] The private key version in key vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultKeyReference
   *
   * @returns {object} metadata of KeyVaultKeyReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultKeyReference',
      type: {
        name: 'Composite',
        className: 'KeyVaultKeyReference',
        modelProperties: {
          keyVault: {
            required: true,
            serializedName: 'keyVault',
            type: {
              name: 'Composite',
              className: 'KeyVaultKeyReferenceKeyVault'
            }
          },
          keyName: {
            required: true,
            serializedName: 'keyName',
            type: {
              name: 'String'
            }
          },
          keyVersion: {
            required: false,
            serializedName: 'keyVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultKeyReference;
