/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The request history.
 *
 * @extends models['Resource']
 */
class RequestHistory extends models['Resource'] {
  /**
   * Create a RequestHistory.
   * @property {object} [properties] The request history properties.
   * @property {date} [properties.startTime] The time the request started.
   * @property {date} [properties.endTime] The time the request ended.
   * @property {object} [properties.request] The request.
   * @property {object} [properties.request.headers] A list of all the headers
   * attached to the request.
   * @property {string} [properties.request.uri] The destination for the
   * request.
   * @property {string} [properties.request.method] The HTTP method used for
   * the request.
   * @property {object} [properties.response] The response.
   * @property {object} [properties.response.headers] A list of all the headers
   * attached to the response.
   * @property {number} [properties.response.statusCode] The status code of the
   * response.
   * @property {object} [properties.response.bodyLink] Details on the location
   * of the body content.
   * @property {string} [properties.response.bodyLink.uri] The content link
   * URI.
   * @property {string} [properties.response.bodyLink.contentVersion] The
   * content version.
   * @property {number} [properties.response.bodyLink.contentSize] The content
   * size.
   * @property {object} [properties.response.bodyLink.contentHash] The content
   * hash.
   * @property {string} [properties.response.bodyLink.contentHash.algorithm]
   * The algorithm of the content hash.
   * @property {string} [properties.response.bodyLink.contentHash.value] The
   * value of the content hash.
   * @property {object} [properties.response.bodyLink.metadata] The metadata.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RequestHistory
   *
   * @returns {object} metadata of RequestHistory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RequestHistory',
      type: {
        name: 'Composite',
        className: 'RequestHistory',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'RequestHistoryProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = RequestHistory;
