/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object model for updating a closed list.
 *
 */
class ClosedListModelUpdateObject {
  /**
   * Create a ClosedListModelUpdateObject.
   * @property {array} [subLists] The new sublists for the feature.
   * @property {string} [name] The new name of the closed list feature.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClosedListModelUpdateObject
   *
   * @returns {object} metadata of ClosedListModelUpdateObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClosedListModelUpdateObject',
      type: {
        name: 'Composite',
        className: 'ClosedListModelUpdateObject',
        modelProperties: {
          subLists: {
            required: false,
            serializedName: 'subLists',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'WordListObjectElementType',
                  type: {
                    name: 'Composite',
                    className: 'WordListObject'
                  }
              }
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClosedListModelUpdateObject;
