/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A Custom Prebuilt model.
 *
 */
class CustomPrebuiltModel {
  /**
   * Create a CustomPrebuiltModel.
   * @property {uuid} id The ID of the Entity Model.
   * @property {string} [name] Name of the Entity Model.
   * @property {number} [typeId] The type ID of the Entity Model.
   * @property {string} readableType Possible values include: 'Entity
   * Extractor', 'Hierarchical Entity Extractor', 'Hierarchical Child Entity
   * Extractor', 'Composite Entity Extractor', 'Closed List Entity Extractor',
   * 'Prebuilt Entity Extractor', 'Intent Classifier', 'Pattern.Any Entity
   * Extractor', 'Regex Entity Extractor'
   * @property {string} [customPrebuiltDomainName] The domain name.
   * @property {string} [customPrebuiltModelName] The intent name or entity
   * name.
   * @property {array} [roles]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CustomPrebuiltModel
   *
   * @returns {object} metadata of CustomPrebuiltModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomPrebuiltModel',
      type: {
        name: 'Composite',
        className: 'CustomPrebuiltModel',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          typeId: {
            required: false,
            serializedName: 'typeId',
            type: {
              name: 'Number'
            }
          },
          readableType: {
            required: true,
            serializedName: 'readableType',
            type: {
              name: 'String'
            }
          },
          customPrebuiltDomainName: {
            required: false,
            serializedName: 'customPrebuiltDomainName',
            type: {
              name: 'String'
            }
          },
          customPrebuiltModelName: {
            required: false,
            serializedName: 'customPrebuiltModelName',
            type: {
              name: 'String'
            }
          },
          roles: {
            required: false,
            serializedName: 'roles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EntityRoleElementType',
                  type: {
                    name: 'Composite',
                    className: 'EntityRole'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CustomPrebuiltModel;
