/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An Entity Extractor model info.
 *
 * @extends models['ModelInfo']
 */
class EntityModelInfo extends models['ModelInfo'] {
  /**
   * Create a EntityModelInfo.
   * @property {array} [roles]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EntityModelInfo
   *
   * @returns {object} metadata of EntityModelInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EntityModelInfo',
      type: {
        name: 'Composite',
        className: 'EntityModelInfo',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          typeId: {
            required: false,
            serializedName: 'typeId',
            type: {
              name: 'Number'
            }
          },
          readableType: {
            required: true,
            serializedName: 'readableType',
            type: {
              name: 'String'
            }
          },
          roles: {
            required: false,
            serializedName: 'roles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EntityRoleElementType',
                  type: {
                    name: 'Composite',
                    className: 'EntityRole'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EntityModelInfo;
