/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Predicted/suggested intent.
 *
 */
class IntentsSuggestionExample {
  /**
   * Create a IntentsSuggestionExample.
   * @property {string} [text] The utterance. E.g.: what's the weather like in
   * seattle?
   * @property {array} [tokenizedText] The utterance tokenized.
   * @property {array} [intentPredictions] Predicted/suggested intents.
   * @property {array} [entityPredictions] Predicted/suggested entities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntentsSuggestionExample
   *
   * @returns {object} metadata of IntentsSuggestionExample
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntentsSuggestionExample',
      type: {
        name: 'Composite',
        className: 'IntentsSuggestionExample',
        modelProperties: {
          text: {
            required: false,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          tokenizedText: {
            required: false,
            serializedName: 'tokenizedText',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          intentPredictions: {
            required: false,
            serializedName: 'intentPredictions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IntentPredictionElementType',
                  type: {
                    name: 'Composite',
                    className: 'IntentPrediction'
                  }
              }
            }
          },
          entityPredictions: {
            required: false,
            serializedName: 'entityPredictions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EntityPredictionElementType',
                  type: {
                    name: 'Composite',
                    className: 'EntityPrediction'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IntentsSuggestionExample;
