/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Exported Model - Extracted Entity from utterance.
 *
 */
class JSONEntity {
  /**
   * Create a JSONEntity.
   * @property {number} startPos The index within the utterance where the
   * extracted entity starts.
   * @property {number} endPos The index within the utterance where the
   * extracted entity ends.
   * @property {string} entity The entity name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JSONEntity
   *
   * @returns {object} metadata of JSONEntity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JSONEntity',
      type: {
        name: 'Composite',
        className: 'JSONEntity',
        modelProperties: {
          startPos: {
            required: true,
            serializedName: 'startPos',
            type: {
              name: 'Number'
            }
          },
          endPos: {
            required: true,
            serializedName: 'endPos',
            type: {
              name: 'Number'
            }
          },
          entity: {
            required: true,
            serializedName: 'entity',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JSONEntity;
