/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Model Training Details.
 *
 */
class ModelTrainingDetails {
  /**
   * Create a ModelTrainingDetails.
   * @property {number} [statusId] The train request status ID.
   * @property {string} [status] Possible values include: 'Queued',
   * 'InProgress', 'UpToDate', 'Fail', 'Success'
   * @property {number} [exampleCount] The count of examples used to train the
   * model.
   * @property {date} [trainingDateTime] When the model was trained.
   * @property {string} [failureReason] Reason for the training failure.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ModelTrainingDetails
   *
   * @returns {object} metadata of ModelTrainingDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ModelTrainingDetails',
      type: {
        name: 'Composite',
        className: 'ModelTrainingDetails',
        modelProperties: {
          statusId: {
            required: false,
            serializedName: 'statusId',
            type: {
              name: 'Number'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          exampleCount: {
            required: false,
            serializedName: 'exampleCount',
            type: {
              name: 'Number'
            }
          },
          trainingDateTime: {
            required: false,
            serializedName: 'trainingDateTime',
            type: {
              name: 'DateTime'
            }
          },
          failureReason: {
            required: false,
            serializedName: 'failureReason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ModelTrainingDetails;
