/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Model Training Info.
 *
 */
class ModelTrainingInfo {
  /**
   * Create a ModelTrainingInfo.
   * @property {uuid} [modelId] The ID (GUID) of the model.
   * @property {object} [details]
   * @property {number} [details.statusId] The train request status ID.
   * @property {string} [details.status] Possible values include: 'Queued',
   * 'InProgress', 'UpToDate', 'Fail', 'Success'
   * @property {number} [details.exampleCount] The count of examples used to
   * train the model.
   * @property {date} [details.trainingDateTime] When the model was trained.
   * @property {string} [details.failureReason] Reason for the training
   * failure.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ModelTrainingInfo
   *
   * @returns {object} metadata of ModelTrainingInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ModelTrainingInfo',
      type: {
        name: 'Composite',
        className: 'ModelTrainingInfo',
        modelProperties: {
          modelId: {
            required: false,
            serializedName: 'modelId',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Composite',
              className: 'ModelTrainingDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = ModelTrainingInfo;
