/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object model for updating an application's publish settings.
 *
 */
class PublishSettingUpdateObject {
  /**
   * Create a PublishSettingUpdateObject.
   * @property {boolean} [sentimentAnalysis] Setting sentiment analysis as true
   * returns the Sentiment of the input utterance along with the response
   * @property {boolean} [speech] Setting speech as public enables speech
   * priming in your app
   * @property {boolean} [spellChecker] Setting spell checker as public enables
   * spell checking the input utterance.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PublishSettingUpdateObject
   *
   * @returns {object} metadata of PublishSettingUpdateObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PublishSettingUpdateObject',
      type: {
        name: 'Composite',
        className: 'PublishSettingUpdateObject',
        modelProperties: {
          sentimentAnalysis: {
            required: false,
            nullable: false,
            serializedName: 'sentimentAnalysis',
            type: {
              name: 'Boolean'
            }
          },
          speech: {
            required: false,
            nullable: false,
            serializedName: 'speech',
            type: {
              name: 'Boolean'
            }
          },
          spellChecker: {
            required: false,
            nullable: false,
            serializedName: 'spellChecker',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PublishSettingUpdateObject;
