/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines an extension for a list entity.
 *
 */
class DynamicList {
  /**
   * Create a DynamicList.
   * @property {string} listEntityName The name of the list entity to extend.
   * @property {array} requestLists The lists to append on the extended list
   * entity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DynamicList
   *
   * @returns {object} metadata of DynamicList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DynamicList',
      type: {
        name: 'Composite',
        className: 'DynamicList',
        modelProperties: {
          listEntityName: {
            required: true,
            serializedName: 'listEntityName',
            type: {
              name: 'String'
            }
          },
          requestLists: {
            required: true,
            serializedName: 'requestLists',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RequestListElementType',
                  type: {
                    name: 'Composite',
                    className: 'RequestList'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DynamicList;
