/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines a sub-list to append to an existing list entity.
 *
 */
class RequestList {
  /**
   * Create a RequestList.
   * @property {string} [name] The name of the sub-list.
   * @property {string} canonicalForm The canonical form of the sub-list.
   * @property {array} [synonyms] The synonyms of the canonical form.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RequestList
   *
   * @returns {object} metadata of RequestList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RequestList',
      type: {
        name: 'Composite',
        className: 'RequestList',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          canonicalForm: {
            required: true,
            serializedName: 'canonicalForm',
            type: {
              name: 'String'
            }
          },
          synonyms: {
            required: false,
            serializedName: 'synonyms',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RequestList;
