/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters for updating a machine learning workspace.
 *
 */
class WorkspaceUpdateParameters {
  /**
   * Create a WorkspaceUpdateParameters.
   * @property {object} [tags] The resource tags for the machine learning
   * workspace.
   * @property {string} [workspaceState] The current state of workspace
   * resource. Possible values include: 'Deleted', 'Enabled', 'Disabled',
   * 'Migrated', 'Updated', 'Registered', 'Unregistered'
   * @property {string} [keyVaultIdentifierId] The key vault identifier used
   * for encrypted workspaces.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkspaceUpdateParameters
   *
   * @returns {object} metadata of WorkspaceUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkspaceUpdateParameters',
      type: {
        name: 'Composite',
        className: 'WorkspaceUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          workspaceState: {
            required: false,
            serializedName: 'properties.workspaceState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Deleted', 'Enabled', 'Disabled', 'Migrated', 'Updated', 'Registered', 'Unregistered' ]
            }
          },
          keyVaultIdentifierId: {
            required: false,
            serializedName: 'properties.keyVaultIdentifierId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkspaceUpdateParameters;
