/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The result of a request to list machine learning team accounts.
 */
class AccountListResult extends Array {
  /**
   * Create a AccountListResult.
   * @member {string} [nextLink] The URI that can be used to request the next
   * list of machine learning team accounts.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AccountListResult
   *
   * @returns {object} metadata of AccountListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccountListResult',
      type: {
        name: 'Composite',
        className: 'AccountListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AccountElementType',
                  type: {
                    name: 'Composite',
                    className: 'Account'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AccountListResult;
