/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a storage account for a machine learning team account.
 *
 */
class StorageAccountProperties {
  /**
   * Create a StorageAccountProperties.
   * @member {string} storageAccountId The fully qualified arm Id of the
   * storage account.
   * @member {string} accessKey The access key to the storage account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccountProperties
   *
   * @returns {object} metadata of StorageAccountProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccountProperties',
      type: {
        name: 'Composite',
        className: 'StorageAccountProperties',
        modelProperties: {
          storageAccountId: {
            required: true,
            serializedName: 'storageAccountId',
            type: {
              name: 'String'
            }
          },
          accessKey: {
            required: true,
            serializedName: 'accessKey',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccountProperties;
