/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.Resource = require('./resource');
exports.Workspace = require('./workspace');
exports.WorkspaceUpdateParameters = require('./workspaceUpdateParameters');
exports.Identity = require('./identity');
exports.Password = require('./password');
exports.RegistryListCredentialsResult = require('./registryListCredentialsResult');
exports.ListWorkspaceKeysResult = require('./listWorkspaceKeysResult');
exports.ErrorDetail = require('./errorDetail');
exports.ErrorResponse = require('./errorResponse');
exports.MachineLearningServiceError = require('./machineLearningServiceError');
exports.Compute = require('./compute');
exports.ComputeResource = require('./computeResource');
exports.SystemService = require('./systemService');
exports.SslConfiguration = require('./sslConfiguration');
exports.AKSProperties = require('./aKSProperties');
exports.AKS = require('./aKS');
exports.ScaleSettings = require('./scaleSettings');
exports.BatchAIProperties = require('./batchAIProperties');
exports.BatchAI = require('./batchAI');
exports.VirtualMachineSshCredentials = require('./virtualMachineSshCredentials');
exports.VirtualMachineProperties = require('./virtualMachineProperties');
exports.VirtualMachine = require('./virtualMachine');
exports.HDInsightProperties = require('./hDInsightProperties');
exports.HDInsight = require('./hDInsight');
exports.DataFactory = require('./dataFactory');
exports.ServicePrincipalCredentials = require('./servicePrincipalCredentials');
exports.ComputeSecrets = require('./computeSecrets');
exports.AksComputeSecrets = require('./aksComputeSecrets');
exports.VirtualMachineSecrets = require('./virtualMachineSecrets');
exports.OperationListResult = require('./operationListResult');
exports.WorkspaceListResult = require('./workspaceListResult');
exports.PaginatedComputeResourcesList = require('./paginatedComputeResourcesList');
exports.discriminators = {
  'Compute' : exports.Compute,
  'Compute.AKS' : exports.AKS,
  'Compute.BatchAI' : exports.BatchAI,
  'Compute.VirtualMachine' : exports.VirtualMachine,
  'Compute.HDInsight' : exports.HDInsight,
  'Compute.DataFactory' : exports.DataFactory,
  'ComputeSecrets' : exports.ComputeSecrets,
  'ComputeSecrets.AKS' : exports.AksComputeSecrets,
  'ComputeSecrets.VirtualMachine' : exports.VirtualMachineSecrets
};
