/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Secrets related to a Machine Learning compute based on AKS.
 *
 * @extends models['ComputeSecrets']
 */
class VirtualMachineSecrets extends models['ComputeSecrets'] {
  /**
   * Create a VirtualMachineSecrets.
   * @member {object} [administratorAccount] Admin creadentials for virtual
   * machine.
   * @member {string} [administratorAccount.username] Username of admin account
   * @member {string} [administratorAccount.password] Password of admin account
   * @member {string} [administratorAccount.publicKeyData] Public key data
   * @member {string} [administratorAccount.privateKeyData] Private key data
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualMachineSecrets
   *
   * @returns {object} metadata of VirtualMachineSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachine',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'computeType',
          clientName: 'computeType'
        },
        uberParent: 'ComputeSecrets',
        className: 'VirtualMachineSecrets',
        modelProperties: {
          computeType: {
            required: true,
            serializedName: 'computeType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          administratorAccount: {
            required: false,
            serializedName: 'administratorAccount',
            type: {
              name: 'Composite',
              className: 'VirtualMachineSshCredentials'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineSecrets;
