/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The details of a management group.
 *
 */
class ManagementGroupDetails {
  /**
   * Create a ManagementGroupDetails.
   * @member {number} [version] The version number of the object.
   * @member {date} [updatedTime] The date and time when this object was last
   * updated.
   * @member {string} [updatedBy] The identity of the principal or process that
   * updated the object.
   * @member {object} [parent] Parent.
   * @member {string} [parent.parentId] The fully qualified ID for the parent
   * management group.  For example,
   * /providers/Microsoft.Management/managementGroups/0000000-0000-0000-0000-000000000000
   * @member {string} [parent.displayName] The friendly name of the parent
   * management group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagementGroupDetails
   *
   * @returns {object} metadata of ManagementGroupDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementGroupDetails',
      type: {
        name: 'Composite',
        className: 'ManagementGroupDetails',
        modelProperties: {
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'Number'
            }
          },
          updatedTime: {
            required: false,
            serializedName: 'updatedTime',
            type: {
              name: 'DateTime'
            }
          },
          updatedBy: {
            required: false,
            serializedName: 'updatedBy',
            type: {
              name: 'String'
            }
          },
          parent: {
            required: false,
            serializedName: 'parent',
            type: {
              name: 'Composite',
              className: 'ParentGroupInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementGroupDetails;
