/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties to create a new replica.
 *
 * @extends models['ServerPropertiesForCreate']
 */
class ServerPropertiesForReplica extends models['ServerPropertiesForCreate'] {
  /**
   * Create a ServerPropertiesForReplica.
   * @property {string} sourceServerId The master server id to create replica
   * from.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerPropertiesForReplica
   *
   * @returns {object} metadata of ServerPropertiesForReplica
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Replica',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'createMode',
          clientName: 'createMode'
        },
        uberParent: 'ServerPropertiesForCreate',
        className: 'ServerPropertiesForReplica',
        modelProperties: {
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          sslEnforcement: {
            required: false,
            serializedName: 'sslEnforcement',
            type: {
              name: 'Enum',
              allowedValues: [ 'Enabled', 'Disabled' ]
            }
          },
          storageProfile: {
            required: false,
            serializedName: 'storageProfile',
            type: {
              name: 'Composite',
              className: 'StorageProfile'
            }
          },
          createMode: {
            required: true,
            serializedName: 'createMode',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          sourceServerId: {
            required: true,
            serializedName: 'sourceServerId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerPropertiesForReplica;
