/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A codec flag, which tells the encoder to copy the input video bitstream
 * without re-encoding.
 *
 * @extends models['Codec']
 */
class CopyVideo extends models['Codec'] {
  /**
   * Create a CopyVideo.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CopyVideo
   *
   * @returns {object} metadata of CopyVideo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.CopyVideo',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'Codec',
        className: 'CopyVideo',
        modelProperties: {
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CopyVideo;
