/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class to specify properties of default content key for each encryption
 * scheme
 *
 */
class DefaultKey {
  /**
   * Create a DefaultKey.
   * @property {string} [label] Label can be used to specify Content Key when
   * creating a Streaming Locator
   * @property {string} [policyName] Policy used by Default Key
   */
  constructor() {
  }

  /**
   * Defines the metadata of DefaultKey
   *
   * @returns {object} metadata of DefaultKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DefaultKey',
      type: {
        name: 'Composite',
        className: 'DefaultKey',
        modelProperties: {
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          policyName: {
            required: false,
            serializedName: 'policyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DefaultKey;
