/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the de-interlacing settings.
 *
 */
class Deinterlace {
  /**
   * Create a Deinterlace.
   * @property {string} [parity] The field parity for de-interlacing, defaults
   * to Auto. Possible values include: 'Auto', 'TopFieldFirst',
   * 'BottomFieldFirst'
   * @property {string} [mode] The deinterlacing mode. Defaults to
   * AutoPixelAdaptive. Possible values include: 'Off', 'AutoPixelAdaptive'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Deinterlace
   *
   * @returns {object} metadata of Deinterlace
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Deinterlace',
      type: {
        name: 'Composite',
        className: 'Deinterlace',
        modelProperties: {
          parity: {
            required: false,
            serializedName: 'parity',
            type: {
              name: 'String'
            }
          },
          mode: {
            required: false,
            serializedName: 'mode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Deinterlace;
