/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Live Event input.
 *
 */
class LiveEventInput {
  /**
   * Create a LiveEventInput.
   * @property {string} streamingProtocol The streaming protocol for the Live
   * Event.  This is specified at creation time and cannot be updated. Possible
   * values include: 'FragmentedMP4', 'RTMP'
   * @property {object} [accessControl] The access control for LiveEvent Input.
   * @property {object} [accessControl.ip] The IP access control properties.
   * @property {array} [accessControl.ip.allow] The IP allow list.
   * @property {string} [keyFrameIntervalDuration] ISO 8601 timespan duration
   * of the key frame interval duration.
   * @property {string} [accessToken] A unique identifier for a stream.  This
   * can be specified at creation time but cannot be updated.  If omitted, the
   * service will generate a unique value.
   * @property {array} [endpoints] The input endpoints for the Live Event.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LiveEventInput
   *
   * @returns {object} metadata of LiveEventInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LiveEventInput',
      type: {
        name: 'Composite',
        className: 'LiveEventInput',
        modelProperties: {
          streamingProtocol: {
            required: true,
            serializedName: 'streamingProtocol',
            type: {
              name: 'Enum',
              allowedValues: [ 'FragmentedMP4', 'RTMP' ]
            }
          },
          accessControl: {
            required: false,
            serializedName: 'accessControl',
            type: {
              name: 'Composite',
              className: 'LiveEventInputAccessControl'
            }
          },
          keyFrameIntervalDuration: {
            required: false,
            serializedName: 'keyFrameIntervalDuration',
            type: {
              name: 'String'
            }
          },
          accessToken: {
            required: false,
            serializedName: 'accessToken',
            type: {
              name: 'String'
            }
          },
          endpoints: {
            required: false,
            serializedName: 'endpoints',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LiveEventEndpointElementType',
                  type: {
                    name: 'Composite',
                    className: 'LiveEventEndpoint'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = LiveEventInput;
