/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A metric emitted by service.
 *
 */
class Metric {
  /**
   * Create a Metric.
   * @property {string} [name] The metric name.
   * @property {string} [displayName] The metric display name.
   * @property {string} [displayDescription] The metric display description.
   * @property {string} [unit] The metric unit. Possible values include:
   * 'Bytes', 'Count', 'Milliseconds'
   * @property {string} [aggregationType] The metric aggregation type. Possible
   * values include: 'Average', 'Count', 'Total'
   * @property {array} [dimensions] The metric dimensions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Metric
   *
   * @returns {object} metadata of Metric
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Metric',
      type: {
        name: 'Composite',
        className: 'Metric',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            readOnly: true,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          displayDescription: {
            required: false,
            readOnly: true,
            serializedName: 'displayDescription',
            type: {
              name: 'String'
            }
          },
          unit: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          aggregationType: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'aggregationType',
            type: {
              name: 'String'
            }
          },
          dimensions: {
            required: false,
            readOnly: true,
            serializedName: 'dimensions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetricDimensionElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetricDimension'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Metric;
