/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class to specify configurations of Widevine in Streaming Policy
 *
 */
class StreamingPolicyWidevineConfiguration {
  /**
   * Create a StreamingPolicyWidevineConfiguration.
   * @property {string} [customLicenseAcquisitionUrlTemplate] Template for the
   * URL of the custom service delivering licenses to end user players.  Not
   * required when using Azure Media Services for issuing licenses.  The
   * template supports replaceable tokens that the service will update at
   * runtime with the value specific to the request.  The currently supported
   * token values are {AlternativeMediaId}, which is replaced with the value of
   * StreamingLocatorId.AlternativeMediaId, and {ContentKeyId}, which is
   * replaced with the value of identifier of the key being requested.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StreamingPolicyWidevineConfiguration
   *
   * @returns {object} metadata of StreamingPolicyWidevineConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StreamingPolicyWidevineConfiguration',
      type: {
        name: 'Composite',
        className: 'StreamingPolicyWidevineConfiguration',
        modelProperties: {
          customLicenseAcquisitionUrlTemplate: {
            required: false,
            serializedName: 'customLicenseAcquisitionUrlTemplate',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StreamingPolicyWidevineConfiguration;
