/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class to specify one track property condition
 *
 */
class TrackPropertyCondition {
  /**
   * Create a TrackPropertyCondition.
   * @property {string} property Track property type. Possible values include:
   * 'Unknown', 'FourCC'
   * @property {string} operation Track property condition operation. Possible
   * values include: 'Unknown', 'Equal'
   * @property {string} [value] Track property value
   */
  constructor() {
  }

  /**
   * Defines the metadata of TrackPropertyCondition
   *
   * @returns {object} metadata of TrackPropertyCondition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrackPropertyCondition',
      type: {
        name: 'Composite',
        className: 'TrackPropertyCondition',
        modelProperties: {
          property: {
            required: true,
            serializedName: 'property',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: true,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TrackPropertyCondition;
