/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Azure mobile App push notification receiver.
 *
 */
class AzureAppPushReceiver {
  /**
   * Create a AzureAppPushReceiver.
   * @property {string} name The name of the Azure mobile app push receiver.
   * Names must be unique across all receivers within an action group.
   * @property {string} emailAddress The email address registered for the Azure
   * mobile app.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureAppPushReceiver
   *
   * @returns {object} metadata of AzureAppPushReceiver
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureAppPushReceiver',
      type: {
        name: 'Composite',
        className: 'AzureAppPushReceiver',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          emailAddress: {
            required: true,
            serializedName: 'emailAddress',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureAppPushReceiver;
