/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a baseline metadata value.
 *
 */
class BaselineMetadataValue {
  /**
   * Create a BaselineMetadataValue.
   * @property {object} [name] the name of the metadata.
   * @property {string} [name.value] the invariant value.
   * @property {string} [name.localizedValue] the locale specific value.
   * @property {string} [value] the value of the metadata.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BaselineMetadataValue
   *
   * @returns {object} metadata of BaselineMetadataValue
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BaselineMetadataValue',
      type: {
        name: 'Composite',
        className: 'BaselineMetadataValue',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'LocalizableString'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BaselineMetadataValue;
