/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the criteria for converting log to metric.
 *
 */
class Criteria {
  /**
   * Create a Criteria.
   * @property {string} metricName Name of the metric
   * @property {array} [dimensions] List of Dimensions for creating metric
   */
  constructor() {
  }

  /**
   * Defines the metadata of Criteria
   *
   * @returns {object} metadata of Criteria
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Criteria',
      type: {
        name: 'Composite',
        className: 'Criteria',
        modelProperties: {
          metricName: {
            required: true,
            serializedName: 'metricName',
            type: {
              name: 'String'
            }
          },
          dimensions: {
            required: false,
            serializedName: 'dimensions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DimensionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Dimension'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Criteria;
