/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies a metric dimension.
 *
 */
class MetricDimension {
  /**
   * Create a MetricDimension.
   * @property {string} name Name of the dimension.
   * @property {string} operator the dimension operator. Only 'Include' and
   * 'Exclude' are supported
   * @property {array} values list of dimension values.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricDimension
   *
   * @returns {object} metadata of MetricDimension
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricDimension',
      type: {
        name: 'Composite',
        className: 'MetricDimension',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          operator: {
            required: true,
            serializedName: 'operator',
            type: {
              name: 'String'
            }
          },
          values: {
            required: true,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MetricDimension;
