/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The time series info needed for calculating the baseline.
 *
 */
class TimeSeriesInformation {
  /**
   * Create a TimeSeriesInformation.
   * @property {array} sensitivities the list of sensitivities for calculating
   * the baseline.
   * @property {array} values The metric values to calculate the baseline.
   * @property {array} [timestamps] the array of timestamps of the baselines.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TimeSeriesInformation
   *
   * @returns {object} metadata of TimeSeriesInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TimeSeriesInformation',
      type: {
        name: 'Composite',
        className: 'TimeSeriesInformation',
        modelProperties: {
          sensitivities: {
            required: true,
            serializedName: 'sensitivities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          values: {
            required: true,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          timestamps: {
            required: false,
            serializedName: 'timestamps',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DateElementType',
                  type: {
                    name: 'DateTime'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TimeSeriesInformation;
