/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a video object that is relevant to the query.
 *
 * @extends models['MediaObject']
 */
class VideoObject extends models['MediaObject'] {
  /**
   * Create a VideoObject.
   * @property {string} [motionThumbnailUrl]
   * @property {string} [motionThumbnailId]
   * @property {string} [embedHtml]
   * @property {boolean} [allowHttpsEmbed]
   * @property {number} [viewCount]
   * @property {object} [thumbnail]
   * @property {object} [thumbnail.thumbnail] The URL to a thumbnail of the
   * image
   * @property {string} [videoId]
   * @property {boolean} [allowMobileEmbed]
   * @property {boolean} [isSuperfresh]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VideoObject
   *
   * @returns {object} metadata of VideoObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VideoObject',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'VideoObject',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          webSearchUrl: {
            required: false,
            readOnly: true,
            serializedName: 'webSearchUrl',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          image: {
            required: false,
            readOnly: true,
            serializedName: 'image',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'ImageObject'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          alternateName: {
            required: false,
            readOnly: true,
            serializedName: 'alternateName',
            type: {
              name: 'String'
            }
          },
          bingId: {
            required: false,
            readOnly: true,
            serializedName: 'bingId',
            type: {
              name: 'String'
            }
          },
          thumbnailUrl: {
            required: false,
            readOnly: true,
            serializedName: 'thumbnailUrl',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            readOnly: true,
            serializedName: 'provider',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ThingElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: '_type',
                      clientName: '_type'
                    },
                    uberParent: 'ResponseBase',
                    className: 'Thing'
                  }
              }
            }
          },
          datePublished: {
            required: false,
            readOnly: true,
            serializedName: 'datePublished',
            type: {
              name: 'String'
            }
          },
          video: {
            required: false,
            readOnly: true,
            serializedName: 'video',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'VideoObject'
            }
          },
          contentUrl: {
            required: false,
            readOnly: true,
            serializedName: 'contentUrl',
            type: {
              name: 'String'
            }
          },
          width: {
            required: false,
            readOnly: true,
            serializedName: 'width',
            type: {
              name: 'Number'
            }
          },
          height: {
            required: false,
            readOnly: true,
            serializedName: 'height',
            type: {
              name: 'Number'
            }
          },
          motionThumbnailUrl: {
            required: false,
            readOnly: true,
            serializedName: 'motionThumbnailUrl',
            type: {
              name: 'String'
            }
          },
          motionThumbnailId: {
            required: false,
            readOnly: true,
            serializedName: 'motionThumbnailId',
            type: {
              name: 'String'
            }
          },
          embedHtml: {
            required: false,
            readOnly: true,
            serializedName: 'embedHtml',
            type: {
              name: 'String'
            }
          },
          allowHttpsEmbed: {
            required: false,
            readOnly: true,
            serializedName: 'allowHttpsEmbed',
            type: {
              name: 'Boolean'
            }
          },
          viewCount: {
            required: false,
            readOnly: true,
            serializedName: 'viewCount',
            type: {
              name: 'Number'
            }
          },
          thumbnail: {
            required: false,
            readOnly: true,
            serializedName: 'thumbnail',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'ImageObject'
            }
          },
          videoId: {
            required: false,
            readOnly: true,
            serializedName: 'videoId',
            type: {
              name: 'String'
            }
          },
          allowMobileEmbed: {
            required: false,
            readOnly: true,
            serializedName: 'allowMobileEmbed',
            type: {
              name: 'Boolean'
            }
          },
          isSuperfresh: {
            required: false,
            readOnly: true,
            serializedName: 'isSuperfresh',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VideoObject;
