/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Provision request specification
 *
 */
class DedicatedCapacityUpdateParameters {
  /**
   * Create a DedicatedCapacityUpdateParameters.
   * @member {object} [sku] The SKU of the Dedicated capacity resource.
   * @member {string} [sku.name] Name of the SKU level.
   * @member {string} [sku.tier] The name of the Azure pricing tier to which
   * the SKU applies. Possible values include: 'PBIE_Azure'
   * @member {object} [tags] Key-value pairs of additional provisioning
   * properties.
   * @member {object} [administration] A collection of Dedicated capacity
   * administrators
   * @member {array} [administration.members] An array of administrator user
   * identities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DedicatedCapacityUpdateParameters
   *
   * @returns {object} metadata of DedicatedCapacityUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DedicatedCapacityUpdateParameters',
      type: {
        name: 'Composite',
        className: 'DedicatedCapacityUpdateParameters',
        modelProperties: {
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'ResourceSku'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          administration: {
            required: false,
            serializedName: 'properties.administration',
            type: {
              name: 'Composite',
              className: 'DedicatedCapacityAdministrators'
            }
          }
        }
      }
    };
  }
}

module.exports = DedicatedCapacityUpdateParameters;
