/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureFileShare workload-specific backup request.
 *
 * @extends models['BackupRequest']
 */
class AzureFileShareBackupRequest extends models['BackupRequest'] {
  /**
   * Create a AzureFileShareBackupRequest.
   * @member {date} [recoveryPointExpiryTimeInUTC] Backup copy will expire
   * after the time specified (UTC).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureFileShareBackupRequest
   *
   * @returns {object} metadata of AzureFileShareBackupRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureFileShareBackupRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'BackupRequest',
        className: 'AzureFileShareBackupRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          recoveryPointExpiryTimeInUTC: {
            required: false,
            serializedName: 'recoveryPointExpiryTimeInUTC',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFileShareBackupRequest;
