/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure VM workload-specific protectable item representing SQL Instance.
 *
 * @extends models['AzureVmWorkloadProtectableItem']
 */
class AzureVmWorkloadSQLInstanceProtectableItem extends models['AzureVmWorkloadProtectableItem'] {
  /**
   * Create a AzureVmWorkloadSQLInstanceProtectableItem.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureVmWorkloadSQLInstanceProtectableItem
   *
   * @returns {object} metadata of AzureVmWorkloadSQLInstanceProtectableItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SQLInstance',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'protectableItemType',
          clientName: 'protectableItemType'
        },
        uberParent: 'WorkloadProtectableItem',
        className: 'AzureVmWorkloadSQLInstanceProtectableItem',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          workloadType: {
            required: false,
            serializedName: 'workloadType',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          protectionState: {
            required: false,
            serializedName: 'protectionState',
            type: {
              name: 'String'
            }
          },
          protectableItemType: {
            required: true,
            serializedName: 'protectableItemType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          parentName: {
            required: false,
            serializedName: 'parentName',
            type: {
              name: 'String'
            }
          },
          parentUniqueName: {
            required: false,
            serializedName: 'parentUniqueName',
            type: {
              name: 'String'
            }
          },
          serverName: {
            required: false,
            serializedName: 'serverName',
            type: {
              name: 'String'
            }
          },
          isAutoProtectable: {
            required: false,
            serializedName: 'isAutoProtectable',
            type: {
              name: 'Boolean'
            }
          },
          isAutoProtected: {
            required: false,
            serializedName: 'isAutoProtected',
            type: {
              name: 'Boolean'
            }
          },
          subinquireditemcount: {
            required: false,
            serializedName: 'subinquireditemcount',
            type: {
              name: 'Number'
            }
          },
          subprotectableitemcount: {
            required: false,
            serializedName: 'subprotectableitemcount',
            type: {
              name: 'Number'
            }
          },
          prebackupvalidation: {
            required: false,
            serializedName: 'prebackupvalidation',
            type: {
              name: 'Composite',
              className: 'PreBackupValidation'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureVmWorkloadSQLInstanceProtectableItem;
