/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureWorkload-specific restore.
 *
 * @extends models['RestoreRequest']
 */
class AzureWorkloadRestoreRequest extends models['RestoreRequest'] {
  /**
   * Create a AzureWorkloadRestoreRequest.
   * @member {string} [recoveryType] OLR/ALR, RestoreDisks is invalid option.
   * Possible values include: 'Invalid', 'OriginalLocation',
   * 'AlternateLocation', 'RestoreDisks'
   * @member {string} [sourceResourceId] Fully qualified ARM ID of the VM on
   * which workload that was running is being recovered.
   * @member {object} [propertyBag] Workload specific property bag.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureWorkloadRestoreRequest
   *
   * @returns {object} metadata of AzureWorkloadRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadRestoreRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'RestoreRequest',
        className: 'AzureWorkloadRestoreRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          recoveryType: {
            required: false,
            serializedName: 'recoveryType',
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadRestoreRequest;
