/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureWorkload SAP Hana-specific restore.
 *
 * @extends models['RestoreRequest']
 */
class AzureWorkloadSAPHanaRestoreRequest extends models['RestoreRequest'] {
  /**
   * Create a AzureWorkloadSAPHanaRestoreRequest.
   * @member {object} [targetInfo] Details of target database
   * @member {string} [targetInfo.overwriteOption] Can Overwrite if Target
   * DataBase already exists. Possible values include: 'Invalid',
   * 'FailOnConflict', 'Overwrite'
   * @member {string} [targetInfo.containerId] Resource Id name of the
   * container in which Target DataBase resides
   * @member {string} [targetInfo.databaseName] Database name
   * InstanceName/DataBaseName for SQL or System/DbName for SAP Hana
   * @member {string} [recoveryType] OLR/ALR, RestoreDisks is invalid option.
   * Possible values include: 'Invalid', 'OriginalLocation',
   * 'AlternateLocation', 'RestoreDisks'
   * @member {string} [sourceResourceId] Fully qualified ARM ID of the VM on
   * which workload that was running is being recovered.
   * @member {object} [propertyBag] Workload specific property bag.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureWorkloadSAPHanaRestoreRequest
   *
   * @returns {object} metadata of AzureWorkloadSAPHanaRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadSAPHanaRestoreRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'RestoreRequest',
        className: 'AzureWorkloadSAPHanaRestoreRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          targetInfo: {
            required: false,
            serializedName: 'targetInfo',
            type: {
              name: 'Composite',
              className: 'TargetRestoreInfo'
            }
          },
          recoveryType: {
            required: false,
            serializedName: 'recoveryType',
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadSAPHanaRestoreRequest;
