/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This is used to represent the various nodes of the distributed container.
 *
 */
class DistributedNodesInfo {
  /**
   * Create a DistributedNodesInfo.
   * @member {string} [nodeName] Name of the node under a distributed
   * container.
   * @member {string} [status] Status of this Node.
   * Failed | Succeeded
   * @member {object} [errorDetail] Error Details if the Status is non-success.
   * @member {string} [errorDetail.code] Error code.
   * @member {string} [errorDetail.message] Error Message related to the Code.
   * @member {array} [errorDetail.recommendations] List of recommendation
   * strings.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DistributedNodesInfo
   *
   * @returns {object} metadata of DistributedNodesInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DistributedNodesInfo',
      type: {
        name: 'Composite',
        className: 'DistributedNodesInfo',
        modelProperties: {
          nodeName: {
            required: false,
            serializedName: 'nodeName',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          errorDetail: {
            required: false,
            serializedName: 'errorDetail',
            type: {
              name: 'Composite',
              className: 'ErrorDetail'
            }
          }
        }
      }
    };
  }
}

module.exports = DistributedNodesInfo;
