/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contract to validate if backup can be enabled on the given resource in a
 * given vault and given configuration.
 * It will validate followings
 * 1. Vault capacity
 * 2. VM is already protected
 * 3. Any VM related configuration passed in properties.
 *
 */
class PreValidateEnableBackupRequest {
  /**
   * Create a PreValidateEnableBackupRequest.
   * @member {string} [resourceType] ProtectedItem Type- VM, SqlDataBase,
   * AzureFileShare etc. Possible values include: 'Invalid', 'VM',
   * 'FileFolder', 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
   * 'SystemState', 'Client', 'GenericDataSource', 'SQLDataBase',
   * 'AzureFileShare', 'SAPHanaDatabase'
   * @member {string} [resourceId] ARM Virtual Machine Id
   * @member {string} [properties] Configuration of VM if any needs to be
   * validated like OS type etc
   */
  constructor() {
  }

  /**
   * Defines the metadata of PreValidateEnableBackupRequest
   *
   * @returns {object} metadata of PreValidateEnableBackupRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PreValidateEnableBackupRequest',
      type: {
        name: 'Composite',
        className: 'PreValidateEnableBackupRequest',
        modelProperties: {
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PreValidateEnableBackupRequest;
