/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response contract for enable backup validation request
 *
 */
class PreValidateEnableBackupResponse {
  /**
   * Create a PreValidateEnableBackupResponse.
   * @member {string} [status] Validation Status. Possible values include:
   * 'Invalid', 'Succeeded', 'Failed'
   * @member {string} [errorCode] Response error code
   * @member {string} [errorMessage] Response error message
   * @member {string} [recommendation] Recommended action for user
   * @member {string} [containerName] Specifies the product specific container
   * name. E.g. iaasvmcontainer;iaasvmcontainer;rgname;vmname. This is required
   * for portal
   * @member {string} [protectedItemName] Specifies the product specific ds
   * name. E.g. vm;iaasvmcontainer;rgname;vmname. This is required for portal
   */
  constructor() {
  }

  /**
   * Defines the metadata of PreValidateEnableBackupResponse
   *
   * @returns {object} metadata of PreValidateEnableBackupResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PreValidateEnableBackupResponse',
      type: {
        name: 'Composite',
        className: 'PreValidateEnableBackupResponse',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          errorCode: {
            required: false,
            serializedName: 'errorCode',
            type: {
              name: 'String'
            }
          },
          errorMessage: {
            required: false,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          },
          recommendation: {
            required: false,
            serializedName: 'recommendation',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: false,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          },
          protectedItemName: {
            required: false,
            serializedName: 'protectedItemName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PreValidateEnableBackupResponse;
