/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A2A protected managed disk details.
 *
 */
class A2AProtectedManagedDiskDetails {
  /**
   * Create a A2AProtectedManagedDiskDetails.
   * @member {string} [diskId] The managed disk Arm id.
   * @member {string} [recoveryResourceGroupId] The recovery disk resource
   * group Arm Id.
   * @member {string} [recoveryTargetDiskId] Recovery target disk Arm Id.
   * @member {string} [recoveryReplicaDiskId] Recovery replica disk Arm Id.
   * @member {string} [recoveryReplicaDiskAccountType] The replica disk type.
   * Its an optional value and will be same as source disk type if not user
   * provided.
   * @member {string} [recoveryTargetDiskAccountType] The target disk type
   * after failover. Its an optional value and will be same as source disk type
   * if not user provided.
   * @member {string} [diskName] The disk name.
   * @member {number} [diskCapacityInBytes] The disk capacity in bytes.
   * @member {string} [primaryStagingAzureStorageAccountId] The primary staging
   * storage account.
   * @member {string} [diskType] The type of disk.
   * @member {boolean} [resyncRequired] A value indicating whether resync is
   * required for this disk.
   * @member {number} [monitoringPercentageCompletion] The percentage of the
   * monitoring job. The type of the monitoring job is defined by
   * MonitoringJobType property.
   * @member {string} [monitoringJobType] The type of the monitoring job. The
   * progress is contained in MonitoringPercentageCompletion property.
   * @member {number} [dataPendingInStagingStorageAccountInMB] The data pending
   * for replication in MB at staging account.
   * @member {number} [dataPendingAtSourceAgentInMB] The data pending at source
   * virtual machine in MB.
   * @member {boolean} [isDiskEncrypted] A value indicating whether vm has
   * encrypted os disk or not.
   * @member {string} [secretIdentifier] The secret URL / identifier (BEK).
   * @member {string} [dekKeyVaultArmId] The KeyVault resource id for secret
   * (BEK).
   * @member {boolean} [isDiskKeyEncrypted] A value indicating whether disk key
   * got encrypted or not.
   * @member {string} [keyIdentifier] The key URL / identifier (KEK).
   * @member {string} [kekKeyVaultArmId] The KeyVault resource id for key
   * (KEK).
   */
  constructor() {
  }

  /**
   * Defines the metadata of A2AProtectedManagedDiskDetails
   *
   * @returns {object} metadata of A2AProtectedManagedDiskDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2AProtectedManagedDiskDetails',
      type: {
        name: 'Composite',
        className: 'A2AProtectedManagedDiskDetails',
        modelProperties: {
          diskId: {
            required: false,
            serializedName: 'diskId',
            type: {
              name: 'String'
            }
          },
          recoveryResourceGroupId: {
            required: false,
            serializedName: 'recoveryResourceGroupId',
            type: {
              name: 'String'
            }
          },
          recoveryTargetDiskId: {
            required: false,
            serializedName: 'recoveryTargetDiskId',
            type: {
              name: 'String'
            }
          },
          recoveryReplicaDiskId: {
            required: false,
            serializedName: 'recoveryReplicaDiskId',
            type: {
              name: 'String'
            }
          },
          recoveryReplicaDiskAccountType: {
            required: false,
            serializedName: 'recoveryReplicaDiskAccountType',
            type: {
              name: 'String'
            }
          },
          recoveryTargetDiskAccountType: {
            required: false,
            serializedName: 'recoveryTargetDiskAccountType',
            type: {
              name: 'String'
            }
          },
          diskName: {
            required: false,
            serializedName: 'diskName',
            type: {
              name: 'String'
            }
          },
          diskCapacityInBytes: {
            required: false,
            serializedName: 'diskCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          primaryStagingAzureStorageAccountId: {
            required: false,
            serializedName: 'primaryStagingAzureStorageAccountId',
            type: {
              name: 'String'
            }
          },
          diskType: {
            required: false,
            serializedName: 'diskType',
            type: {
              name: 'String'
            }
          },
          resyncRequired: {
            required: false,
            serializedName: 'resyncRequired',
            type: {
              name: 'Boolean'
            }
          },
          monitoringPercentageCompletion: {
            required: false,
            serializedName: 'monitoringPercentageCompletion',
            type: {
              name: 'Number'
            }
          },
          monitoringJobType: {
            required: false,
            serializedName: 'monitoringJobType',
            type: {
              name: 'String'
            }
          },
          dataPendingInStagingStorageAccountInMB: {
            required: false,
            serializedName: 'dataPendingInStagingStorageAccountInMB',
            type: {
              name: 'Number'
            }
          },
          dataPendingAtSourceAgentInMB: {
            required: false,
            serializedName: 'dataPendingAtSourceAgentInMB',
            type: {
              name: 'Number'
            }
          },
          isDiskEncrypted: {
            required: false,
            serializedName: 'isDiskEncrypted',
            type: {
              name: 'Boolean'
            }
          },
          secretIdentifier: {
            required: false,
            serializedName: 'secretIdentifier',
            type: {
              name: 'String'
            }
          },
          dekKeyVaultArmId: {
            required: false,
            serializedName: 'dekKeyVaultArmId',
            type: {
              name: 'String'
            }
          },
          isDiskKeyEncrypted: {
            required: false,
            serializedName: 'isDiskKeyEncrypted',
            type: {
              name: 'Boolean'
            }
          },
          keyIdentifier: {
            required: false,
            serializedName: 'keyIdentifier',
            type: {
              name: 'String'
            }
          },
          kekKeyVaultArmId: {
            required: false,
            serializedName: 'kekKeyVaultArmId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = A2AProtectedManagedDiskDetails;
