/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A firewall rule on a redis cache has a name, and describes a contiguous
 * range of IP addresses permitted to connect
 *
 * @extends models['ProxyResource']
 */
class RedisFirewallRule extends models['ProxyResource'] {
  /**
   * Create a RedisFirewallRule.
   * @property {string} startIP lowest IP address included in the range
   * @property {string} endIP highest IP address included in the range
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RedisFirewallRule
   *
   * @returns {object} metadata of RedisFirewallRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RedisFirewallRule',
      type: {
        name: 'Composite',
        className: 'RedisFirewallRule',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          startIP: {
            required: true,
            serializedName: 'properties.startIP',
            type: {
              name: 'String'
            }
          },
          endIP: {
            required: true,
            serializedName: 'properties.endIP',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RedisFirewallRule;
