/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of upgrade notification.
 *
 */
class UpgradeNotification {
  /**
   * Create a UpgradeNotification.
   * @property {string} [name] Name of upgrade notification.
   * @property {date} [timestamp] Timestamp when upgrade notification occurred.
   * @property {object} [upsellNotification] Details about this upgrade
   * notification
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpgradeNotification
   *
   * @returns {object} metadata of UpgradeNotification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpgradeNotification',
      type: {
        name: 'Composite',
        className: 'UpgradeNotification',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: false,
            readOnly: true,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          upsellNotification: {
            required: false,
            readOnly: true,
            serializedName: 'upsellNotification',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = UpgradeNotification;
