/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CalculatePriceResponse.
 */
class CalculatePriceResponse {
  /**
   * Create a CalculatePriceResponse.
   * @property {object} [properties]
   * @property {object} [properties.billingCurrencyTotal] Currency and amount
   * that customer will be charged in customer's local currency. Tax is not
   * included.
   * @property {string} [properties.billingCurrencyTotal.currencyCode]
   * @property {number} [properties.billingCurrencyTotal.amount]
   * @property {boolean} [properties.isBillingPartnerManaged] True if billing
   * is managed by Microsoft Partner. Used only for CSP accounts.
   * @property {string} [properties.reservationOrderId] GUID that represents
   * reservation order that can be placed after calculating price.
   * @property {string} [properties.skuTitle] Title of SKU that is being
   * purchased.
   * @property {string} [properties.skuDescription] Description of SKU that is
   * being purchased.
   * @property {object} [properties.pricingCurrencyTotal] Amount that Microsoft
   * uses for record. Used during refund for calculating refund limit. Tax is
   * not included.
   * @property {string} [properties.pricingCurrencyTotal.currencyCode]
   * @property {number} [properties.pricingCurrencyTotal.amount]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CalculatePriceResponse
   *
   * @returns {object} metadata of CalculatePriceResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CalculatePriceResponse',
      type: {
        name: 'Composite',
        className: 'CalculatePriceResponse',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CalculatePriceResponseProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = CalculatePriceResponse;
