/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Resource group information.
 *
 * @extends models['BaseResource']
 */
class ResourceGroup extends models['BaseResource'] {
  /**
   * Create a ResourceGroup.
   * @property {string} [id] The ID of the resource group.
   * @property {string} [name] The name of the resource group.
   * @property {string} [type] The type of the resource group.
   * @property {object} [properties]
   * @property {string} [properties.provisioningState] The provisioning state.
   * @property {string} location The location of the resource group. It cannot
   * be changed after the resource group has been created. It must be one of
   * the supported Azure locations.
   * @property {string} [managedBy] The ID of the resource that manages this
   * resource group.
   * @property {object} [tags] The tags attached to the resource group.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ResourceGroup
   *
   * @returns {object} metadata of ResourceGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceGroup',
      type: {
        name: 'Composite',
        className: 'ResourceGroup',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ResourceGroupProperties'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          managedBy: {
            required: false,
            serializedName: 'managedBy',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceGroup;
