/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Advanced Threat Protection resource.
 *
 * @extends models['Resource']
 */
class AdvancedThreatProtectionSetting extends models['Resource'] {
  /**
   * Create a AdvancedThreatProtectionSetting.
   * @member {boolean} [isEnabled] Indicates whether Advanced Threat Protection
   * is enabled.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AdvancedThreatProtectionSetting
   *
   * @returns {object} metadata of AdvancedThreatProtectionSetting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdvancedThreatProtectionSetting',
      type: {
        name: 'Composite',
        className: 'AdvancedThreatProtectionSetting',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          isEnabled: {
            required: false,
            serializedName: 'properties.isEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AdvancedThreatProtectionSetting;
