/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary The external security solution properties for CEF solutions
  *
 * @extends models['ExternalSecuritySolutionProperties']
 */
class CefSolutionProperties extends models['ExternalSecuritySolutionProperties'] {
  /**
   * Create a CefSolutionProperties.
   * @member {string} [hostname]
   * @member {string} [agent]
   * @member {string} [lastEventReceived]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CefSolutionProperties
   *
   * @returns {object} metadata of CefSolutionProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CefSolutionProperties',
      type: {
        name: 'Composite',
        className: 'CefSolutionProperties',
        modelProperties: {
          deviceVendor: {
            required: false,
            serializedName: 'deviceVendor',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: false,
            serializedName: 'deviceType',
            type: {
              name: 'String'
            }
          },
          workspace: {
            required: false,
            serializedName: 'workspace',
            type: {
              name: 'Composite',
              className: 'ConnectedWorkspace'
            }
          },
          hostname: {
            required: false,
            serializedName: 'hostname',
            type: {
              name: 'String'
            }
          },
          agent: {
            required: false,
            serializedName: 'agent',
            type: {
              name: 'String'
            }
          },
          lastEventReceived: {
            required: false,
            serializedName: 'lastEventReceived',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CefSolutionProperties;
