/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a JitNetworkAccessRequest.
 */
class JitNetworkAccessRequest {
  /**
   * Create a JitNetworkAccessRequest.
   * @member {array} virtualMachines
   * @member {date} startTimeUtc The start time of the request in UTC
   * @member {string} requestor The identity of the person who made the request
   */
  constructor() {
  }

  /**
   * Defines the metadata of JitNetworkAccessRequest
   *
   * @returns {object} metadata of JitNetworkAccessRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JitNetworkAccessRequest',
      type: {
        name: 'Composite',
        className: 'JitNetworkAccessRequest',
        modelProperties: {
          virtualMachines: {
            required: true,
            serializedName: 'virtualMachines',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JitNetworkAccessRequestVirtualMachineElementType',
                  type: {
                    name: 'Composite',
                    className: 'JitNetworkAccessRequestVirtualMachine'
                  }
              }
            }
          },
          startTimeUtc: {
            required: true,
            serializedName: 'startTimeUtc',
            type: {
              name: 'DateTime'
            }
          },
          requestor: {
            required: true,
            serializedName: 'requestor',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JitNetworkAccessRequest;
