/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about an application type.
 *
 */
class ApplicationTypeInfo {
  /**
   * Create a ApplicationTypeInfo.
   * @property {string} [name] The application type name as defined in the
   * application manifest.
   * @property {string} [version] The version of the application type as
   * defined in the application manifest.
   * @property {array} [defaultParameterList] List of application type
   * parameters that can be overridden when creating or updating the
   * application.
   * @property {string} [status] The status of the application type. Possible
   * values include: 'Invalid', 'Provisioning', 'Available', 'Unprovisioning',
   * 'Failed'
   * @property {string} [statusDetails] Additional detailed information about
   * the status of the application type.
   * @property {string} [applicationTypeDefinitionKind] The mechanism used to
   * define a Service Fabric application type. Possible values include:
   * 'Invalid', 'ServiceFabricApplicationPackage', 'Compose'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationTypeInfo
   *
   * @returns {object} metadata of ApplicationTypeInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationTypeInfo',
      type: {
        name: 'Composite',
        className: 'ApplicationTypeInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'Version',
            type: {
              name: 'String'
            }
          },
          defaultParameterList: {
            required: false,
            serializedName: 'DefaultParameterList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationParameter'
                  }
              }
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            serializedName: 'StatusDetails',
            type: {
              name: 'String'
            }
          },
          applicationTypeDefinitionKind: {
            required: false,
            serializedName: 'ApplicationTypeDefinitionKind',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationTypeInfo;
