/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Application Upgrade Domain Complete event.
 *
 * @extends models['ApplicationEvent']
 */
class ApplicationUpgradeDomainCompleteEvent extends models['ApplicationEvent'] {
  /**
   * Create a ApplicationUpgradeDomainCompleteEvent.
   * @property {string} applicationTypeName Application type name.
   * @property {string} currentApplicationTypeVersion Current Application type
   * version.
   * @property {string} applicationTypeVersion Target Application type version.
   * @property {string} upgradeState State of upgrade.
   * @property {string} upgradeDomains Upgrade domains.
   * @property {number} upgradeDomainElapsedTimeInMs Upgrade time of domain in
   * milli-seconds.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationUpgradeDomainCompleteEvent
   *
   * @returns {object} metadata of ApplicationUpgradeDomainCompleteEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationUpgradeDomainComplete',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ApplicationUpgradeDomainCompleteEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          applicationId: {
            required: true,
            serializedName: 'ApplicationId',
            type: {
              name: 'String'
            }
          },
          applicationTypeName: {
            required: true,
            serializedName: 'ApplicationTypeName',
            type: {
              name: 'String'
            }
          },
          currentApplicationTypeVersion: {
            required: true,
            serializedName: 'CurrentApplicationTypeVersion',
            type: {
              name: 'String'
            }
          },
          applicationTypeVersion: {
            required: true,
            serializedName: 'ApplicationTypeVersion',
            type: {
              name: 'String'
            }
          },
          upgradeState: {
            required: true,
            serializedName: 'UpgradeState',
            type: {
              name: 'String'
            }
          },
          upgradeDomains: {
            required: true,
            serializedName: 'UpgradeDomains',
            type: {
              name: 'String'
            }
          },
          upgradeDomainElapsedTimeInMs: {
            required: true,
            serializedName: 'UpgradeDomainElapsedTimeInMs',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationUpgradeDomainCompleteEvent;
