/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the parameters for triggering partition's backup.
 *
 */
class BackupPartitionDescription {
  /**
   * Create a BackupPartitionDescription.
   * @property {object} [backupStorage] Specifies the details of the backup
   * storage where to save the backup.
   * @property {string} [backupStorage.friendlyName] Friendly name for this
   * backup storage.
   * @property {string} [backupStorage.storageKind] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupPartitionDescription
   *
   * @returns {object} metadata of BackupPartitionDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupPartitionDescription',
      type: {
        name: 'Composite',
        className: 'BackupPartitionDescription',
        modelProperties: {
          backupStorage: {
            required: false,
            serializedName: 'BackupStorage',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'StorageKind',
                clientName: 'storageKind'
              },
              uberParent: 'BackupStorageDescription',
              className: 'BackupStorageDescription'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupPartitionDescription;
