/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Chaos Restart Node Fault Scheduled event.
 *
 * @extends models['NodeEvent']
 */
class ChaosRestartNodeFaultScheduledEvent extends models['NodeEvent'] {
  /**
   * Create a ChaosRestartNodeFaultScheduledEvent.
   * @property {number} nodeInstanceId Id of Node instance.
   * @property {uuid} faultGroupId Id of fault group.
   * @property {uuid} faultId Id of fault.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ChaosRestartNodeFaultScheduledEvent
   *
   * @returns {object} metadata of ChaosRestartNodeFaultScheduledEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChaosRestartNodeFaultScheduled',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ChaosRestartNodeFaultScheduledEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          nodeName: {
            required: true,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          nodeInstanceId: {
            required: true,
            serializedName: 'NodeInstanceId',
            type: {
              name: 'Number'
            }
          },
          faultGroupId: {
            required: true,
            serializedName: 'FaultGroupId',
            type: {
              name: 'String'
            }
          },
          faultId: {
            required: true,
            serializedName: 'FaultId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ChaosRestartNodeFaultScheduledEvent;
