/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The container state.
 *
 */
class ContainerState {
  /**
   * Create a ContainerState.
   * @property {string} [state] The state of this container
   * @property {date} [startTime] Date/time when the container state started.
   * @property {string} [exitCode] The container exit code.
   * @property {date} [finishTime] Date/time when the container state finished.
   * @property {string} [detailStatus] Human-readable status of this state.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerState
   *
   * @returns {object} metadata of ContainerState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerState',
      type: {
        name: 'Composite',
        className: 'ContainerState',
        modelProperties: {
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          exitCode: {
            required: false,
            serializedName: 'exitCode',
            type: {
              name: 'String'
            }
          },
          finishTime: {
            required: false,
            serializedName: 'finishTime',
            type: {
              name: 'DateTime'
            }
          },
          detailStatus: {
            required: false,
            serializedName: 'detailStatus',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerState;
