/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Node Deactivate Complete event.
 *
 * @extends models['NodeEvent']
 */
class NodeDeactivateCompleteEvent extends models['NodeEvent'] {
  /**
   * Create a NodeDeactivateCompleteEvent.
   * @property {number} nodeInstance Id of Node instance.
   * @property {string} effectiveDeactivateIntent Describes deactivate intent.
   * @property {string} batchIdsWithDeactivateIntent Batch Ids.
   * @property {date} startTime Start time.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NodeDeactivateCompleteEvent
   *
   * @returns {object} metadata of NodeDeactivateCompleteEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeDeactivateComplete',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'NodeDeactivateCompleteEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          nodeName: {
            required: true,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          nodeInstance: {
            required: true,
            serializedName: 'NodeInstance',
            type: {
              name: 'Number'
            }
          },
          effectiveDeactivateIntent: {
            required: true,
            serializedName: 'EffectiveDeactivateIntent',
            type: {
              name: 'String'
            }
          },
          batchIdsWithDeactivateIntent: {
            required: true,
            serializedName: 'BatchIdsWithDeactivateIntent',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: true,
            serializedName: 'StartTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeDeactivateCompleteEvent;
