/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identity of the task related to deactivation operation on the node.
 *
 */
class NodeDeactivationTaskId {
  /**
   * Create a NodeDeactivationTaskId.
   * @property {string} [id] Value of the task id.
   * @property {string} [nodeDeactivationTaskType] The type of the task that
   * performed the node deactivation. Following are the possible values.
   * Possible values include: 'Invalid', 'Infrastructure', 'Repair', 'Client'
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeDeactivationTaskId
   *
   * @returns {object} metadata of NodeDeactivationTaskId
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeDeactivationTaskId',
      type: {
        name: 'Composite',
        className: 'NodeDeactivationTaskId',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'Id',
            type: {
              name: 'String'
            }
          },
          nodeDeactivationTaskType: {
            required: false,
            serializedName: 'NodeDeactivationTaskType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeDeactivationTaskId;
