/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This type describes the requested resources for a given container. It
 * describes the least amount of resources required for the container. A
 * container can consume more than requested resources up to the specified
 * limits before being restarted. Currently, the requested resources are
 * treated as limits.
 *
 */
class ResourceRequests {
  /**
   * Create a ResourceRequests.
   * @property {number} memoryInGB The memory request in GB for this container.
   * @property {number} cpu Requested number of CPU cores. At present, only
   * full cores are supported.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceRequests
   *
   * @returns {object} metadata of ResourceRequests
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceRequests',
      type: {
        name: 'Composite',
        className: 'ResourceRequests',
        modelProperties: {
          memoryInGB: {
            required: true,
            serializedName: 'memoryInGB',
            type: {
              name: 'Number'
            }
          },
          cpu: {
            required: true,
            serializedName: 'cpu',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceRequests;
