/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the properties of a secret resource.
 *
 * @extends models['SecretResourcePropertiesBase']
 */
class SecretResourceProperties extends models['SecretResourcePropertiesBase'] {
  /**
   * Create a SecretResourceProperties.
   * @property {string} [description] User readable description of the secret.
   * @property {string} [status] Status of the resource. Possible values
   * include: 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting', 'Failed'
   * @property {string} [statusDetails] Gives additional information about the
   * current status of the secret.
   * @property {string} [contentType] The type of the content stored in the
   * secret value. The value of this property is opaque to Service Fabric. Once
   * set, the value of this property cannot be changed.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SecretResourceProperties
   *
   * @returns {object} metadata of SecretResourceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretResourceProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'SecretResourcePropertiesBase',
        className: 'SecretResourceProperties',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            readOnly: true,
            serializedName: 'statusDetails',
            type: {
              name: 'String'
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretResourceProperties;
