/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the resource that is used for triggering auto scaling.
 *
 * @extends models['AutoScalingMetric']
 */
class AutoScalingResourceMetric extends models['AutoScalingMetric'] {
  /**
   * Create a AutoScalingResourceMetric.
   * @member {string} name Name of the resource. Possible values include:
   * 'cpu', 'memoryInGB'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AutoScalingResourceMetric
   *
   * @returns {object} metadata of AutoScalingResourceMetric
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Resource',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'AutoScalingMetric',
        className: 'AutoScalingResourceMetric',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AutoScalingResourceMetric;
