/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Diagnostics settings for Geneva.
 *
 * @extends models['DiagnosticsSinkProperties']
 */
class AzureInternalMonitoringPipelineSinkDescription extends models['DiagnosticsSinkProperties'] {
  /**
   * Create a AzureInternalMonitoringPipelineSinkDescription.
   * @member {string} [accountName] Azure Internal monitoring pipeline account.
   * @member {string} [namespace] Azure Internal monitoring pipeline account
   * namespace.
   * @member {string} [maConfigUrl] Azure Internal monitoring agent
   * configuration.
   * @member {object} [fluentdConfigUrl] Azure Internal monitoring agent
   * fluentd configuration.
   * @member {string} [autoKeyConfigUrl] Azure Internal monitoring pipeline
   * autokey associated with the certificate.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureInternalMonitoringPipelineSinkDescription
   *
   * @returns {object} metadata of AzureInternalMonitoringPipelineSinkDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureInternalMonitoringPipeline',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'DiagnosticsSinkProperties',
        className: 'AzureInternalMonitoringPipelineSinkDescription',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          accountName: {
            required: false,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          namespace: {
            required: false,
            serializedName: 'namespace',
            type: {
              name: 'String'
            }
          },
          maConfigUrl: {
            required: false,
            serializedName: 'maConfigUrl',
            type: {
              name: 'String'
            }
          },
          fluentdConfigUrl: {
            required: false,
            serializedName: 'fluentdConfigUrl',
            type: {
              name: 'Object'
            }
          },
          autoKeyConfigUrl: {
            required: false,
            serializedName: 'autoKeyConfigUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureInternalMonitoringPipelineSinkDescription;
