/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error model information
 *
 */
class ErrorErrorModel {
  /**
   * Create a ErrorErrorModel.
   * @member {string} code
   * @member {string} [message] Error message.
   * @member {string} [innerError]
   * @member {array} [details] List of error message details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorErrorModel
   *
   * @returns {object} metadata of ErrorErrorModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorErrorModel',
      type: {
        name: 'Composite',
        className: 'ErrorErrorModel',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          innerError: {
            required: false,
            serializedName: 'innerError',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorDetailsModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorDetailsModel'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorErrorModel;
