/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the hostname properties for http routing.
 *
 */
class HttpHostConfig {
  /**
   * Create a HttpHostConfig.
   * @member {string} name http hostname config name.
   * @member {array} routes Route information to use for routing. Routes are
   * processed in the order they are specified. Specify routes that are more
   * specific before routes that can hamdle general cases.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpHostConfig
   *
   * @returns {object} metadata of HttpHostConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpHostConfig',
      type: {
        name: 'Composite',
        className: 'HttpHostConfig',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          routes: {
            required: true,
            serializedName: 'routes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HttpRouteConfigElementType',
                  type: {
                    name: 'Composite',
                    className: 'HttpRouteConfig'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = HttpHostConfig;
