/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a network reference in a service.
 *
 */
class NetworkRef {
  /**
   * Create a NetworkRef.
   * @member {string} [name] Name of the network
   * @member {array} [endpointRefs] A list of endpoints that are exposed on
   * this network.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkRef
   *
   * @returns {object} metadata of NetworkRef
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkRef',
      type: {
        name: 'Composite',
        className: 'NetworkRef',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          endpointRefs: {
            required: false,
            serializedName: 'endpointRefs',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EndpointRefElementType',
                  type: {
                    name: 'Composite',
                    className: 'EndpointRef'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkRef;
