/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an Azure Cloud Service
 *
 */
class AzureCloudServiceConfiguration {
  /**
   * Create a AzureCloudServiceConfiguration.
   * @member {string} [name] Cloud Service name
   * @member {string} [instanceId] Cloud Service instance identifier
   * @member {string} [deployment] Cloud Service deployment identifier
   * @member {string} [roleName] Cloud Service role name
   * @member {string} [roleType] Used to specify type of an Azure Cloud Service
   * role. Possible values include: 'unknown', 'worker', 'web'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureCloudServiceConfiguration
   *
   * @returns {object} metadata of AzureCloudServiceConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureCloudServiceConfiguration',
      type: {
        name: 'Composite',
        className: 'AzureCloudServiceConfiguration',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          instanceId: {
            required: false,
            serializedName: 'instanceId',
            type: {
              name: 'String'
            }
          },
          deployment: {
            required: false,
            serializedName: 'deployment',
            type: {
              name: 'String'
            }
          },
          roleName: {
            required: false,
            serializedName: 'roleName',
            type: {
              name: 'String'
            }
          },
          roleType: {
            required: false,
            serializedName: 'roleType',
            type: {
              name: 'Enum',
              allowedValues: [ 'unknown', 'worker', 'web' ]
            }
          }
        }
      }
    };
  }
}

module.exports = AzureCloudServiceConfiguration;
