/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters for SignalR service update operation
 *
 */
class SignalRUpdateParameters {
  /**
   * Create a SignalRUpdateParameters.
   * @member {object} [tags] A list of key value pairs that describe the
   * resource.
   * @member {object} [sku] The billing information of the resource.(e.g. basic
   * vs. standard)
   * @member {string} [sku.name] The name of the SKU. This is typically a
   * letter + number code, such as A0 or P3.  Required (if sku is specified)
   * @member {string} [sku.tier] Optional tier of this particular SKU. `Basic`
   * is deprecated, use `Standard` instead for Basic tier. Possible values
   * include: 'Free', 'Basic', 'Standard', 'Premium'
   * @member {string} [sku.size] Optional, string. When the name field is the
   * combination of tier and some other value, this would be the standalone
   * code.
   * @member {string} [sku.family] Optional, string. If the service has
   * different generations of hardware, for the same SKU, then that can be
   * captured here.
   * @member {number} [sku.capacity] Optional, integer. If the SKU supports
   * scale out/in then the capacity integer should be included. If scale out/in
   * is not
   * possible for the resource this may be omitted.
   * @member {object} [properties] Settings used to provision or configure the
   * resource
   * @member {string} [properties.hostNamePrefix] Prefix for the hostName of
   * the SignalR service. Retained for future use.
   * The hostname will be of format:
   * &lt;hostNamePrefix&gt;.service.signalr.net.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SignalRUpdateParameters
   *
   * @returns {object} metadata of SignalRUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SignalRUpdateParameters',
      type: {
        name: 'Composite',
        className: 'SignalRUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'ResourceSku'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'SignalRCreateOrUpdateProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = SignalRUpdateParameters;
