/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The target that a job execution is executed on.
 *
 */
class JobExecutionTarget {
  /**
   * Create a JobExecutionTarget.
   * @property {string} [type] The type of the target. Possible values include:
   * 'TargetGroup', 'SqlDatabase', 'SqlElasticPool', 'SqlShardMap', 'SqlServer'
   * @property {string} [serverName] The server name.
   * @property {string} [databaseName] The database name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobExecutionTarget
   *
   * @returns {object} metadata of JobExecutionTarget
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobExecutionTarget',
      type: {
        name: 'Composite',
        className: 'JobExecutionTarget',
        modelProperties: {
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          serverName: {
            required: false,
            readOnly: true,
            serializedName: 'serverName',
            type: {
              name: 'String'
            }
          },
          databaseName: {
            required: false,
            readOnly: true,
            serializedName: 'databaseName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobExecutionTarget;
