/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Partner region information for the failover group.
 *
 */
class PartnerRegionInfo {
  /**
   * Create a PartnerRegionInfo.
   * @property {string} [location] Geo location of the partner managed
   * instances.
   * @property {string} [replicationRole] Replication role of the partner
   * managed instances. Possible values include: 'Primary', 'Secondary'
   */
  constructor() {
  }

  /**
   * Defines the metadata of PartnerRegionInfo
   *
   * @returns {object} metadata of PartnerRegionInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartnerRegionInfo',
      type: {
        name: 'Composite',
        className: 'PartnerRegionInfo',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          replicationRole: {
            required: false,
            readOnly: true,
            serializedName: 'replicationRole',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PartnerRegionInfo;
