/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Set the access level and network port settings for SQL Server.
 *
 */
class SqlConnectivityUpdateSettings {
  /**
   * Create a SqlConnectivityUpdateSettings.
   * @property {string} [connectivityType] SQL Server connectivity option.
   * Possible values include: 'LOCAL', 'PRIVATE', 'PUBLIC'
   * @property {number} [port] SQL Server port.
   * @property {string} [sqlAuthUpdateUserName] SQL Server sysadmin login to
   * create.
   * @property {string} [sqlAuthUpdatePassword] SQL Server sysadmin login
   * password.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SqlConnectivityUpdateSettings
   *
   * @returns {object} metadata of SqlConnectivityUpdateSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SqlConnectivityUpdateSettings',
      type: {
        name: 'Composite',
        className: 'SqlConnectivityUpdateSettings',
        modelProperties: {
          connectivityType: {
            required: false,
            serializedName: 'connectivityType',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          },
          sqlAuthUpdateUserName: {
            required: false,
            serializedName: 'sqlAuthUpdateUserName',
            type: {
              name: 'String'
            }
          },
          sqlAuthUpdatePassword: {
            required: false,
            serializedName: 'sqlAuthUpdatePassword',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SqlConnectivityUpdateSettings;
