/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Set disk storage settings for SQL Server.
 *
 */
class SqlStorageUpdateSettings {
  /**
   * Create a SqlStorageUpdateSettings.
   * @property {number} [diskCount] Virtual machine disk count.
   * @property {string} [diskConfigurationType] Disk configuration to apply to
   * SQL Server. Possible values include: 'NEW', 'EXTEND', 'ADD'
   * @property {number} [startingDeviceId] Device id of the first disk to be
   * updated.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SqlStorageUpdateSettings
   *
   * @returns {object} metadata of SqlStorageUpdateSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SqlStorageUpdateSettings',
      type: {
        name: 'Composite',
        className: 'SqlStorageUpdateSettings',
        modelProperties: {
          diskCount: {
            required: false,
            serializedName: 'diskCount',
            type: {
              name: 'Number'
            }
          },
          diskConfigurationType: {
            required: false,
            serializedName: 'diskConfigurationType',
            type: {
              name: 'String'
            }
          },
          startingDeviceId: {
            required: false,
            serializedName: 'startingDeviceId',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SqlStorageUpdateSettings;
