/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Challenge-Handshake Authentical Protocol (CHAP) setting
 *
 * @extends models['BaseModel']
 */
class ChapSettings extends models['BaseModel'] {
  /**
   * Create a ChapSettings.
   * @member {object} password The chap password.
   * @member {string} [password.value] The value of the secret itself. If the
   * secret is in plaintext then EncryptionAlgorithm will be none and
   * EncryptionCertThumbprint will be null.
   * @member {string} [password.encryptionCertificateThumbprint] Thumbprint
   * certificate that was used to encrypt "Value"
   * @member {string} [password.encryptionAlgorithm] Algorithm used to encrypt
   * "Value". Possible values include: 'None', 'AES256', 'RSAES_PKCS1_v_1_5'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ChapSettings
   *
   * @returns {object} metadata of ChapSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChapSettings',
      type: {
        name: 'Composite',
        className: 'ChapSettings',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          password: {
            required: true,
            serializedName: 'properties.password',
            type: {
              name: 'Composite',
              className: 'AsymmetricEncryptedSecret'
            }
          }
        }
      }
    };
  }
}

module.exports = ChapSettings;
