/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Upload Certificate Response from IDM
 *
 * @extends models['BaseModel']
 */
class UploadCertificateResponse extends models['BaseModel'] {
  /**
   * Create a UploadCertificateResponse.
   * @member {string} [authType] Specify the Authentication type. Possible
   * values include: 'Invalid', 'AccessControlService', 'AzureActiveDirectory'
   * @member {string} certificate Gets or sets the base64 encoded certificate
   * raw data string
   * @member {number} resourceId Gets or Sets the ResourceId
   * @member {string} aadAuthority AAD tenant authority
   * @member {string} aadTenantId AAD tenant Id
   * @member {string} servicePrincipalClientId AAD service principal clientId
   * @member {string} servicePrincipalObjectId AAD service principal ObjectId
   * @member {string} azureManagementEndpointAudience Azure Management Endpoint
   * Audience
   * @member {string} subject Certificate Subject Name
   * @member {date} validFrom Certificate Validity start Date time
   * @member {date} validTo Certificate Validity End Date time
   * @member {string} thumbprint Certificate thumbrprint
   * @member {string} friendlyName Certificate friendlyname
   * @member {string} issuer Certificate issuer
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of UploadCertificateResponse
   *
   * @returns {object} metadata of UploadCertificateResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UploadCertificateResponse',
      type: {
        name: 'Composite',
        className: 'UploadCertificateResponse',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          authType: {
            required: false,
            serializedName: 'properties.authType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'AccessControlService', 'AzureActiveDirectory' ]
            }
          },
          certificate: {
            required: true,
            serializedName: 'properties.certificate',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: true,
            serializedName: 'properties.resourceId',
            type: {
              name: 'Number'
            }
          },
          aadAuthority: {
            required: true,
            serializedName: 'properties.aadAuthority',
            type: {
              name: 'String'
            }
          },
          aadTenantId: {
            required: true,
            serializedName: 'properties.aadTenantId',
            type: {
              name: 'String'
            }
          },
          servicePrincipalClientId: {
            required: true,
            serializedName: 'properties.servicePrincipalClientId',
            type: {
              name: 'String'
            }
          },
          servicePrincipalObjectId: {
            required: true,
            serializedName: 'properties.servicePrincipalObjectId',
            type: {
              name: 'String'
            }
          },
          azureManagementEndpointAudience: {
            required: true,
            serializedName: 'properties.azureManagementEndpointAudience',
            type: {
              name: 'String'
            }
          },
          subject: {
            required: true,
            serializedName: 'properties.subject',
            type: {
              name: 'String'
            }
          },
          validFrom: {
            required: true,
            serializedName: 'properties.validFrom',
            type: {
              name: 'DateTime'
            }
          },
          validTo: {
            required: true,
            serializedName: 'properties.validTo',
            type: {
              name: 'DateTime'
            }
          },
          thumbprint: {
            required: true,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: true,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          },
          issuer: {
            required: true,
            serializedName: 'properties.issuer',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UploadCertificateResponse;
