/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters used when creating a server endpoint.
 *
 * @extends models['ProxyResource']
 */
class ServerEndpointCreateParameters extends models['ProxyResource'] {
  /**
   * Create a ServerEndpointCreateParameters.
   * @property {string} [serverLocalPath] Server Local path.
   * @property {string} [cloudTiering] Cloud Tiering. Possible values include:
   * 'on', 'off'
   * @property {number} [volumeFreeSpacePercent] Level of free space to be
   * maintained by Cloud Tiering if it is enabled.
   * @property {number} [tierFilesOlderThanDays] Tier files older than days.
   * @property {string} [friendlyName] Friendly Name
   * @property {string} [serverResourceId] Server Resource Id.
   * @property {string} [offlineDataTransfer] Offline data transfer. Possible
   * values include: 'on', 'off'
   * @property {string} [offlineDataTransferShareName] Offline data transfer
   * share name
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerEndpointCreateParameters
   *
   * @returns {object} metadata of ServerEndpointCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerEndpointCreateParameters',
      type: {
        name: 'Composite',
        className: 'ServerEndpointCreateParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          serverLocalPath: {
            required: false,
            serializedName: 'properties.serverLocalPath',
            type: {
              name: 'String'
            }
          },
          cloudTiering: {
            required: false,
            serializedName: 'properties.cloudTiering',
            type: {
              name: 'String'
            }
          },
          volumeFreeSpacePercent: {
            required: false,
            serializedName: 'properties.volumeFreeSpacePercent',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          tierFilesOlderThanDays: {
            required: false,
            serializedName: 'properties.tierFilesOlderThanDays',
            constraints: {
              InclusiveMaximum: 2147483647,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          },
          serverResourceId: {
            required: false,
            serializedName: 'properties.serverResourceId',
            type: {
              name: 'String'
            }
          },
          offlineDataTransfer: {
            required: false,
            serializedName: 'properties.offlineDataTransfer',
            type: {
              name: 'String'
            }
          },
          offlineDataTransferShareName: {
            required: false,
            serializedName: 'properties.offlineDataTransferShareName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerEndpointCreateParameters;
