/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters for updating an Server Endpoint.
 *
 */
class ServerEndpointUpdateParameters {
  /**
   * Create a ServerEndpointUpdateParameters.
   * @property {string} [cloudTiering] Cloud Tiering. Possible values include:
   * 'on', 'off'
   * @property {number} [volumeFreeSpacePercent] Level of free space to be
   * maintained by Cloud Tiering if it is enabled.
   * @property {number} [tierFilesOlderThanDays] Tier files older than days.
   * @property {string} [offlineDataTransfer] Offline data transfer. Possible
   * values include: 'on', 'off'
   * @property {string} [offlineDataTransferShareName] Offline data transfer
   * share name
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServerEndpointUpdateParameters
   *
   * @returns {object} metadata of ServerEndpointUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerEndpointUpdateParameters',
      type: {
        name: 'Composite',
        className: 'ServerEndpointUpdateParameters',
        modelProperties: {
          cloudTiering: {
            required: false,
            serializedName: 'properties.cloudTiering',
            type: {
              name: 'String'
            }
          },
          volumeFreeSpacePercent: {
            required: false,
            serializedName: 'properties.volumeFreeSpacePercent',
            constraints: {
              InclusiveMaximum: 100,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          tierFilesOlderThanDays: {
            required: false,
            serializedName: 'properties.tierFilesOlderThanDays',
            constraints: {
              InclusiveMaximum: 2147483647,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          offlineDataTransfer: {
            required: false,
            serializedName: 'properties.offlineDataTransfer',
            type: {
              name: 'String'
            }
          },
          offlineDataTransferShareName: {
            required: false,
            serializedName: 'properties.offlineDataTransferShareName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerEndpointUpdateParameters;
