/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters used when creating a storage sync service.
 *
 */
class StorageSyncServiceCreateParameters {
  /**
   * Create a StorageSyncServiceCreateParameters.
   * @property {string} location Required. Gets or sets the location of the
   * resource. This will be one of the supported and registered Azure Geo
   * Regions (e.g. West US, East US, Southeast Asia, etc.). The geo region of a
   * resource cannot be changed once it is created, but if an identical geo
   * region is specified on update, the request will succeed.
   * @property {object} [tags] Gets or sets a list of key value pairs that
   * describe the resource. These tags can be used for viewing and grouping
   * this resource (across resource groups). A maximum of 15 tags can be
   * provided for a resource. Each tag must have a key with a length no greater
   * than 128 characters and a value with a length no greater than 256
   * characters.
   * @property {object} [properties]
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageSyncServiceCreateParameters
   *
   * @returns {object} metadata of StorageSyncServiceCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageSyncServiceCreateParameters',
      type: {
        name: 'Composite',
        className: 'StorageSyncServiceCreateParameters',
        modelProperties: {
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageSyncServiceCreateParameters;
