/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Sync Session status object.
 *
 */
class SyncActivityStatus {
  /**
   * Create a SyncActivityStatus.
   * @property {date} [timestamp] Timestamp when properties were updated
   * @property {number} [perItemErrorCount] Per item error count
   * @property {number} [appliedItemCount] Applied item count.
   * @property {number} [totalItemCount] Total item count (if available)
   * @property {number} [appliedBytes] Applied bytes
   * @property {number} [totalBytes] Total bytes (if available)
   */
  constructor() {
  }

  /**
   * Defines the metadata of SyncActivityStatus
   *
   * @returns {object} metadata of SyncActivityStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncActivityStatus',
      type: {
        name: 'Composite',
        className: 'SyncActivityStatus',
        modelProperties: {
          timestamp: {
            required: false,
            readOnly: true,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          perItemErrorCount: {
            required: false,
            readOnly: true,
            serializedName: 'perItemErrorCount',
            type: {
              name: 'Number'
            }
          },
          appliedItemCount: {
            required: false,
            readOnly: true,
            serializedName: 'appliedItemCount',
            type: {
              name: 'Number'
            }
          },
          totalItemCount: {
            required: false,
            readOnly: true,
            serializedName: 'totalItemCount',
            type: {
              name: 'Number'
            }
          },
          appliedBytes: {
            required: false,
            readOnly: true,
            serializedName: 'appliedBytes',
            type: {
              name: 'Number'
            }
          },
          totalBytes: {
            required: false,
            readOnly: true,
            serializedName: 'totalBytes',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncActivityStatus;
