/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object that contains the details about an environment's state.
 *
 */
class EnvironmentStateDetails {
  /**
   * Create a EnvironmentStateDetails.
   * @member {string} [code] Contains the code that represents the reason of an
   * environment being in a particular state. Can be used to programatically
   * handle specific cases.
   * @member {string} [message] A message that describes the state in detail.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnvironmentStateDetails
   *
   * @returns {object} metadata of EnvironmentStateDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentStateDetails',
      type: {
        name: 'Composite',
        className: 'EnvironmentStateDetails',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentStateDetails;
