/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines an image region relevant to the ImageTag.
 *
 */
class ImageTagRegion {
  /**
   * Create a ImageTagRegion.
   * @property {object} queryRectangle A rectangle that outlines the area of
   * interest for this tag.
   * @property {object} [queryRectangle.topLeft] The top left corner
   * coordinate.
   * @property {number} [queryRectangle.topLeft.x] The x-coordinate of the
   * point.
   * @property {number} [queryRectangle.topLeft.y] The y-coordinate of the
   * point.
   * @property {object} [queryRectangle.topRight] The top right corner
   * coordinate.
   * @property {number} [queryRectangle.topRight.x] The x-coordinate of the
   * point.
   * @property {number} [queryRectangle.topRight.y] The y-coordinate of the
   * point.
   * @property {object} [queryRectangle.bottomRight] The bottom right corner
   * coordinate.
   * @property {number} [queryRectangle.bottomRight.x] The x-coordinate of the
   * point.
   * @property {number} [queryRectangle.bottomRight.y] The y-coordinate of the
   * point.
   * @property {object} [queryRectangle.bottomLeft] The bottom left corner
   * coordinate.
   * @property {number} [queryRectangle.bottomLeft.x] The x-coordinate of the
   * point.
   * @property {number} [queryRectangle.bottomLeft.y] The y-coordinate of the
   * point.
   * @property {object} displayRectangle A recommended rectangle to show to the
   * user.
   * @property {object} [displayRectangle.topLeft] The top left corner
   * coordinate.
   * @property {number} [displayRectangle.topLeft.x] The x-coordinate of the
   * point.
   * @property {number} [displayRectangle.topLeft.y] The y-coordinate of the
   * point.
   * @property {object} [displayRectangle.topRight] The top right corner
   * coordinate.
   * @property {number} [displayRectangle.topRight.x] The x-coordinate of the
   * point.
   * @property {number} [displayRectangle.topRight.y] The y-coordinate of the
   * point.
   * @property {object} [displayRectangle.bottomRight] The bottom right corner
   * coordinate.
   * @property {number} [displayRectangle.bottomRight.x] The x-coordinate of
   * the point.
   * @property {number} [displayRectangle.bottomRight.y] The y-coordinate of
   * the point.
   * @property {object} [displayRectangle.bottomLeft] The bottom left corner
   * coordinate.
   * @property {number} [displayRectangle.bottomLeft.x] The x-coordinate of the
   * point.
   * @property {number} [displayRectangle.bottomLeft.y] The y-coordinate of the
   * point.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageTagRegion
   *
   * @returns {object} metadata of ImageTagRegion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageTagRegion',
      type: {
        name: 'Composite',
        className: 'ImageTagRegion',
        modelProperties: {
          queryRectangle: {
            required: true,
            serializedName: 'queryRectangle',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'NormalizedQuadrilateral'
            }
          },
          displayRectangle: {
            required: true,
            serializedName: 'displayRectangle',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'NormalizedQuadrilateral'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageTagRegion;
