/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a region of an image. The region is a convex quadrilateral defined
 * by coordinates of its top left, top right, bottom left, and bottom right
 * points. The coordinates are fractional values of the original image's width
 * and height in the range 0.0 through 1.0.
 *
 * @extends models['StructuredValue']
 */
class NormalizedQuadrilateral extends models['StructuredValue'] {
  /**
   * Create a NormalizedQuadrilateral.
   * @property {object} topLeft The top left corner coordinate.
   * @property {number} [topLeft.x] The x-coordinate of the point.
   * @property {number} [topLeft.y] The y-coordinate of the point.
   * @property {object} topRight The top right corner coordinate.
   * @property {number} [topRight.x] The x-coordinate of the point.
   * @property {number} [topRight.y] The y-coordinate of the point.
   * @property {object} bottomRight The bottom right corner coordinate.
   * @property {number} [bottomRight.x] The x-coordinate of the point.
   * @property {number} [bottomRight.y] The y-coordinate of the point.
   * @property {object} bottomLeft The bottom left corner coordinate.
   * @property {number} [bottomLeft.x] The x-coordinate of the point.
   * @property {number} [bottomLeft.y] The y-coordinate of the point.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NormalizedQuadrilateral
   *
   * @returns {object} metadata of NormalizedQuadrilateral
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NormalizedQuadrilateral',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'NormalizedQuadrilateral',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          readLink: {
            required: false,
            readOnly: true,
            serializedName: 'readLink',
            type: {
              name: 'String'
            }
          },
          webSearchUrl: {
            required: false,
            readOnly: true,
            serializedName: 'webSearchUrl',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          image: {
            required: false,
            readOnly: true,
            serializedName: 'image',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'ImageObject'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          alternateName: {
            required: false,
            readOnly: true,
            serializedName: 'alternateName',
            type: {
              name: 'String'
            }
          },
          bingId: {
            required: false,
            readOnly: true,
            serializedName: 'bingId',
            type: {
              name: 'String'
            }
          },
          topLeft: {
            required: true,
            serializedName: 'topLeft',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'Point2D'
            }
          },
          topRight: {
            required: true,
            serializedName: 'topRight',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'Point2D'
            }
          },
          bottomRight: {
            required: true,
            serializedName: 'bottomRight',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'Point2D'
            }
          },
          bottomLeft: {
            required: true,
            serializedName: 'bottomLeft',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'Point2D'
            }
          }
        }
      }
    };
  }
}

module.exports = NormalizedQuadrilateral;
